
	

;s0	r0  A
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag
	


vm_syscalls: .dw DummySyscall	;0 - ChipExt
			 .dw DummySyscall	;1 - VMControl
			 .dw DummySyscall	;2 - VMMonitor
			 .dw AdventureCall	;3
			 .dw DummySyscall ;4 - ChibiSoundCall
			 
			 .ifdef DoMaxTileCall
			 	.dw DoMaxTileCall ;5 - MaxTileCall  
			 .else
				.dw DummySyscall ;5 - MaxTileCall  
			 .endif 
			
			 .dw DummySyscall ;6 - QTVCall
			 .ifdef NativeSpriteCall
				.dw NativeSpriteCall ;7 - NSCall
			 .else 
				.dw DummySyscall ;7 - NSCall
			.endif
			 .dw DummySyscall ;8 - LoadMultiReg
			 .ifdef MBCall
				.dw MBCall ;7 - NSCall
			 .else 
				.dw DummySyscall ;7 - NSCall
			.endif
	;dw ChipEXT			;0
	;dw VMControl		;1
	;dw VMMonitor		;2
	;dw AdventureCall	;3
	;dw ChibiSoundCall	;4
	;dw MaxTileCall		;5
	;dw QTVCall			;6
	;dw NSCall			;7
	;dw LoadMultiReg		;8
	
syscallAdventure equ 3		
syscallNativeSprite equ 7
syscallMB equ 9			;Multiplatform Bitmap
	
DummySyscall:
	;mov pc,lr
	
	.macro AdvCall,p1		
		.db SYSi,syscallAdventure
		.db p1
	.endmacro

	.macro NsCall,p1		
		.db SYSi,syscallNativeSprite
		.db p1
	.endmacro
		
		
	
	.macro MaxTileCall,p1		
		.db SYSi,syscallNativeSprite
		.db p1
	.endmacro
			
	.Macro MBcall,p1
		.db SYSi,syscallMB
		.db p1
	.endmacro
	
regRR equ 0
regNO equ 0

aPrintChar equ 0
aPrintSeq equ 1
aPrintNumber equ 2
aPrintSeqNC equ 3
aPrintSeqNL equ 4
aShowDecimal equ 5
aNewLine equ 6
acls equ 7
aFillArea equ 8
aWaitForFire equ 9
aJoyAxis equ 10
aPause50 equ 11
aPauseA equ 12
aDivideAbyH equ 13
aRangedRandom equ 14
aRangeLimit equ 15
aRangeTest equ 16
aDoRandom equ 17
aChibiSoundBeep equ 18
aChibiSound equ 19
aDoLdir equ 20
aDoLddr equ 21
aSlowDown equ 22
aReadJoystick equ 23
aWaitForRelease equ 24
aLastCommand equ 25
	
	
vecAdventureCall:	
	.dw PrintChar
	.dw PrintSeqADV
	.dw PrintNumber
	.dw PrintSeqNC
	.dw PrintSeqNL
	.dw ShowDecimal
	.dw NewLine
	.dw cls
	.dw FillArea
	.dw WaitForFire
	.dw JoyAxis
	.dw Pause50
	.dw PauseA
	.dw DivideAbyH
	.dw RangedRandom
	.dw RangeLimit
	.dw RangeTest
	.dw DoRandom
	.dw ChibiSoundBeep
	.dw ChibiSound
	.dw DoLdir
	.dw DoLddr
	.dw SlowDown
	.dw ReadJoystick
	.dw WaitForRelease


AdventureCall:	 ;Return address is on stack!

		la t7,vecAdventureCall
		;move.l #vecAdventureCall,a6
ChibiVM_VectorCall:	 	
	;STMFD sp!,{lr}
		
	
		la a0,vm_rambaseAddr
		lw s7,(a0)			;Get Base of VM Ram
		lw a0,(a0)			;Get Base of VM Ram
		loadLEA0 vm_rpc,s7		;Load Little endian A3 from A0
								;(Program Counter)
		
		
		
		lbu s0,0(s7)	;Get the command byte
		addi s7,s7,1
	
		storeLEa0 s7,vm_rpc
		
		move t0,s0
		sll t0,t0,2		;4 bytes per address
		add t0,t0,t7
		
			
		lw t7,(t0)		;Get the final address
		
		
		
		lbu s0,VM_rR0(a0)
		
		
		lbu s1,VM_rR3(a0)
		lbu s4,VM_rR2(a0)
		sll t0,s1,8
		or s4,s4,t0
		
		
		lbu s2,VM_rR5(a0)
		lbu s5,VM_rR4(a0)
		sll t0,s2,8
		or s5,s5,t0
		
		
		;ldrb r2,[r10,#VM_rR5]
		;ldrb r5,[r10,#VM_rR4]
		;orr r5,r5,r2,lsl #8
		
		
		lbu s3,VM_rR7(a0)
		lbu s6,VM_rR6(a0)
		sll t0,s3,8
		or s6,s6,t0
		
		
		;ldrb r3,[r10,#VM_rR7]
		;ldrb r6,[r10,#VM_rR6]
		;orr r6,r6,r3,lsl #8
		
		
		la t6,Mask16bitInv
		lw t6,(t6)
		nop
		and t6,t6,a0	;Patch in top 16 bits of 32 bit address
		
		add s4,s4,t6
		add s5,s5,t6
		add s6,s6,t6
		
		
		li t8,0			;Return Key
		
		la ra,ChibiVM_VectorCall_Return
			
		jr t7				;Call the sub
		nop
		
ChibiVM_VectorCall_Return:	

		la t6,ReturnKey
		lw t6,(t6)		;t8=#$66660006 ?
		nop
		;cmp r11,r9
		beq t6,t8,AdventureCall_CustomSave	;Allow override for all regs
		nop 
		
		la a0,vm_rambaseAddr
		lw a0,(a0)			;Get Base of VM Ram
		;move.l (VM_RamBaseAddr),a0
		nop
		sb s0,VM_rR0(a0)
		
		;Note: ChibiAdventure was designed for the Z80, so registers mimic A BC DE HL
		;move.b d0,(VM_rR0,a0)	;Accumulator is always 8 bits... R1 doesn't exist on Z80
		
		la t6,ReturnKey2
		lw t6,(t6)		;#$66660000
		nop
		
		beq t6,t8,AdventureCall_CustomSave	;Allow override for A3/A2/A1 or 16 bit D1/D2/D3
		nop
		
		
		
		;Store 8 bit regs back to VM
		
		sb s3,VM_rR7(a0)
		sb s6,VM_rR6(a0)
		sb s2,VM_rR5(a0)
		sb s5,VM_rR4(a0)
		sb s1,VM_rR3(a0)
		sb s4,VM_rR2(a0)
		
AdventureCall_CustomSave:	
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	

ReturnKey:	.dw 0x66660006
ReturnKey2:	.dw 0x66660000

PrintSeqADV:
	;STMFD sp!,{lr}
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

	
		move s3,s6			;16 bit val into r3
		
		jal PrintSeq
		nop
		
		la a0,vm_rambaseAddr
		lw a0,(a0)			;Get Base of VM Ram
		
		
		jal VM_SaveA3
		nop
		
		sb s2,VM_rR5(a0)
		sb s5,VM_rR4(a0)
		sb s1,VM_rR3(a0)
		sb s4,VM_rR2(a0)
		
		la t8,ReturnKey2
		lw t8,(t8)		;#$66660000
		
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	;LDMFD sp!,{pc}
		;move.l #$66660000,d7			;We needto restore A3
		;rts
		
VM_SaveA3:
		sub s3,s3,a0
		move t7,s3
		sb t7,VM_rR6(a0)	;HL (Address)
		srl t7,t7,8
		
		sb t7,VM_rR7(a0)
	;mov pc,lr
	jr ra				;Return
	nop
	
VM_SaveA6R10:	
	la a0,vm_rambaseAddr
	lw a0,(a0)			;Get Base of VM Ram
	nop
VM_SaveA6:
		sub s6,s6,a0
		move t7,s6
		sb t7,VM_rR6(a0)	;HL (Address)
		srl t7,t7,8
		sb t7,VM_rR7(a0)
	;mov pc,lr
	jr ra				;Return
	nop
	
	
	

AddressRemapViaTableR6:
	la t0,Mask16bit
	lw t0,(t0)
	nop
	and s0,t0,s6
	
	
	
AddressRemapViaTableR6b:
	li t1,0x200
	;cmp	r0,#0x200		;first 511 bytes of VM ram for 32 bit remaps
	bge s0,t1,AddressRemapViaTableHL_Done
	nop
	
;.ifdef vm_remap_TableAddr
		la a3,vm_rambaseAddr
		lw a3,(a3)			;Get Base of VM Ram
		
		la t1,vm_remap_TableAddr
		lw t1,(t1)			;Get Base of VM Ram
		nop
		
		; jal monitor
		; nop
; i:		
		; j i
		; nop
		
		add a3,a3,t1
; .endif
; .ifndef vm_remap_TableAddr
		 ;la a3,vm_AddressRemapTable
; .endif 
	
	sll s0,s0,2;*4 bytes per entry
	add a3,a3,s0
	lw s6,(a3)
	
	
	
	;ldr r6,[r9,r0,lsl #2] ;*4 bytes per entry
	;mov pc,lr
	
	jr ra				;Return
	nop
	
	
AddressRemapViaTableHL_Done:
	;cmp r10,r6	;>16 bit?
	
	bgtu s6,t0,AddressRemapViaTableHL_Done2
	
	la t0,vm_rambaseAddr
	lw t0,(t0)			;Get Base of VM Ram
	nop
	add s6,s6,t0
		
	
AddressRemapViaTableHL_Done2:	
	
	jr ra				;Return
	nop
	