VscreenMinX equ 64		;Top left of visible screen in logical co-ordinates
VscreenMinY equ 80
VscreenWid equ 128		;Visible Screen Size in logical units
VscreenHei equ 96

tempbuffer equ ramarea+128


BackgroundTilemapScrollX equ ramarea+64
BackgroundTilemapScrollY equ BackgroundTilemapScrollX+4
backgroundtilemapbase equ BackgroundTilemapScrollY+4

BackgroundTilemapWidthV equ 36 ;Tilemap width in words

;doublebuffered:

;s0	r0  A				
;s1	r1  B BC 
;s2 ,vr2  D DE
;s3 r3  H HL
;s4	,vr4  C
;s5	r5  E
;s6 ,vr6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

vm_remap_TableAddr equ vm_rambaseAddr+0xFFF0



	.include "Header.asm"


	.include "\SrcAll\BasicMacros.asm"
  
  
	.include "\srcALL\ChibiVm_InstSet.asm"
	
 
	
VM_ProgLoadAddr equ 0x400	

	
	la s0,MaxTileTest
	la s1,backgroundtilemapbase
	sw s0,(s1)

	li s1,4
	li s4,10
	li s2,8;32
	li s5,6;24
	
	li s6,0x0011
	
	jal MaxTileFillArea
	nop

	
	li s1,20
	li s4,10
	li s2,4;32
	li s5,4;24
	
	la s6,DrawAreaTest
	
	jal MaxTileDrawArea
	nop
	
	li s1,6
	li s4,6
	la s6,PrintTest
	li s5,0x0101
	jal MaxTilePrint
	nop
	
	; la a0,vm_rambaseAddr		;Address
	; lw a0,(a0)
	
	
	
	jal MaxTileRedraw
	nop

; i:	
	; j i
	; nop
	; li s0,0x0200				;Stack
	; StoreLEA0 s0,vm_rsp
	
	; li s0,0x0000
	; StoreLEA0 s0,vm_rBank0
	; li s0,0x4000
	; StoreLEA0 s0,vm_rBank1
	; li s0,0x8000
	; StoreLEA0 s0,vm_rBank2
	; li s0,0xC000
	; StoreLEA0 s0,vm_rBank3
	
;Copy our program to VM Ram
	; la a0,vm_rambaseAddr		;Address
	; lw s2,(a0)
	; lw a0,(a0)
	
	; la s3,VM_Program_Zero
	; li s1,VM_Program_End-VM_Program_Zero
	
	
MTLoop:	
	
	la s1,BackgroundTilemapScrollX
	lbu s4,(s1)
	nop
	addi s4,s4,1
	;sb s4,(s1)
	
	la s3,backgroundTilemapScrollY
	lbu s5,(s3)
	nop
	addi s5,s5,1
	;sb s5,(s3)
	
	li s0,0
	jal MaxTileSetScroll
	nop
	
	
	
	li s1,0
	li s4,0
	li s2,32
	li s5,24
	
	jal MaxTileFlagForRedraw ;d1,d4 = XY d2,d5=wh 
	nop
	
	jal MaxTileRedraw
	nop
	jal MaxTileClearBorder
	nop
	
	;li s2,0
	;li s5,0
	;jal monitor
	nop
	
	li s0,0x400000
	
MTDelay:
	addi s0,s0,-1
	bne s0,zero,MTDelay
	nop
	
	b MTLoop
	nop
	
; ProgramCopyAgain2:	
	; lbu s0,(s3)
	; addi s3,s3,1
	; sb s0,(s2)
	; addi s2,s2,1
	
	; addi s1,s1,-1
	; bne s1,zero,ProgramCopyAgain2
	; nop 
	
	
	;li s0,0x0800				;Prog Start
	;StoreLEA0 s0,vm_rpc
	
	jal ChibiVM_Init
	nop
	
	
	li s1,100
ProgSkip:
	;jal VM_Tick
	; nop
	
	; addi s1,s1,-1
	; bne s1,zero,ProgSkip
	; nop
	
InfLoop:
	 jal VM_Tick
	 nop
		

	 j InfLoop					;Halt
	 nop

;Debugger
	


	li s2,0	;Xpos
	li s5,0	;Ypos

	la a2,vm_rambaseAddr	;Address
	lw a2,(a2)
	li a1,6	;Lines
	
	jal MemDump				;Dump to screen
	nop
	
	
	
	la a0,vm_rambaseAddr	;Address
	lw a2,(a0)
	nop
	addi a2,a2,0x0200		;Stack
	addi a2,a2,-12

	li a1,2				;Lines
	jal MemDump				;Dump to screen
	nop
	
	la a0,vm_rambaseAddr		;Address
	lw a2,(a0)
	lw a0,(a0)
	LoadLEA0 vm_rpc,a2
	li a1,3				;Lines
	jal MemDump				;Dump to screen
	nop
	
	
	la a2,vm_rambaseAddr	;Address
	lw a2,(a2)
	nop
	addi a2,a2,64+16
	li a1,4	;Lines
	
	jal MemDump				;Dump to screen
	nop
	
	
	
	;jal Monitor
	;nop
	
	jal VM_Tick
	nop
	
	;jal ReadJoystick
	;nop
	;li s2,0
	;li s5,10
	;jal Monitor			;Reg Dump
	;nop
	
	
	jal WaitForFire
	nop


   j InfLoop					;Halt
	nop
vm_rambaseAddr: .dw (ramarea+65536)


;vm_syscalls:
	;.dw VM_Program
	;.dw TestSysCall1
	
TestSysCall1:
	li s0,0xE4
	la a0,vm_rambaseAddr
	lw a0,(a0)
	nop
	sb s0,VM_rR1(a0)
	
	
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
vm_trap_TableAddr: .dw  ramarea+65536+0x0A46


	
	
	.include "\srcALL\ChibiVm_CPU.asm"
	;.include "\srcALL\test.asm"
;vm_trap_tableaddr: .dw 0
;vm_syscalls:	.dw 0
	
	
	
	.include "\SrcALL\V1_MaxTile.asm"

	
	
;vm_rambaseaddr:	.dw ramarea+0x10000	
	.include "\SrcALL\V1_MultiplatformBitmap.asm"

	.ifdef BuildN64
		.include "\SrcN64\N64_V1_MultiplatformBitmap.asm"	;MUST come before Adventure Engine!
	.endif
	
	.ifdef BuildPSX
		.include "\SrcPSX\PSX_V1_MultiplatformBitmap.asm"	;MUST come before Adventure Engine!
	.endif

	.include "ChibiVM_AdventureEngine.asm"
	
	
	
	.include "ChibiVM_Host.asm"
	.align 4	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.include "core.asm"
	.include "monitor.asm"  	

; .macro advcall,p1
	; .db p1
	; .db p1/256
; .endmacro 	

	.align 65536
VM_Program_Zero:
	.fill 0x400		
VM_Program:	
	.db "!!!!Chibi/VM!!!!"			;Magic key - must be on a $xxxxxx00 boundary
	.db "Your product name here          "		;Software Name - 32 bytes

	;rorg $10000+VM_ProgLoadAddr+$30
	.db 0			;Header Version
	.db 0b00000011	; config {COpy Vectors to $100}
	.db 0b00111111	;Requirements {adv} {reikou} {maxtile} {QTV} {NS} {memmapper} {ChibiTracks}
	.db 0			;Spare
	.db 0			;Spare
	.db 0			;Cpu Requirements
	.db 0			;Ram Requirements
	.db 0 			;Vector Requorements {Vblank}
	.db 0 			;SysCall Requirements {VmMonitor}{VmControl}{ChipExt}
	.db 0 			;SysCall Requirements
	.db 0			;ChipExt Requirements ???
	.db 0			;ChipExt Requirements ???
	.db 0x11		;Bitmap Modes 0-7 {NS / Maxtile} 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.db 0x01		;Bitmap Modes 0-7 {AdvFont / QTV } 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.db 0			;Bitmap modes (spare)
	.db 0			;Bitmap modes (spare)
	
	;rorg $10000+VM_ProgLoadAddr+$40
	dl 0x400		;Rom Load Address
	dl 0x200		;StackPointer
	dl 0x100		;Trap table Ram address (0=none)
	dl 0x0000		;Memmap 1
	dl 0x4000		;Memmap 2
	dl 0x8000		;Memmap 3
	dl 0xC000		;Memmap 4

	.db 0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;rorg $10000+VM_ProgLoadAddr+$70
	dl (vm_traps-VM_Program)	;Vector table (0=none)
	dl 0x2000		;Address remap table (0=none)
	dl 0			;VMAssets (Palette,Font etc)
	dl 0			;???

VM_Program_Hend:

	.fill 0x800	-(VM_Program_Hend-VM_Program_Zero)	;Program load address

ProgramLaunch:
		dbbb movx,r3_imm8,191
;                                     testagain:    
testagain:
;                                         ld a,b
	dbb movx,r0_r3
	db asrb
	db asrb
	db asrb
	dbb vandi,0b00001111
;                                         ld d,b
	dbbb movx,zeropg_r3,vr5
	
;                                         ld e,b
	dbb movx,r4_r3
;                                         ld l,0                ;ld = xpos e=ypos
	dbbb movx,r6_imm8,0
	
	
	
;                                         push bc
	;db ph2b
;                                             call mpbitmap_setpixel
	;dbw bsrj,mpbitmap_setpixel
	MBcall mbSetpixel					;Diagonal line
;                                         pop bc
	;db pl2b
;                                         

;                                         

;                                         

;                                         ld a,b
	dbb movx,r0_r3
	db asrb
	db asrb
	db asrb
	dbb vandi,0b00001111
;                                         ld d,b
	dbbb movx,zeropg_r3,vr5
;                                         ld e,b
	dbb movx,r4_r3
    dbb lsrz,vr4
    dbb lsrz,vr4
    dbb lsrz,vr4
	dbbb movx,r6_imm8,0

;	db ph2b
;                                             call mpbitmap_setpixel
	;dbw bsrj,mpbitmap_setpixel
	MBcall mbSetpixel
;                                         pop bc
	;db pl2b
;                                         

;                                         ld d,b
	dbbb movx,zeropg_r3,vr5
;                                         ld e,b
	dbb movx,r4_r3
;                                         ld l,0
	dbbb movx,r6_imm8,0
;                                         

;                                         push bc
	;db ph2b
;                                             call mpbitmap_getpixel
	dbb movi,1
	;dbw bsrj,mpbitmap_getpixel
	MBcall mbGetpixel
;                                         pop bc
	;db pl2b
;                                         inc a
	db incb
;                                         ld d,b
	dbbb movx,zeropg_r3,vr5
	dbb incz,vr5
	dbb incz,vr5
	dbb incz,vr5
	dbb movx,r4_r3
	dbbb movx,r6_imm8,0
;                                         push bc
	;db ph2b
;                                             call mpbitmap_setpixel
	;dbw bsrj,mpbitmap_setpixel
	MBcall mbSetpixel
;                                         pop bc
	;db pl2b
;                                         

;                                         

;                                         djnz testagain
	dbb decz,vr3
	dbw bnej,testagain

	
TileTest:	
	
	dbbw mov16x,r6_imm16,bitmap2bitplane
;                                         ld de,&0010
	dbbw mov16x,r4_imm16,0x0010
;                                             

;                                         ld c,6
	dbbb movx,r2_imm8,6
;                                     tiletestagainy3:    
tiletestagainy3:
;                                         ld b,6
	dbbb movx,r3_imm8,6
;                                     tiletestagainx3:    
tiletestagainx3:
;                                         ld a,2
	dbb movi,2
;                                         push bc
	db ph2b
;                                         push de
	db ph4b
;                                             call mpbitmap_settile
	;dbw bsrj,mpbitmap_settile
	MBcall mbSettile
;                                         pop de
	db pl4b
;                                         inc d
	dbb incz,vr5
;                                         pop bc
	db pl2b
;                                         djnz tiletestagainx3
	dbb decz,vr3
	dbw bnej,tiletestagainx3
;                                         ld d,0
	dbbbb movx,zeropg_imm8,vr5,0
;                                         inc e
	dbb incz,vr4
;                                         dec c
	dbb decz,vr2
;                                         jr nz,tiletestagainy3
	dbb bnei,tiletestagainy3-lbl_1CD7xD783
lbl_1CD7xD783:
;                                         

;                                         

;                                         ld hl,bitmap4bitplane
	dbbw mov16x,r6_imm16,bitmap4bitplane
;                                         ld de,&0008
	dbbw mov16x,r4_imm16,0x0008
;                                             

;                                         ld c,6
	dbbb movx,r2_imm8,6
;                                     tiletestagainy:    
tiletestagainy:
;                                         ld b,6
	dbbb movx,r3_imm8,6
;                                     tiletestagainx:    
tiletestagainx:
;                                         ld a,4
	dbb movi,4
;                                         push bc
	db ph2b
;                                         push de
	db ph4b
;                                             call mpbitmap_settile
	;dbw bsrj,mpbitmap_settile
	MBcall mbSettile
;                                         pop de
	db pl4b
;                                         inc d
	dbb incz,vr5
;                                         pop bc
	db pl2b
;                                         djnz tiletestagainx
	dbb decz,vr3
	dbw bnej,tiletestagainx
;                                         ld d,0
	dbbbb movx,zeropg_imm8,vr5,0
;                                         inc e
	dbb incz,vr4
;                                         dec c
	dbb decz,vr2
;                                         jr nz,tiletestagainy
	dbb bnei,tiletestagainy-lbl_9803x75B7
lbl_9803x75B7:
;                                         

;                                         

;                                         ld de,&0008
	dbbw mov16x,r4_imm16,0x0008
;                                         ld c,6
	dbbb movx,r2_imm8,6
;                                     tiletestagainy2:    
tiletestagainy2:
;                                         ld b,6
	dbbb movx,r3_imm8,6
;                                     tiletestagainx2:    
tiletestagainx2:
;                                         

;                                         push bc
	db ph2b
;                                         push de
	db ph4b
;                                             push de
	db ph4b
;                                                 ld hl,tempbuffer
	dbbw mov16x,r6_imm16,tempbuffer
;                                                 ld a,1
	dbb movi,1
	MBcall mbGettile
;                                             pop de
	db pl4b
;                                             ld hl,tempbuffer
	dbbw mov16x,r6_imm16,tempbuffer
;                                             ld a,d
	dbbb movx,r0_zeropg,vr5
;                                             add 24
	dbb vaddi,12
;                                             ld d,a
	dbbb movx,zeropg_r0,vr5
;                                             

;                                             

;                                             ld a,1
	dbb movi,1
	MBcall mbSettile
;                                         pop de
	db pl4b
;                                         inc d
	dbb incz,vr5
;                                         pop bc
	db pl2b
;                                         djnz tiletestagainx2
	dbb decz,vr3
	dbw bnej,tiletestagainx2
;                                         ld d,0
	dbbbb movx,zeropg_imm8,vr5,0
;                                         inc e
	dbb incz,vr4
;                                         dec c
	dbb decz,vr2
;                                         jr nz,tiletestagainy2
	dbb bnei,tiletestagainy2-lbl_7409xD7E8
lbl_7409xD7E8:
;                                         

;                                     


	.align 4
n64_maxtile_solidfills:
N64_Palette:	
   .dh 0b0000000000000000  ; ;0  %RRRRRGGGGGBBBBB-
   .dh 0b1000000000000000  ; ;1  %RRRRRGGGGGBBBBB-
   .dh 0b0000010000000000  ; ;2  %RRRRRGGGGGBBBBB-
   .dh 0b1000010000000000  ; ;3  %RRRRRGGGGGBBBBB-
   .dh 0b0000000000100000  ; ;4  %RRRRRGGGGGBBBBB-
   .dh 0b1000000000100000  ; ;5  %RRRRRGGGGGBBBBB-
   .dh 0b0000010000100000  ; ;6  %RRRRRGGGGGBBBBB-
   .dh 0b1100011000110000  ; ;7  %RRRRRGGGGGBBBBB-
   .dh 0b1000010000100000  ; ;8  %RRRRRGGGGGBBBBB-
   .dh 0b1111100000000000  ; ;9  %RRRRRGGGGGBBBBB-
   .dh 0b0000011111000000  ; ;10  %RRRRRGGGGGBBBBB-
   .dh 0b1111111111000000  ; ;11  %RRRRRGGGGGBBBBB-
   .dh 0b0000000000111110  ; ;12  %RRRRRGGGGGBBBBB-
   .dh 0b1111100000111110  ; ;13  %RRRRRGGGGGBBBBB-
   .dh 0b0000011111111110  ; ;14  %RRRRRGGGGGBBBBB-
   .dh 0b1111111111111110  ; ;15  %RRRRRGGGGGBBBBB-


	.align 4
PSX_Palette:	
 
    .dh 0b1000000000000000; ;0  %-BBBBBGGGGGRRRRR
    .dh 0b1000000000010000; ;1  %-BBBBBGGGGGRRRRR
    .dh 0b1000001000000000; ;2  %-BBBBBGGGGGRRRRR
    .dh 0b1000001000010000; ;3  %-BBBBBGGGGGRRRRR
    .dh 0b1100000000000000; ;4  %-BBBBBGGGGGRRRRR
    .dh 0b1100000000010000; ;5  %-BBBBBGGGGGRRRRR
    .dh 0b1100001000000000; ;6  %-BBBBBGGGGGRRRRR
    .dh 0b1110001100011000; ;7  %-BBBBBGGGGGRRRRR
    .dh 0b1100001000010000; ;8  %-BBBBBGGGGGRRRRR
    .dh 0b1000000000011111; ;9  %-BBBBBGGGGGRRRRR
    .dh 0b1000001111100000; ;10  %-BBBBBGGGGGRRRRR
    .dh 0b1000001111111111; ;11  %-BBBBBGGGGGRRRRR
    .dh 0b1111110000000000; ;12  %-BBBBBGGGGGRRRRR
    .dh 0b1111110000011111; ;13  %-BBBBBGGGGGRRRRR
    .dh 0b1111111111100000; ;14  %-BBBBBGGGGGRRRRR
    .dh 0b1111111111111111; ;15  %-BBBBBGGGGGRRRRR


Bitmap2bitplane:
	.incbin "\ResALL\Sprites\RawGB.RAW"
	
Bitmap4bitplane:
	.incbin "\ResALL\Sprites\RawSMS_16Color.RAW"
	
	.align 4
vm_AddressRemapTable:

vm_traps: 	dw ProgramLaunch
			dw 0

			
DrawAreaTest:
	.word 0x0031,0x0011,0x0011,0x0031
	.word 0x0011,0x0021,0x0021,0x0011
	.word 0x0011,0x0021,0x0021,0x0011
	.word 0x0031,0x0011,0x0011,0x0031
	
	

PrintTest: .db 1,2,3,4,255
		   .db 1,2,3,255
		   .db 1,2,255
		   .db 255
	.align 4
			
MaxTileTest:

	dw36 0x0032,0x0132,0x0232,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0040,0x0040,0x0040,0x0040,0x0047,0x0047,0x0047,0x0047,0x004B,0x004B,0x004B,0x004B,0x004F,0x004F,0x004F,0x004F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0020,0x0060,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0040,0x0040,0x0040,0x0040,0x0047,0x0047,0x0047,0x0047,0x004B,0x004B,0x004B,0x004B,0x004F,0x004F,0x004F,0x004F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0070,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0040,0x0040,0x0040,0x0040,0x0047,0x0047,0x0047,0x0047,0x004B,0x004B,0x004B,0x004B,0x004F,0x004F,0x004F,0x004F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0040,0x0080,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0040,0x0040,0x0040,0x0040,0x0047,0x0047,0x0047,0x0047,0x004B,0x004B,0x004B,0x004B,0x004F,0x004F,0x004F,0x004F,0x0030,0x0030,0x0030,0x0030

	dw36 0x0030,0x0037,0x003B,0x003F,0x1AA0,0x1AA7,0x1AAB,0x1AAF,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0050,0x0050,0x0050,0x0050

	dw36 0x0003,0x0103,0x0203,0x0303,0x0403,0x0503,0x0603,0x0703,0x0803,0x0903,0x0A03,0x0B03,0x0C03,0x0D03,0x0E03,0x0F03,0x1003,0x1103,0x1203,0x1303,0x1403,0x1503,0x1603,0x1703,0x1803,0x1903,0x1A03,0x1B03,0x1C03,0x1D03,0x1E03,0x1F03,0x0050,0x0050,0x0050,0x0050
	dw36 0x0003,0x0103,0x0203,0x0303,0x0403,0x0503,0x0603,0x0703,0x0803,0x0903,0x0A03,0x0B03,0x0C03,0x0D03,0x0E03,0x0F03,0x1003,0x1103,0x1203,0x1303,0x1403,0x1503,0x1603,0x1703,0x1803,0x1903,0x1A03,0x1B03,0x1C03,0x1D03,0x1E03,0x1F03,0x0050,0x0050,0x0050,0x0050
	dw36 0x0003,0x0103,0x0203,0x0303,0x0403,0x0503,0x0603,0x0703,0x0803,0x0903,0x0A03,0x0B03,0x0C03,0x0D03,0x0E03,0x0F03,0x1003,0x1103,0x1203,0x1303,0x1403,0x1503,0x1603,0x1703,0x1803,0x1903,0x1A03,0x1B03,0x1C03,0x1D03,0x1E03,0x1F03,0x0050,0x0050,0x0050,0x0050
	
	dw36 0x0010,0x0017,0x001B,0x001F,0x1AA0,0x1AA7,0x1AAB,0x1AAF,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0050,0x0050,0x0050,0x0050
	dw36 0x0020,0x0027,0x002B,0x002F,0x1AA0,0x1AA7,0x1AAB,0x1AAF,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0050,0x0050,0x0050,0x0050
	dw36 0x0030,0x0037,0x003B,0x003F,0x1AA0,0x1AA7,0x1AAB,0x1AAF,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0020,0x0030,0x0040,0x0000,0x0010,0x0050,0x0050,0x0050,0x0050
	
	;Double
	dw36 0x0013,0x0213,0x0413,0x0613,0x0813,0x1213,0x1413,0x0613,0x0413,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0113,0x0313,0x0513,0x0713,0x0913,0x1313,0x1513,0x0713,0x0513,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
		
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030

	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030
	dw36 0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030,0x0037,0x0037,0x0037,0x0037,0x003B,0x003B,0x003B,0x003B,0x003F,0x003F,0x003F,0x003F,0x0030,0x0030,0x0030,0x0030

	dw36 0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050
	dw36 0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050
	dw36 0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050
	dw36 0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050,0x0050

	dw 0
	dw 0
	dw 0
	dw 0		;Scroll area

	.align 4
MaxTilePatterns:
	.ifdef BuildN64
		.incbin "\ResALL\MaxTile\N64_Tiles.raw"
		.align 4
	
AdrScreenBase:	.dw 0xA0100000+320*2*8*2

	
	.endif
	
	.ifdef BuildPSX
		.incbin "\ResALL\MaxTile\PSX_Tiles.raw"
		.align 4
	.endif
	
	.align 4
			
			
VM_Program_End:
		
	
text:
	.db "HELlo World",255
	.align 4

	
	.include "Footer.asm"


