;s0	r0  A				
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)
vm_usevmem:

	.include "Header.asm"


	.include "\SrcAll\BasicMacros.asm"
  
  
	.include "\srcALL\ChibiVm_InstSet.asm"
	
 
	
 
;Clear Low Ram
	
	la a0,vm_rambaseAddr		;Address
	lw a0,(a0)
	li s1,512					;clear 512 bytes
	
ClearRamAgain:	
	sb zero,(a0)				;Zero a byte
	addi a0,a0,1
	
	addi s1,s1,-1
	bne s1,zero,ClearRamAgain
	nop 
	
	
;Init the program counter	
	li s0,0x0800				;Prog Start
		
	la a0,vm_rambaseAddr		;Address
	lw a0,(a0)
	StoreLEA0 s0,vm_rpc
	
;Init the stack
	li s0,0x0200				;Stack from 0x0200 Down to 0x100
	StoreLEA0 s0,vm_rsp
	

	
;Copy our program to VM Ram
	la a0,vm_rambaseAddr		;Address
	lw s2,(a0)
	lw a0,(a0)
	LoadLEA0 vm_rpc,s2
	
	la s3,VM_Program
	li s1,VM_Program_End-VM_Program
	
ProgramCopyAgain:	
	lbu s0,(s3)
	addi s3,s3,1	
	sb s0,(s2)					;Transfer a byte to VM ram
	addi s2,s2,1	
	
	addi s1,s1,-1
	bne s1,zero,ProgramCopyAgain
	nop 
	
	
;Init the bankswitching
	li s0,0x0000
	add s0,s0,a0
	StoreLE32bitA0 s0,vm_rBank0
	li s0,0x4000
	add s0,s0,a0
	StoreLE32bitA0 s0,vm_rBank1
	li s0,0x8000
	add s0,s0,a0
	StoreLE32bitA0 s0,vm_rBank2
	li s0,0xC000
	add s0,s0,a0
	StoreLE32bitA0 s0,vm_rBank3
	
	
	li s1,170
ProgSkip:
	;jal VM_Tick
	nop
	
	addi s1,s1,-1
	bne s1,zero,ProgSkip
	
	
InfLoop:	
	li s2,0	;Xpos
	li s5,0	;Ypos

	la a2,vm_rambaseAddr	;Address
	lw a2,(a2)
	li a1,6	;Lines
	
	;jal Monitor
	;nop
	
	jal MemDump				;Dump to screen
	nop
	
	
	
	la a0,vm_rambaseAddr	;Address
	lw a2,(a0)
	nop
	addi a2,a2,0x0200		;Stack
	addi a2,a2,-12

	li a1,2				;Lines
	jal MemDump				;Dump to screen
	nop
	
	la a0,vm_rambaseAddr		;Address
	lw a2,(a0)
	lw a0,(a0)
	LoadLEA0 vm_rpc,a2
	li a1,3				;Lines
	jal MemDump				;Dump to screen
	nop
	
	
	;jal Monitor
	;nop
	
	jal VM_Tick
	nop
	
	;jal ReadJoystick
	;nop
	;li s2,0
	;li s5,10
	;jal Monitor			;Reg Dump
	;nop
	
	
	;jal WaitForFire
	;nop


   j InfLoop					;Halt
	nop
vm_rambaseAddr: .dw ramarea+65536


vm_syscalls:
	.dw 0
	.dw TestSysCall1
	
TestSysCall1:
	li s0,0xE4
	la a0,vm_rambaseAddr
	lw a0,(a0)
	nop
	sb s0,VM_rR1(a0)
	
	
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
vm_trap_TableAddr: .dw  ramarea+65536+0x0A46


	
	
	.include "\srcALL\ChibiVm_CPU.asm"
	;.include "\srcALL\test.asm"
;vm_trap_tableaddr: .dw 0
;vm_syscalls:	.dw 0
	
;vm_rambaseaddr:	.dw ramarea+0x10000	

	.align 4	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.include "core.asm"
	.include "monitor.asm"  	
	
	
VM_Program:
	.incbin "\ResAll\ChibiVM\AcidTest.bin"
	;.fill 8
	
VM_Program_End:
	
	
	
text:
	.db "HELlo World",255
	.align 4

	
	.include "Footer.asm"


