VscreenMinX equ 64		;Top left of visible screen in logical co-ordinates
VscreenMinY equ 80
VscreenWid equ 128		;Visible Screen Size in logical units
VscreenHei equ 96



;s0	r0  A				
;s1	r1  B BC 
;s2 ,vr2  D DE
;s3 r3  H HL
;s4	,vr4  C
;s5	r5  E
;s6 ,vr6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

vm_remap_TableAddr equ vm_rambaseAddr+0xFFF0



	.include "Header.asm"


	.include "\SrcAll\BasicMacros.asm"
  
  
	.include "\srcALL\ChibiVm_InstSet.asm"
	
 
	
VM_ProgLoadAddr equ 0x400	

	
	
	; la a0,vm_rambaseAddr		;Address
	; lw a0,(a0)
	
	
	
	; li s0,0x0200				;Stack
	; StoreLEA0 s0,vm_rsp
	
	; li s0,0x0000
	; StoreLEA0 s0,vm_rBank0
	; li s0,0x4000
	; StoreLEA0 s0,vm_rBank1
	; li s0,0x8000
	; StoreLEA0 s0,vm_rBank2
	; li s0,0xC000
	; StoreLEA0 s0,vm_rBank3
	
;Copy our program to VM Ram
	; la a0,vm_rambaseAddr		;Address
	; lw s2,(a0)
	; lw a0,(a0)
	
	; la s3,VM_Program_Zero
	; li s1,VM_Program_End-VM_Program_Zero
	
	
	
; ProgramCopyAgain2:	
	; lbu s0,(s3)
	; addi s3,s3,1
	; sb s0,(s2)
	; addi s2,s2,1
	
	; addi s1,s1,-1
	; bne s1,zero,ProgramCopyAgain2
	; nop 
	
	
	;li s0,0x0800				;Prog Start
	;StoreLEA0 s0,vm_rpc
	
	jal ChibiVM_Init
	nop
	
	
	li s1,100
ProgSkip:
	;jal VM_Tick
	; nop
	
	; addi s1,s1,-1
	; bne s1,zero,ProgSkip
	; nop
	
InfLoop:
	 jal VM_Tick			;Process one VM command
	 nop
		
	 j InfLoop				;Repeat
	 nop

;Debugger
	


	li s2,0	;Xpos
	li s5,0	;Ypos

	la a2,vm_rambaseAddr	;Address
	lw a2,(a2)
	li a1,6	;Lines
	
	jal MemDump				;Dump to screen
	nop
	
	
	
	la a0,vm_rambaseAddr	;Address
	lw a2,(a0)
	nop
	addi a2,a2,0x0200		;Stack
	addi a2,a2,-12

	li a1,2				;Lines
	jal MemDump				;Dump to screen
	nop
	
	la a0,vm_rambaseAddr		;Address
	lw a2,(a0)
	lw a0,(a0)
	LoadLEA0 vm_rpc,a2
	li a1,3				;Lines
	jal MemDump				;Dump to screen
	nop
	
	
	la a2,vm_rambaseAddr	;Address
	lw a2,(a2)
	nop
	addi a2,a2,64+16
	li a1,4	;Lines
	
	jal MemDump				;Dump to screen
	nop
	
	
	
	;jal Monitor
	;nop
	
	jal VM_Tick
	nop
	
	;jal ReadJoystick
	;nop
	;li s2,0
	;li s5,10
	;jal Monitor			;Reg Dump
	;nop
	
	
	jal WaitForFire
	nop


   j InfLoop					;Halt
	nop
vm_rambaseAddr: .dw (ramarea+65536)


;vm_syscalls:
	;.dw VM_Program
	;.dw TestSysCall1
	
TestSysCall1:
	li s0,0xE4
	la a0,vm_rambaseAddr
	lw a0,(a0)
	nop
	sb s0,VM_rR1(a0)
	
	
	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
vm_trap_TableAddr: .dw  ramarea+65536+0x0A46


	
	
	.include "\srcALL\ChibiVm_CPU.asm"
	;.include "\srcALL\test.asm"
;vm_trap_tableaddr: .dw 0
;vm_syscalls:	.dw 0
	
;vm_rambaseaddr:	.dw ramarea+0x10000	
		.include "\SrcALL\V1_NativeSprite.asm"

	.ifdef BuildN64
		.include "\SrcN64\N64_V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif
	
	.ifdef BuildPSX
		.include "\SrcPSX\PSX_V1_NativeSprite.asm"	;MUST come before Adventure Engine!
	.endif

	.include "ChibiVM_AdventureEngine.asm"
	
	
	
	.include "ChibiVM_Host.asm"
	.align 4	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.include "core.asm"
	.include "monitor.asm"  	

; .macro advcall,p1
	; .db p1
	; .db p1/256
; .endmacro 	

	.align 65536
VM_Program_Zero:
	.fill 0x400		
VM_Program:	
	.db "!!!!Chibi/VM!!!!"			;Magic key - must be on a $xxxxxx00 boundary
	.db "Your product name here          "		;Software Name - 32 bytes

	;rorg $10000+VM_ProgLoadAddr+$30
	.db 0			;Header Version
	.db 0b00000011	; config {COpy Vectors to $100}
	.db 0b00111111	;Requirements {adv} {reikou} {maxtile} {QTV} {NS} {memmapper} {ChibiTracks}
	.db 0			;Spare
	.db 0			;Spare
	.db 0			;Cpu Requirements
	.db 0			;Ram Requirements
	.db 0 			;Vector Requorements {Vblank}
	.db 0 			;SysCall Requirements {VmMonitor}{VmControl}{ChipExt}
	.db 0 			;SysCall Requirements
	.db 0			;ChipExt Requirements ???
	.db 0			;ChipExt Requirements ???
	.db 0x11		;Bitmap Modes 0-7 {NS / Maxtile} 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.db 0x01		;Bitmap Modes 0-7 {AdvFont / QTV } 0=ZXS 1=CPC 2=GBC 3=SMS 4=SAM 5=VGA 6=GBA 7=RGBA
	.db 0			;Bitmap modes (spare)
	.db 0			;Bitmap modes (spare)
	
	;rorg $10000+VM_ProgLoadAddr+$40
	dl 0x400		;Rom Load Address
	dl 0x200		;StackPointer
	dl 0x100		;Trap table Ram address (0=none)
	dl 0x0000		;Memmap 1
	dl 0x4000		;Memmap 2
	dl 0x8000		;Memmap 3
	dl 0xC000		;Memmap 4

	.db 0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;rorg $10000+VM_ProgLoadAddr+$70
	dl (vm_traps-VM_Program)	;Vector table (0=none)
	dl 0x2000		;Address remap table (0=none)
	dl 0			;VMAssets (Palette,Font etc)
	dl 0			;???

VM_Program_Hend:

	.fill 0x800	-(VM_Program_Hend-VM_Program_Zero)	;Program load address

ProgramLaunch:
	
VramBase equ 0
ballpos equ 64+16
ballmove equ 64+18
PlayerPaddle equ 64+20
CpuPaddle equ 64+22
PlayerScore equ 64+24
CpuScore equ 64+25
GameTick equ 64+26
GameSpeed equ 64+27		
GameAI equ 64+28
SoundByte equ 64+29 


	
	
	
	dbbw mov16x,r6_imm16,0;SpritePatterns		;Sprite patterns
	NSCall nsInit 
				
	dbbw mov16x,r6_imm16,SpriteArrayRam;5	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray
	
	;db hltb
;                                     

;                                     newgame:
newgame:
	NSCall nsHideAll+regNO
	
	
	
;                                     	advcall acls
	advcall acls
;                                     	mov16x r6,#0x0000		;speed - ai
	dbbw mov16x,r6_imm16,0x0000
;                                     titlescreen:

titlescreen:
;                                     	advcall apause50
	advcall apause50
;                                     	mov16x r4,#0x0000		;cursorpos
	dbbw mov16x,r4_imm16,0x0000
;                                     	ph6
	db ph6b
;                                     		mov16x r6,#strstart
	dbbw mov16x,r6_imm16,(strstart-VramBase)
;                                     		advcall aprintseq
	advcall aprintseq
;                                     		mov16x r6,#strspeed
	dbbw mov16x,r6_imm16,(strspeed-VramBase)
;                                     		advcall aprintseq
	advcall aprintseq
;                                     	pl6
	db pl6b
;                                     	movx r0,r7
	dbbb movx,r0_zeropg,vr7
;                                     	advcall ashowdecimal
	advcall ashowdecimal
;                                     	ph6
	db ph6b
;                                     		mov16x r6,#strai
	dbbw mov16x,r6_imm16,(strai-VramBase)
;                                     		advcall aprintseq
	advcall aprintseq
;                                     	pl6
	db pl6b
;                                     	movx r0,r6
	dbb movx,r0_r6
;                                     	advcall ashowdecimal
	advcall ashowdecimal
;                                     

;                                     	advcall areadjoystick	;0b---frldu
	advcall areadjoystick
;                                     	movx r2,r0
	dbb movx,r2_r0
;                                     

;                                     	mov16x r4,#0x0004		;cursorpos
	dbbw mov16x,r4_imm16,0x0004
;                                     

;                                     	movx r0,r6
	dbb movx,r0_r6
;                                     	advcall ajoyaxis		;ud
	advcall ajoyaxis
;                                     	advcall arangelimit
	advcall arangelimit
;                                     	movx r6,r0
	dbb movx,r6_r0
;                                     

;                                     	movx r0,r7
	dbbb movx,r0_zeropg,vr7
;                                     	advcall ajoyaxis		;lr
	advcall ajoyaxis
;                                     	advcall arangelimit
	advcall arangelimit
;                                     	movx r7,r0
	dbbb movx,zeropg_r0,vr7
;                                     

;                                     	tstx r2,#1			;fire?
	dbbb tstx,r2_imm8,1
;                                     	bnei titlescreen
	dbb bnei,(titlescreen-lbl35419)
lbl35419:


	dbbb movx,r0_zeropg,vr7
	dbw bsrj,(readmask-VramBase)
	dbbw stox,r0_addr16,gamespeed

	dbb movx,r0_r6
	dbw bsrj,(readmask-VramBase)
	dbbw stox,r0_addr16,gameai

	dbw bsrj,(rezeroball-VramBase)

 	dbbw sto16x,r4_addr16,ballpos

	dbbww mov16x,addr16_imm16,ballmove,0xffff	;ball pos -1 = facing player

	dbbwb movx,addr16_imm8,playerpaddle,(6*4)		;ypos
	dbbwb movx,addr16_imm8,cpupaddle,(6*4)

	dbbw clrx,addr16_r0,cpuscore
	dbbw clrx,addr16_r0,playerscore

	dbbwb movx,addr16_imm8,(playerpaddle+1),(0*4)	;Xpos
	dbbwb movx,addr16_imm8,(cpupaddle+1),(19*4)

	advcall acls
	dbbw mov16x,r6_imm16,(strwall-VramBase)				;Draw Walls
	advcall aprintseq
	
	dbw bsrj,(ShowScores-VramBase)							;ShowScores

gameloop:

	dbbw mov16x,r4_addr16,ballpos
	db ph4b
		
		
		
	dbbbb addx,zeropg_imm8,vr4,VscreenMinY
	dbbbb addx,zeropg_imm8,vr5,VscreenMinX
	
	dbbw sto16x,r4_addr16,(SpriteArrayRam+9)
	
	dbw bsrj,(getplayerpaddlede-VramBase)
	
	dbbbb addx,zeropg_imm8,vr4,VscreenMinY
	dbbbb addx,zeropg_imm8,vr5,VscreenMinX
	
	dbbw sto16x,r4_addr16,(SpriteArrayRam+1)
		
	dbw bsrj,(getcpupaddlede-VramBase)
	
	dbbbb addx,zeropg_imm8,vr4,VscreenMinY
	dbbbb addx,zeropg_imm8,vr5,VscreenMinX
	
	dbbw sto16x,r4_addr16,(SpriteArrayRam+5)
		
	
	
	
	dbbw mov16x,r6_imm16,SpriteArrayRam	;Ram
	NSCall nsDrawArray+regRR 			;SpriteArray

	;dbw bsrj,drawpaddle

	

	dbbw movx,r0_addr16,soundbyte
	advcall achibisound+regRR
	dbbw clrx,addr16_r0,soundbyte
	
	dbb movi,1
	advcall apausea
	
	db pl4b

	;db ph4b
	;dbb movi,' '
	;advcall aprintchar
	;db pl4b

	
	
	
	dbbw movx,r0_addr16,gametick
	db incb
	dbbw stox,r0_addr16,gametick

	dbbw andx,r0_addr16,gamespeed

	dbb bnei,(noballmove-lbl65191)
lbl65191:
	dbbw mov16x,r2_addr16,ballmove
	dbw bsrj,(moveball-VramBase)
noballmove:



	dbw bsrj,(getplayerpaddlede-VramBase)

	advcall areadjoystick
	dbb movx,r2_r0
	dbw bsrj,(processpaddle-VramBase)

	
	
 	dbbw sto16x,r6_addr16,playerpaddle
	dbw bsrj,(getcpupaddlede-VramBase)

	dbbw movx,r0_addr16,gametick
	dbbw andx,r0_addr16,gameai

	dbb bnei,(cpudecided-lbl61257)
lbl61257:

	dbbb movx,r2_imm8,0b11111111	;nomove
	dbbw movx,r0_addr16,ballpos
	dbb subi,1
	dbb cmpz,vr4
	dbb beqi,(cpudecided-lbl43064)
lbl43064:
	dbb bcsi,(cpuup-lbl27499)
lbl27499:
	dbbb movx,r2_imm8,0b11111101
	dbb brai,(cpudecided-lbl36249)
lbl36249:

cpuup:
	dbbb movx,r2_imm8,0b11111110

cpudecided:


	dbw bsrj,(processpaddle-VramBase)
	
	dbbw mov16x,addr16_r6,cpupaddle

	dbbw movx,r0_addr16,cpuscore
	dbbw orrx,r0_addr16,playerscore
	
	
	
	dbb cmpi,8
	dbw bcsj,(gameloop-VramBase)
	
	
	
	dbbw mov16x,r6_imm16,(strgameover-VramBase)
	dbbw mov16x,r4_imm16,0x0608
	advcall aprintseq
	advcall awaitforfire
	dbw braj,(newgame-VramBase)

	
getplayerpaddlede:
	dbbw mov16x,r4_addr16,playerpaddle
	db rtsb

getcpupaddlede:
	dbbw mov16x,r4_addr16,cpupaddle
	db rtsb

	
moveball:
	dbbwb movx,addr16_imm8,soundbyte,0b10100000
	dbbw mov16x,r6_addr16,playerpaddle
	
	;dbbb movx,r0_zeropg,r5
	;dbb cmpi,1*4
	dbbbb cmpx,zeropg_imm8,vr5,(1*4-1)
	
	dbb bnei,(noplayerpaddlehit-lbl50130)
lbl50130:

	dbw bsrj,(paddletest-VramBase)
	dbb bcci,(noplayerpaddlehit-lbl28645)
lbl28645:
	dbw bsrj,(cpuscores-VramBase)		;cs=hit


noplayerpaddlehit:
	dbbw mov16x,r6_addr16,cpupaddle

	dbbbb cmpx,zeropg_imm8,vr5,(18*4+1)
	
	dbb bnei,(nocpupaddlehit-lbl7460)
lbl7460:
	dbw bsrj,(paddletest-VramBase)
	dbb bcci,(nocpupaddlehit-lbl16183)
lbl16183:
	dbw bsrj,(playerscores-VramBase)

	
nocpupaddlehit:
	dbbb addx,zeropg_r3,vr5
	dbb  addx,r4_r2		;update ball ypos
	dbbb cmpx,r4_imm8,1*4			;hit top wall
	dbb bnei,(lbl5063-lbl23676)
lbl23676:
	dbw bsrj,(flipy-VramBase)
lbl5063:
	dbbb cmpx,r4_imm8,16*4	;hit bottom wall
	dbb bnei,(lbl16101-lbl21583)
lbl21583:
	dbw bsrj,(flipy-VramBase)
lbl16101:
 	dbbw sto16x,r4_addr16,ballpos		;Old cursor pos
 	dbbw sto16x,r2_addr16,ballmove	
	db rtsb

paddletest:	;carry=missed paddle
	dbb movx,r0_r4
	dbb cmpz,vr6
	dbb bcsi,(paddlemiss-lbl22097)
lbl22097:
	dbb subi,3*4
	dbb cmpz,vr6
	dbb bcci,(paddlemiss-lbl59932)
lbl59932:
	dbw bsrj,(flipx-VramBase)

	dbbwb movx,addr16_imm8,soundbyte,0b01000000
	dbb orrz,vr0	;clear carry
	db rtsb

paddlemiss:
	dbbwb movx,addr16_imm8,soundbyte,0b01110000
	dbbb movx,rf_imm8,3
	db rtsb

cpuscores:
	dbbw incx,addr16_r0,cpuscore
	dbw bsrj,(rezeroball-VramBase)
	dbw bsrj,(ShowScores-VramBase)							;ShowScores
	db rtsb

playerscores:
	dbbw incx,addr16_r0,playerscore
	dbw bsrj,(ShowScores-VramBase)							;ShowScores

rezeroball:
	dbbw mov16x,r4_imm16,0x0a08*4

flipx:
	dbb negz,vr3
	db rtsb

flipy:
	dbb negz,vr2
	db rtsb
	

processpaddle:
	dbb mov16x,r6_r4

	dbbw mov16x,r4_imm16,0x010e*4
	dbb movx,r0_r6
		advcall ajoyaxis
		advcall arangelimit
	dbb movx,r6_r0
	db rtsb

readmask:
	dbbbb movx,zeropg_imm8,vr5,0
	dbb movx,r4_r0
	dbbw add16x,r4_imm16,(masks-VramBase)
	dbb movx,r0_atr4
	db rtsb
	
ShowScores:
	db ph4b
		dbbw mov16x,r4_imm16,0x0011
		dbbw movx,r0_addr16,playerscore
		advcall ashowdecimal+regRR

		dbbw mov16x,r4_imm16,0x1111
		dbbw movx,r0_addr16,cpuscore
		advcall ashowdecimal+regRR
	db pl4b
	db rtsb
	
	
	
;Speed masks for ball and AI	
Masks:	.db 0b00000111,0b00000011,0b00000001,0b00000000


strGameOver:.db "Game Over",255
strStart:	.db "Pongo!",253,255

strSpeed:	.db 253,"Speed:",255
strAi:		.db 253,"AI:",255


strWall:	.db 0xB3,"-"
			.db 253
			.db 0xF1	;253=Newline (Xpos=0) 0xF1= Ypos=17
			 .db 0xB3,"-"
			 .db 255		;0xB3=18 char H strip 

strPaddle: 	 	 .db 0xC2,"X",255 ;0xC2=3 char V strip
strBlankPaddle:  .db 0xC2," ",255


vm_traps: 	dw ProgramLaunch
			dw 0
			
SpriteArrayRam:
SpriteArrayTT:
	.db 3		;Count	
	.db 0x80,0x70
		.db 2,0;SpriteData_Bat1	;XXYY,Sprite
	.db 0x80,0x90
		.db 3,0;dc.w SpriteData_Bat2	;XXYY,Sprite
	.db 0x80,0x80
		.db 4,0;dc.w SpriteData_Ball	;XXYY,Sprite
	.align 4


	
	
			
SpritePatterns:	
	.ifdef BuildN64
		.incbin "\ResALL\ChibiVM\Sprong_Sprites_N64.raw"
	.endif
	.ifdef BuildPSX
		.incbin "\ResALL\ChibiVM\Sprong_Sprites_PSX.raw"
	.endif
SpritePatterns_End:	

	.align 8192 ;$2000
	
vm_AddressRemapTable:
	.dw SpritePatterns	;0
	.dw SpriteArrayRam 	;1
	.dw SpriteData_Bat1	;2
	.dw SpriteData_Bat2	;3
	.dw SpriteData_Ball	;4
	.dw 0;SpriteArray 	;5
	.dw 0;SpriteData_Magnify ;6

SpriteArray:
	.dw 3		;Count	
	.dw 0x70,0x80
		.dw SpriteData_Bat1	;XXYY,Sprite
	.dw 0x90,0x80
		.dw SpriteData_Bat2	;XXYY,Sprite
	.dw 0x80,0x80
		.dw SpriteData_Ball	;XXYY,Sprite
	
	
	.align 4
SpriteData_Bat2:	
SpriteData_Bat1:
		.dw 1,3		;Wid,Hei
		.dw 0,1,2	;Tile patterns

	
SpriteData_Ball:
		.dw 1,1		;Wid,Hei
		.dw 3		;Tile Patterns
	
	
	.align 4  ;*** WARNING - COUNT WILL MEAN ARRAY is ODD ALIGNED! ***
	

VM_Program_End:
		
	
text:
	.db "HELlo World",255
	.align 4

	
	.include "Footer.asm"


