
NewLine:
	addi sp,sp,-4	;Subtract 4 from Stack pointer
	sw ra,0(sp)		;Put the register onto the stack

		li s2,0			;X
		addi s5,s5,1	;Y
		
		li t0,20
		bgt s5,t0,clsb	;Clearscreen if off bottom
		nop

	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4	;Add 4 to the Stack pointer
	jr ra			;Return
	nop
	
	
cls:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
clsb:
		li s2,0				;Xpos
		li s5,0				;Ypos

		li s3,0x20			;Char
		li s6,0				;CharInc
		li s1,30			;Width
		li s4,20			;Height
		jal fillarea
		nop
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
PrintNumber:
	addiu s0,s0,48
PrintChar:	;PrintChar s0 at X,Y pos s2,s5
		andi s0,s0,255
		beq s0,zero,PrintChar_Zero	;Chr0?

;Calcuate VRAM dest
  		andi s2,s2,255	
		andi s5,s5,255
		
		la t5,0xA0100000+320*2*8*2	;Screen Base+2 lines
		  
		move t0,s2		;Xpos
		li t3,16		;Bytes per Char
		multu t3,t0		
		mflo t3
		add t5,t5,t3
					
		  
		move t0,s5		;Ypos
		li t3,320*2*8	;Bytes per line+Char
		multu t3,t0
		mflo t3
		add t5,t5,t3	;T5= Vram Dest
		
;Calcuate Font Source
		la t6,MyFont 	;Font Address
    
		move t7,s0		;Char to show
		addi t7,-32		;No char below 32
		
		li t0,64		;Character not Lowercase?
		bltu t7,t0,NotLowerCase
		nop
		addi t7,-32		;Convert to Uppercase
NotLowerCase:
			
		sll t7,7 		;8*8*2 (2 bytes per pixel - 128 bytes per char) 
		addu t6,t7 		;add to font base

		
		li t2,8			;Height in lines
PrintChar_NextLine:	
		li t1,8			;Width in pixels
PrintChar_NextByte:
		lh t4,0(t6) 	;Get 16 bits from font
		addiu t6,2
		sh t4,0(t5) 	;Store 16 bits to screen
		addiu t5,2
	
		subiu t1,1 		;Repeat for next char
		bnez t1,PrintChar_NextByte
		nop
	  
		addiu t5,(320-8)*2 ;Move down 1 line
      
		subiu t2,1 		;Repeat for next line
		bnez t2,PrintChar_NextLine
		nop

PrintChar_Zero:		
		addiu s2,1		;Xpos ++
	jr ra
	nop

	
	
PrintString:				;Print String s3
	;pushAll		
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
DrawChars:		
		lbu s0,0(s3) 	;Load a character
		addiu s3,1 		;Move to next Char
		
		li t0,255		;Compare to 255
		beq t0,s0,PrintString_Done	;Done?
		nop
		
		jal PrintChar	;Show Character s3 to the screen
		nop
		
		j DrawChars		;Repeat
		nop
PrintString_Done:	
	;popAll				
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
	
	
	
InitJoystick:
;Init Pif 
    li a0,0xBFC007C0		;A0 = PIF Base Register ($BFC00000)
	li t0,8					;Init the PIF
	sw t0,0x3C(a0)			;BFC007FC: Status Register
    
;Init Joypad for read
	li a0,0xA4800000 	;Serial interface (SI) registers
	li t0,0x1FFFFFFF	;Physical Addr Mask
	
	li a1,PIF_Init		;Init sequence
	and a1,a1,t0		;Convert Virtual Addr-> physical
	sw a1,0x0000(a0) 	;SI_DRAM_ADDR_REG
	
	li a1,0xBFC007C0 	;PIF_RAM_START
	and a1,a1,t0		;Convert Virtual Addr-> physical
	sw a1,0x0010(a0) 	;SI_PIF_ADDR_WR64B_REG + Start WRITE (64 Bytes)
     
	jr ra
	nop
	
  .align 8 
PIF_Init:
  .dw 0xFF010401,0		;Controller 1
  .dw 0xFF010401,0		;Controller 2
  .dw 0xFF010401,0		;Controller 3
  .dw 0xFF010401,0		;Controller 4
  
  .dw 0xFE000000,0		;Controller End
  .dw 0,0
  .dw 0,0
  .dw 0,1				;Last word is Status reg
  
  
PIF_JoyState: 			;We'll use this to read back joy state
  .dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  
  
   
ReadJoystick:				;%ZSBARLDU
;Poll joypad
	li a0,0xA4800000 		;Serial interface (SI) registers
	li t0,0x1FFFFFFF		;Physical Addr Mask
	
	li a1,PIF_JoyState 		;RAM for Joy status write
	and a1,a1,t0			;Convert Virtual Addr-> physical
	sw a1,0x0000(a0) 		;SI_DRAM_ADDR_REG
	
	li a1,0xBFC007C0 		;PIF_RAM_START
	and a1,a1,t0			;Convert Virtual Addr-> physical
	sw a1,0x0004(a0) 		;SI_PIF_ADDR_RD64B_REG + Start READ (64 Bytes)

; Convert to our desired format
	li a3,PIF_JoyState 		;RAM for Joy status write
	
	lbu a2,4(a3)
	nop
	andi a1,a2,0b00001000	;U
	srl s0,a1,3
	
	andi a1,a2,0b00000100	;D
	srl a1,a1,1
	or s0,s0,a1
	
	andi a1,a2,0b00000010	;L
	sll a1,a1,1
	or s0,s0,a1
	
	andi a1,a2,0b00000001	;R
	sll a1,a1,3
	or s0,s0,a1
	
	
	andi a1,a2,0b11000000	;BA
	srl a1,a1,2
	or s0,s0,a1
	
	andi a1,a2,0b00110000	;Z Start
	sll a1,a1,2
	or s0,s0,a1

	xori s0,s0,255
	andi s0,s0,255
	
	jr ra
	nop
		
	; PIF (JoyChannel) RAM:
; ---------------------
	; 0x1FC0 07C0  PIF_RAM_START
	; 0x1FC0 07C4 (16 low bits)   Status of controller:
		; %X  X  X  X  X  X  X  X  X  X  X  X  X  X  X  X
		 ; A  B  Z  ST U  D  L  R  ?  ?  PL PR CU CD CL CR
		 ; A,B,Z,ST    = A,B,Z, Start buttons
		 ; U,D,L,R     = Joypad directions
		 ; ?,?         = Unknown
		 ; PL,PR       = Pan left, Pan right buttons
		 ; CU,CD,CL,CR = C buttons (up,down,left,right)
	; 0x1FC0 07FF  PIF_RAM_END
	
	
MyFont:		;4 lines per char (Big endian)
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  0  - Ofst:&0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  1  - Ofst:&20
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  2  - Ofst:&40
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  3  - Ofst:&60
	.dw 0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;  4  - Ofst:&80
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;  5  - Ofst:&A0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  6  - Ofst:&C0
	.dw 0x00010001,0x00018421,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  7  - Ofst:&E0
	.dw 0x00010001,0xF7BD0001,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;  8  - Ofst:&100
	.dw 0x00010001,0xF7BD0001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;  9  - Ofst:&120
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 10  - Ofst:&140
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 11  - Ofst:&160
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0xF7BD0001,0xF7BD0001,0x00010001     ; 12  - Ofst:&180
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x00010001,0xF7BD0001,0xF7BD0001,0x00010001     ; 13  - Ofst:&1A0
	.dw 0x00018421,0xF7BD8421,0xF7BD8421,0x00010001,0x00010001,0x84210001,0x84210001,0x00010001     ; 14  - Ofst:&1C0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 15  - Ofst:&1E0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 16  - Ofst:&200
	.dw 0x0001F7BD,0x00010001,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ; 17  - Ofst:&220
	.dw 0x00010001,0x0001F7BD,0x00010001,0xF7BD0001,0x00018421,0xF7BD8421,0xF7BD8421,0x00010001     ; 18  - Ofst:&240
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 19  - Ofst:&260
	.dw 0x00010001,0x00010001,0x00010001,0xF7BD0001,0xF7BDF7BD,0x00010001,0x0001F7BD,0x00010001     ; 20  - Ofst:&280
	.dw 0xF7BDF7BD,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0x00010001,0x00010001     ; 21  - Ofst:&2A0
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x00010001,0x00018421,0xF7BD0001     ; 22  - Ofst:&2C0
	.dw 0x84210001,0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ; 23  - Ofst:&2E0
	.dw 0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0xF7BD0001,0xF7BD0001,0x00010001     ; 24  - Ofst:&300
	.dw 0x00010001,0xF7BD0001,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001,0xF7BD0001     ; 25  - Ofst:&320
	.dw 0xF7BD0001,0x0001F7BD,0x0001F7BD,0x00010001,0xF7BD0001,0x00010001,0xF7BD8421,0x00010001     ; 26  - Ofst:&340
	.dw 0x00018421,0x84218421,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ; 27  - Ofst:&360
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001     ; 28  - Ofst:&380
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 29  - Ofst:&3A0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 30  - Ofst:&3C0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 31  - Ofst:&3E0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ; 32  - Ofst:&400
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001     ; 33  - Ofst:&420
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 34  - Ofst:&440
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 35  - Ofst:&460
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ; 36  - Ofst:&480
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ; 37  - Ofst:&4A0
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 38  - Ofst:&4C0
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 39  - Ofst:&4E0
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x0001F7BD,0x00010001,0xF7BD0001,0x0001F7BD     ; 40  - Ofst:&500
	.dw 0x00010001,0xF7BD0001,0xF7BD0001,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001     ; 41  - Ofst:&520
	.dw 0x00010001,0x0001F7BD,0x0001F7BD,0x00010001,0x00010001,0xF7BD0001,0x00010001,0xF7BD0001     ; 42  - Ofst:&540
	.dw 0x00018421,0x00010001,0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001     ; 43  - Ofst:&560
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ; 44  - Ofst:&580
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 45  - Ofst:&5A0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 46  - Ofst:&5C0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 47  - Ofst:&5E0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 48  - Ofst:&600
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 49  - Ofst:&620
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 50  - Ofst:&640
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x84218421,0x00010001,0x00010001     ; 51  - Ofst:&660
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 52  - Ofst:&680
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 53  - Ofst:&6A0
	.dw 0x00018421,0x84218421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ; 54  - Ofst:&6C0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 55  - Ofst:&6E0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 56  - Ofst:&700
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 57  - Ofst:&720
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 58  - Ofst:&740
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 59  - Ofst:&760
	.dw 0x00010001,0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0x00010001     ; 60  - Ofst:&780
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0x00010001,0x00010001     ; 61  - Ofst:&7A0
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x00010001,0x00010001,0x00010001     ; 62  - Ofst:&7C0
	.dw 0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 63  - Ofst:&7E0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001     ; 64  - Ofst:&800
	.dw 0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001     ; 65  - Ofst:&820
	.dw 0x8421F7BD,0x00018421,0x0001F7BD,0x84210001,0x84218421,0x00010001,0x00018421,0x84210001     ; 66  - Ofst:&840
	.dw 0x00018421,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 67  - Ofst:&860
	.dw 0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ; 68  - Ofst:&880
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ; 69  - Ofst:&8A0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 70  - Ofst:&8C0
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 71  - Ofst:&8E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 72  - Ofst:&900
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ; 73  - Ofst:&920
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ; 74  - Ofst:&940
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 75  - Ofst:&960
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 76  - Ofst:&980
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001     ; 77  - Ofst:&9A0
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ; 78  - Ofst:&9C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 79  - Ofst:&9E0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ; 80  - Ofst:&A00
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0x00010001,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001     ; 81  - Ofst:&A20
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BD8421,0x00010001     ; 82  - Ofst:&A40
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 83  - Ofst:&A60
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 84  - Ofst:&A80
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ; 85  - Ofst:&AA0
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ; 86  - Ofst:&AC0
	.dw 0x00010001,0x84218421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ; 87  - Ofst:&AE0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 88  - Ofst:&B00
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ; 89  - Ofst:&B20
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ; 90  - Ofst:&B40
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 91  - Ofst:&B60
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ; 92  - Ofst:&B80
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ; 93  - Ofst:&BA0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ; 94  - Ofst:&BC0
	.dw 0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 95  - Ofst:&BE0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ; 96  - Ofst:&C00
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ; 97  - Ofst:&C20
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ; 98  - Ofst:&C40
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ; 99  - Ofst:&C60
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;100  - Ofst:&C80
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;101  - Ofst:&CA0
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;102  - Ofst:&CC0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;103  - Ofst:&CE0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;104  - Ofst:&D00
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;105  - Ofst:&D20
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;106  - Ofst:&D40
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;107  - Ofst:&D60
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;108  - Ofst:&D80
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;109  - Ofst:&DA0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;110  - Ofst:&DC0
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x84218421,0x00010001,0x00010001     ;111  - Ofst:&DE0
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001     ;112  - Ofst:&E00
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;113  - Ofst:&E20
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD8421,0x00010001     ;114  - Ofst:&E40
	.dw 0x00010001,0x00010001,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;115  - Ofst:&E60
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;116  - Ofst:&E80
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00010001     ;117  - Ofst:&EA0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;118  - Ofst:&EC0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;119  - Ofst:&EE0
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001,0x00010001     ;120  - Ofst:&F00
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;121  - Ofst:&F20
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00018421,0xF7BD8421,0x00010001,0x00010001     ;122  - Ofst:&F40
	.dw 0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;123  - Ofst:&F60
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0x0001F7BD,0xF7BD0001     ;124  - Ofst:&F80
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001     ;125  - Ofst:&FA0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x0001F7BD,0x84210001,0x00010001     ;126  - Ofst:&FC0
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;127  - Ofst:&FE0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0xF7BD0001     ;128  - Ofst:&1000
	.dw 0xF7BD0001,0xF7BD0001,0x0001F7BD,0xF7BD0001,0xF7BD0001,0xF7BDF7BD,0x0001F7BD,0xF7BD0001     ;129  - Ofst:&1020
	.dw 0xF7BDF7BD,0x00010001,0x0001F7BD,0x84210001,0xF7BD8421,0xF7BD8421,0x00010001,0x00010001     ;130  - Ofst:&1040
	.dw 0x00018421,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;131  - Ofst:&1060
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;132  - Ofst:&1080
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;133  - Ofst:&10A0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;134  - Ofst:&10C0
	.dw 0x00010001,0x84210001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;135  - Ofst:&10E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;136  - Ofst:&1100
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;137  - Ofst:&1120
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;138  - Ofst:&1140
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;139  - Ofst:&1160
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;140  - Ofst:&1180
	.dw 0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001     ;141  - Ofst:&11A0
	.dw 0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0x00010001     ;142  - Ofst:&11C0
	.dw 0x00010001,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;143  - Ofst:&11E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0x00010001     ;144  - Ofst:&1200
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;145  - Ofst:&1220
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0x00010001     ;146  - Ofst:&1240
	.dw 0x00010001,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;147  - Ofst:&1260
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;148  - Ofst:&1280
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BD0001,0x00010001     ;149  - Ofst:&12A0
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;150  - Ofst:&12C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;151  - Ofst:&12E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;152  - Ofst:&1300
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BD0001,0x00010001     ;153  - Ofst:&1320
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001,0x00010001     ;154  - Ofst:&1340
	.dw 0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;155  - Ofst:&1360
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;156  - Ofst:&1380
	.dw 0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001     ;157  - Ofst:&13A0
	.dw 0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;158  - Ofst:&13C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;159  - Ofst:&13E0
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;160  - Ofst:&1400
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;161  - Ofst:&1420
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;162  - Ofst:&1440
	.dw 0x00010001,0x84210001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;163  - Ofst:&1460
	.dw 0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;164  - Ofst:&1480
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;165  - Ofst:&14A0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;166  - Ofst:&14C0
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;167  - Ofst:&14E0
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;168  - Ofst:&1500
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;169  - Ofst:&1520
	.dw 0x0001F7BD,0x00010001,0xF7BDF7BD,0x00010001,0xF7BD8421,0xF7BD8421,0xF7BD8421,0x00010001     ;170  - Ofst:&1540
	.dw 0x00018421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;171  - Ofst:&1560
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;172  - Ofst:&1580
	.dw 0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BD0001,0x00010001     ;173  - Ofst:&15A0
	.dw 0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;174  - Ofst:&15C0
	.dw 0x00010001,0x84210001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;175  - Ofst:&15E0
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;176  - Ofst:&1600
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;177  - Ofst:&1620
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;178  - Ofst:&1640
	.dw 0x00010001,0x84218421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;179  - Ofst:&1660
	.dw 0x0001F7BD,0x00010001,0x0001F7BD,0x00010001,0xF7BDF7BD,0xF7BD0001,0xF7BDF7BD,0xF7BD0001     ;180  - Ofst:&1680
	.dw 0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001     ;181  - Ofst:&16A0
	.dw 0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0xF7BD8421,0x0001F7BD,0x00018421,0xF7BD0001     ;182  - Ofst:&16C0
	.dw 0x00018421,0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;183  - Ofst:&16E0
	.dw 0x0001F7BD,0x00010001,0x0001F7BD,0x00010001,0xF7BDF7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;184  - Ofst:&1700
	.dw 0xF7BDF7BD,0xF7BDF7BD,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x0001F7BD,0xF7BDF7BD,0xF7BD0001     ;185  - Ofst:&1720
	.dw 0xF7BDF7BD,0x00010001,0xF7BDF7BD,0xF7BD0001,0xF7BD8421,0x00010001,0x00018421,0xF7BD0001     ;186  - Ofst:&1740
	.dw 0x00018421,0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;187  - Ofst:&1760
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;188  - Ofst:&1780
	.dw 0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001     ;189  - Ofst:&17A0
	.dw 0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0xF7BD8421,0x00010001     ;190  - Ofst:&17C0
	.dw 0x00010001,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;191  - Ofst:&17E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;192  - Ofst:&1800
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;193  - Ofst:&1820
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001,0x00010001     ;194  - Ofst:&1840
	.dw 0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;195  - Ofst:&1860
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;196  - Ofst:&1880
	.dw 0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001     ;197  - Ofst:&18A0
	.dw 0xF7BDF7BD,0x00010001,0xF7BD0001,0xF7BD0001,0x00018421,0x84218421,0x00018421,0x00010001     ;198  - Ofst:&18C0
	.dw 0x00010001,0x84218421,0x84210001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;199  - Ofst:&18E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;200  - Ofst:&1900
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;201  - Ofst:&1920
	.dw 0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;202  - Ofst:&1940
	.dw 0x00010001,0x84210001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;203  - Ofst:&1960
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;204  - Ofst:&1980
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;205  - Ofst:&19A0
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;206  - Ofst:&19C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;207  - Ofst:&19E0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;208  - Ofst:&1A00
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;209  - Ofst:&1A20
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;210  - Ofst:&1A40
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;211  - Ofst:&1A60
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;212  - Ofst:&1A80
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;213  - Ofst:&1AA0
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;214  - Ofst:&1AC0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;215  - Ofst:&1AE0
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;216  - Ofst:&1B00
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;217  - Ofst:&1B20
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BD8421,0xF7BD8421,0x00010001     ;218  - Ofst:&1B40
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;219  - Ofst:&1B60
	.dw 0x0001F7BD,0x00010001,0x0001F7BD,0x00010001,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001     ;220  - Ofst:&1B80
	.dw 0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001     ;221  - Ofst:&1BA0
	.dw 0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x8421F7BD,0x84210001,0x8421F7BD,0x84210001     ;222  - Ofst:&1BC0
	.dw 0x00018421,0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;223  - Ofst:&1BE0
	.dw 0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;224  - Ofst:&1C00
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001     ;225  - Ofst:&1C20
	.dw 0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0xF7BD8421,0x00010001,0x00018421,0xF7BD0001     ;226  - Ofst:&1C40
	.dw 0x00018421,0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;227  - Ofst:&1C60
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;228  - Ofst:&1C80
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;229  - Ofst:&1CA0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;230  - Ofst:&1CC0
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;231  - Ofst:&1CE0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;232  - Ofst:&1D00
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;233  - Ofst:&1D20
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;234  - Ofst:&1D40
	.dw 0x00018421,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;235  - Ofst:&1D60
	.dw 0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001     ;236  - Ofst:&1D80
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001     ;237  - Ofst:&1DA0
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BD8421,0x00010001,0x00010001     ;238  - Ofst:&1DC0
	.dw 0x00010001,0x00018421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;239  - Ofst:&1DE0
	.dw 0xF7BD0001,0x00010001,0x00010001,0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001     ;240  - Ofst:&1E00
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x0001F7BD,0x00010001,0x00010001     ;241  - Ofst:&1E20
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00018421,0x00010001     ;242  - Ofst:&1E40
	.dw 0x00010001,0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;243  - Ofst:&1E60
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;244  - Ofst:&1E80
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;245  - Ofst:&1EA0
	.dw 0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BD8421,0x00010001     ;246  - Ofst:&1EC0
	.dw 0x00010001,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;247  - Ofst:&1EE0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;248  - Ofst:&1F00
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;249  - Ofst:&1F20
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;250  - Ofst:&1F40
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x84210001,0x00010001     ;251  - Ofst:&1F60
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;252  - Ofst:&1F80
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;253  - Ofst:&1FA0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;254  - Ofst:&1FC0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x84210001,0x00010001     ;255  - Ofst:&1FE0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;256  - Ofst:&2000
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;257  - Ofst:&2020
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;258  - Ofst:&2040
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x84210001,0x00010001     ;259  - Ofst:&2060
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;260  - Ofst:&2080
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;261  - Ofst:&20A0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0xF7BD8421,0x00010001,0xF7BD8421,0x00010001     ;262  - Ofst:&20C0
	.dw 0x00018421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;263  - Ofst:&20E0
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;264  - Ofst:&2100
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;265  - Ofst:&2120
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;266  - Ofst:&2140
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;267  - Ofst:&2160
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;268  - Ofst:&2180
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;269  - Ofst:&21A0
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;270  - Ofst:&21C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;271  - Ofst:&21E0
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;272  - Ofst:&2200
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001     ;273  - Ofst:&2220
	.dw 0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001,0xF7BD8421,0x00010001,0xF7BD8421,0x00010001     ;274  - Ofst:&2240
	.dw 0x00018421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;275  - Ofst:&2260
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;276  - Ofst:&2280
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;277  - Ofst:&22A0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00010001,0x00010001     ;278  - Ofst:&22C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;279  - Ofst:&22E0
	.dw 0x00010001,0x0001F7BD,0xF7BDF7BD,0x00010001,0x00010001,0xF7BDF7BD,0x0001F7BD,0xF7BD0001     ;280  - Ofst:&2300
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001     ;281  - Ofst:&2320
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BD8421,0x00010001,0x00010001     ;282  - Ofst:&2340
	.dw 0x00010001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;283  - Ofst:&2360
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;284  - Ofst:&2380
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;285  - Ofst:&23A0
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;286  - Ofst:&23C0
	.dw 0x00010001,0x00010001,0x00018421,0x84210001,0x00010001,0x84218421,0x84218421,0x00010001     ;287  - Ofst:&23E0
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;288  - Ofst:&2400
	.dw 0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BDF7BD,0x0001F7BD,0xF7BD0001     ;289  - Ofst:&2420
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;290  - Ofst:&2440
	.dw 0x00010001,0x84210001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;291  - Ofst:&2460
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;292  - Ofst:&2480
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;293  - Ofst:&24A0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;294  - Ofst:&24C0
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;295  - Ofst:&24E0
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x00010001     ;296  - Ofst:&2500
	.dw 0x00010001,0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001     ;297  - Ofst:&2520
	.dw 0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BD0001,0x00018421,0xF7BD0001     ;298  - Ofst:&2540
	.dw 0x00018421,0x84210001,0x00018421,0x84210001,0x00010001,0x84218421,0x84218421,0x00010001     ;299  - Ofst:&2560
	.dw 0x00010001,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;300  - Ofst:&2580
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;301  - Ofst:&25A0
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00018421,0xF7BD0001,0xF7BD8421,0x00010001     ;302  - Ofst:&25C0
	.dw 0x00010001,0x84210001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;303  - Ofst:&25E0
	.dw 0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;304  - Ofst:&2600
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;305  - Ofst:&2620
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001     ;306  - Ofst:&2640
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;307  - Ofst:&2660
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;308  - Ofst:&2680
	.dw 0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;309  - Ofst:&26A0
	.dw 0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0xF7BD8421,0x00018421,0x00018421,0xF7BD0001     ;310  - Ofst:&26C0
	.dw 0x84218421,0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;311  - Ofst:&26E0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;312  - Ofst:&2700
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;313  - Ofst:&2720
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;314  - Ofst:&2740
	.dw 0x00010001,0x84210001,0x00018421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;315  - Ofst:&2760
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;316  - Ofst:&2780
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;317  - Ofst:&27A0
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;318  - Ofst:&27C0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;319  - Ofst:&27E0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;320  - Ofst:&2800
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;321  - Ofst:&2820
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD8421,0xF7BD8421,0x00010001     ;322  - Ofst:&2840
	.dw 0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x84210001,0x00010001,0x00010001     ;323  - Ofst:&2860
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;324  - Ofst:&2880
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BD0001,0x00010001,0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001     ;325  - Ofst:&28A0
	.dw 0xF7BDF7BD,0x00010001,0xF7BDF7BD,0x00010001,0x00018421,0xF7BD8421,0xF7BD8421,0x00010001     ;326  - Ofst:&28C0
	.dw 0x00010001,0x00010001,0x84218421,0x00010001,0x00010001,0x00010001,0x84210001,0x00010001     ;327  - Ofst:&28E0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;328  - Ofst:&2900
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;329  - Ofst:&2920
	.dw 0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0xF7BD0001,0x00010001,0x00010001     ;330  - Ofst:&2940
	.dw 0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;331  - Ofst:&2960
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;332  - Ofst:&2980
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001     ;333  - Ofst:&29A0
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0x00018421,0xF7BD0001     ;334  - Ofst:&29C0
	.dw 0x00018421,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;335  - Ofst:&29E0
	.dw 0x00010001,0x0001F7BD,0x00010001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001     ;336  - Ofst:&2A00
	.dw 0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001,0x00010001,0xF7BDF7BD,0x00010001,0x00010001     ;337  - Ofst:&2A20
	.dw 0x00010001,0xF7BDF7BD,0x00010001,0x00010001,0x00010001,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;338  - Ofst:&2A40
	.dw 0x00010001,0x00018421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;339  - Ofst:&2A60
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;340  - Ofst:&2A80
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;341  - Ofst:&2AA0
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00018421,0xF7BD0001,0x00018421,0xF7BD0001     ;342  - Ofst:&2AC0
	.dw 0x00010001,0x84218421,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;343  - Ofst:&2AE0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;344  - Ofst:&2B00
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;345  - Ofst:&2B20
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BD8421,0xF7BD8421,0x00010001     ;346  - Ofst:&2B40
	.dw 0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;347  - Ofst:&2B60
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;348  - Ofst:&2B80
	.dw 0x0001F7BD,0x00010001,0x0001F7BD,0x00010001,0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001     ;349  - Ofst:&2BA0
	.dw 0xF7BDF7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0xF7BD8421,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;350  - Ofst:&2BC0
	.dw 0x00018421,0x84210001,0x84218421,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;351  - Ofst:&2BE0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;352  - Ofst:&2C00
	.dw 0xF7BDF7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0xF7BDF7BD,0x00010001     ;353  - Ofst:&2C20
	.dw 0x00010001,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00018421,0xF7BD0001,0xF7BD8421,0x00010001     ;354  - Ofst:&2C40
	.dw 0x84218421,0x00010001,0x00018421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;355  - Ofst:&2C60
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;356  - Ofst:&2C80
	.dw 0x00010001,0xF7BD0001,0x0001F7BD,0x00010001,0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001     ;357  - Ofst:&2CA0
	.dw 0x0001F7BD,0xF7BD0001,0x0001F7BD,0xF7BD0001,0x00010001,0xF7BD8421,0xF7BD8421,0xF7BD0001     ;358  - Ofst:&2CC0
	.dw 0x00010001,0x00010001,0x00018421,0x84210001,0x00018421,0x84218421,0x84218421,0x00010001     ;359  - Ofst:&2CE0
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;360  - Ofst:&2D00
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0x00010001     ;361  - Ofst:&2D20
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BD8421,0x00010001,0x00010001     ;362  - Ofst:&2D40
	.dw 0x00018421,0x84218421,0x84218421,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001     ;363  - Ofst:&2D60
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0xF7BD0001,0x00010001     ;364  - Ofst:&2D80
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x84210001,0x00010001     ;365  - Ofst:&2DA0
	.dw 0x0001F7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0x0001F7BD,0x0001F7BD,0x0001F7BD,0x0001F7BD     ;366  - Ofst:&2DC0
	.dw 0x0001F7BD,0x0001F7BD,0x0001F7BD,0xF7BD8421,0x00018421,0x84218421,0x00018421,0x00010001     ;367  - Ofst:&2DE0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00010001,0x0001F7BD,0x00010001     ;368  - Ofst:&2E00
	.dw 0x00010001,0x00010001,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x84218421,0x00010001     ;369  - Ofst:&2E20
	.dw 0x0001F7BD,0x0001F7BD,0x0001F7BD,0xF7BD0001,0x0001F7BD,0x0001F7BD,0x0001F7BD,0x0001F7BD     ;370  - Ofst:&2E40
	.dw 0x0001F7BD,0x0001F7BD,0x0001F7BD,0xF7BD8421,0x00018421,0x84218421,0x00018421,0x00010001     ;371  - Ofst:&2E60
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;372  - Ofst:&2E80
	.dw 0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;373  - Ofst:&2EA0
	.dw 0x00018421,0xF7BDF7BD,0xF7BDF7BD,0x84210001,0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001     ;374  - Ofst:&2EC0
	.dw 0xF7BD8421,0x84218421,0x84218421,0x8421F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD     ;375  - Ofst:&2EE0
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0xF7BDF7BD,0xF7BDF7BD,0x00010001     ;376  - Ofst:&2F00
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x00018421,0x84210001,0x00010001     ;377  - Ofst:&2F20
	.dw 0x00010001,0x0001F7BD,0xF7BD0001,0x00010001,0x00010001,0x0001F7BD,0xF7BD0001,0x00010001     ;378  - Ofst:&2F40
	.dw 0x00018421,0xF7BDF7BD,0xF7BDF7BD,0xF7BD0001,0x8421F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD     ;379  - Ofst:&2F60
	.dw 0x00010001,0xF7BD0001,0x00010001,0xF7BD0001,0x0001F7BD,0xF7BDF7BD,0x0001F7BD,0xF7BDF7BD     ;380  - Ofst:&2F80
	.dw 0x0001F7BD,0xF7BDF7BD,0xF7BDF7BD,0xF7BDF7BD,0x00018421,0xF7BDF7BD,0xF7BDF7BD,0xF7BD8421     ;381  - Ofst:&2FA0
	.dw 0x00010001,0x8421F7BD,0xF7BDF7BD,0x84210001,0x00010001,0x00018421,0xF7BD8421,0x00010001     ;382  - Ofst:&2FC0
	.dw 0x00010001,0x00010001,0x84210001,0x00010001,0x00010001,0x00010001,0x00010001,0x00010001     ;383  - Ofst:&2FE0


.org 0x80000000+1052672-1			;Pad to 8 megabit
	.db 0
.close


