
NewLine:
	addi sp,sp,-4	;Subtract 4 from Stack pointer
	sw ra,0(sp)		;Put the register onto the stack

		li s2,0			;X
		addi s5,s5,1	;Y
		
		li t0,20
		bgt s5,t0,clsb	;Clearscreen if off bottom
		nop

	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4	;Add 4 to the Stack pointer
	jr ra			;Return
	nop
	
	
cls:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
clsb:
		li s2,0				;Xpos
		li s5,0				;Ypos

		li s3,0x20			;Char
		li s6,0				;CharInc
		li s1,30			;Width
		li s4,20			;Height
		jal fillarea
		nop
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
PrintNumber:
	addiu s0,s0,48
PrintChar:	;PrintChar s0 at X,Y pos s2,s5
		andi s2,s2,255
		andi s5,s5,255
		
		move t1,s2		;Xpos in chars
		sll t1,3 		;*8
		
		move t2,s5		;Ypos in chars
		sll t2,3 		;*8

		lui t4,0x1F80 	;IO_BASE
		
;Define window in Vram
		;Byte 0: GPU Command
		li t3,0xA0000000	;A0=Send image to Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 1: XY Pos - 0xYYYYXXXX 
		sll t3,t2,16 		;0xYYYY----
		addu t3,t1 			;0x----XXXX
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00080008 	;8x8 Char
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
		
;Calculate source pattern		
		move t7,s0			;Char to show
		addi t7,-32			;No Char below space
		
		li t5,64			;Character not Lowercase?
		bltu t7,t5,NotLowerCase
		nop
		addi t7,-32			;Convert to Uppercase
NotLowerCase:
		
		sll t7,7 			;8*8*2=128 bytes per char
		la t2,MyFont  		;Font Source
		addu t7,t2		

;Transfer pattern to VRAM
		li t1,(8*8/2)	 	;Bytes to send (8x8 - 2 pixels per byte)
		
		;Byte 3+: Pixel Data 0x22221111
SendFontData:
		lw t2,0(t7) 		;Get 2 pixels
		
		addiu t7,4  		;Move to next word
		sw t2,0x1810(t4) 	;send pixel Data - 0x22221111
		
		subiu t1,1 			;Decrease loop counter 
		bnez t1,SendFontData 
		nop
			  
		addiu s2,1		;Xpos++
	jr ra
	nop
 
 
 
 
PrintString:				;Print String s3
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
DrawChars:		
		lbu s0,0(s3) 	;Load a character
		addiu s3,1 		;Move to next Char
		
		li t0,255		;Compare to 255
		beq t0,s0,PrintString_Done	;Done?
		nop
		
		jal PrintChar	;Show Character s3 to the screen
		nop
		
		j DrawChars		;Repeat
		nop
PrintString_Done:	
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
	
	
ReadJoystick:
	li a3,JoyData
	lbu a0,2(a3)		;Read in joystick directions
	nop
	srl a0,a0,4
	andi s0,a0,0b00000001	;U
	
	srl a0,a0,1
	andi a0,a0,0b00000110	;DL
	or s0,s0,a0
	
	lbu a0,2(a3)		;Read in joystick directions
	nop
	srl a0,a0,2			
	andi a0,a0,0b00001000	;R
	or s0,s0,a0
	
	lbu a0,3(a3)		;Read in joystick fires
	nop					;Load delay slot
	
	andi a0,a0,0b11110000	;Fires
	or s0,s0,a0
	
	jr ra
	nop
	
;byte 	b7 		b6 		b5 		b4 		b3 		b2 		b1 		b0
;0 --- N.A.
;1 0x41 'A'
;2 0x5a 'Z'
;3 		LEFT 	DOWN 	RGHT 	UP 		START 	1 		1 		SELECT
;4 		SQUARE 	X 		O 		TRIANGL R1 		L1 		R2 		L2	
	



MyFont:	;4 lines per char (Little Endian)
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  0  - Ofst:&0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  1  - Ofst:&20
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  2  - Ofst:&40
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  3  - Ofst:&60
	.dw 0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;  4  - Ofst:&80
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;  5  - Ofst:&A0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  6  - Ofst:&C0
	.dw 0x80008000,0xC2108000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  7  - Ofst:&E0
	.dw 0x80008000,0x8000FBDE,0x8000FBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;  8  - Ofst:&100
	.dw 0x80008000,0x8000FBDE,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;  9  - Ofst:&120
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 10  - Ofst:&140
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 11  - Ofst:&160
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x8000FBDE,0x8000FBDE,0x80008000     ; 12  - Ofst:&180
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0x80008000,0x8000FBDE,0x8000FBDE,0x80008000     ; 13  - Ofst:&1A0
	.dw 0xC2108000,0xC210FBDE,0xC210FBDE,0x80008000,0x80008000,0x8000C210,0x8000C210,0x80008000     ; 14  - Ofst:&1C0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 15  - Ofst:&1E0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 16  - Ofst:&200
	.dw 0xFBDE8000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ; 17  - Ofst:&220
	.dw 0x80008000,0xFBDE8000,0x80008000,0x8000FBDE,0xC2108000,0xC210FBDE,0xC210FBDE,0x80008000     ; 18  - Ofst:&240
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 19  - Ofst:&260
	.dw 0x80008000,0x80008000,0x80008000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x80008000     ; 20  - Ofst:&280
	.dw 0xFBDEFBDE,0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x80008000,0x80008000     ; 21  - Ofst:&2A0
	.dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x80008000,0xC2108000,0x8000FBDE     ; 22  - Ofst:&2C0
	.dw 0x8000C210,0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ; 23  - Ofst:&2E0
	.dw 0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0x8000FBDE,0x8000FBDE,0x80008000     ; 24  - Ofst:&300
	.dw 0x80008000,0x8000FBDE,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000,0x8000FBDE     ; 25  - Ofst:&320
	.dw 0x8000FBDE,0xFBDE8000,0xFBDE8000,0x80008000,0x8000FBDE,0x80008000,0xC210FBDE,0x80008000     ; 26  - Ofst:&340
	.dw 0xC2108000,0xC210C210,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ; 27  - Ofst:&360
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000     ; 28  - Ofst:&380
	.dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 29  - Ofst:&3A0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 30  - Ofst:&3C0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 31  - Ofst:&3E0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ; 32  - Ofst:&400
	.dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000     ; 33  - Ofst:&420
	.dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 34  - Ofst:&440
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 35  - Ofst:&460
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ; 36  - Ofst:&480
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ; 37  - Ofst:&4A0
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 38  - Ofst:&4C0
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 39  - Ofst:&4E0
	.dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0xFBDE8000,0x80008000,0x8000FBDE,0xFBDE8000     ; 40  - Ofst:&500
	.dw 0x80008000,0x8000FBDE,0x8000FBDE,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000     ; 41  - Ofst:&520
	.dw 0x80008000,0xFBDE8000,0xFBDE8000,0x80008000,0x80008000,0x8000FBDE,0x80008000,0x8000FBDE     ; 42  - Ofst:&540
	.dw 0xC2108000,0x80008000,0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000     ; 43  - Ofst:&560
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ; 44  - Ofst:&580
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 45  - Ofst:&5A0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 46  - Ofst:&5C0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 47  - Ofst:&5E0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 48  - Ofst:&600
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 49  - Ofst:&620
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 50  - Ofst:&640
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0xC210C210,0x80008000,0x80008000     ; 51  - Ofst:&660
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 52  - Ofst:&680
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 53  - Ofst:&6A0
	.dw 0xC2108000,0xC210C210,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ; 54  - Ofst:&6C0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 55  - Ofst:&6E0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 56  - Ofst:&700
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 57  - Ofst:&720
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 58  - Ofst:&740
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 59  - Ofst:&760
	.dw 0x80008000,0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x80008000     ; 60  - Ofst:&780
	.dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x80008000,0x80008000     ; 61  - Ofst:&7A0
	.dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000     ; 62  - Ofst:&7C0
	.dw 0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 63  - Ofst:&7E0
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE     ; 64  - Ofst:&800
	.dw 0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE     ; 65  - Ofst:&820
	.dw 0xFBDEC210,0xC2108000,0xFBDE8000,0x8000C210,0xC210C210,0x80008000,0xC2108000,0x8000C210     ; 66  - Ofst:&840
	.dw 0xC2108000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 67  - Ofst:&860
	.dw 0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ; 68  - Ofst:&880
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ; 69  - Ofst:&8A0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 70  - Ofst:&8C0
	.dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 71  - Ofst:&8E0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 72  - Ofst:&900
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ; 73  - Ofst:&920
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ; 74  - Ofst:&940
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 75  - Ofst:&960
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 76  - Ofst:&980
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000     ; 77  - Ofst:&9A0
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ; 78  - Ofst:&9C0
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 79  - Ofst:&9E0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ; 80  - Ofst:&A00
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000     ; 81  - Ofst:&A20
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC210FBDE,0x80008000     ; 82  - Ofst:&A40
	.dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 83  - Ofst:&A60
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 84  - Ofst:&A80
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ; 85  - Ofst:&AA0
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ; 86  - Ofst:&AC0
	.dw 0x80008000,0xC210C210,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ; 87  - Ofst:&AE0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 88  - Ofst:&B00
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ; 89  - Ofst:&B20
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ; 90  - Ofst:&B40
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 91  - Ofst:&B60
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ; 92  - Ofst:&B80
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ; 93  - Ofst:&BA0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ; 94  - Ofst:&BC0
	.dw 0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 95  - Ofst:&BE0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ; 96  - Ofst:&C00
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ; 97  - Ofst:&C20
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ; 98  - Ofst:&C40
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ; 99  - Ofst:&C60
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;100  - Ofst:&C80
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;101  - Ofst:&CA0
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;102  - Ofst:&CC0
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;103  - Ofst:&CE0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;104  - Ofst:&D00
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;105  - Ofst:&D20
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;106  - Ofst:&D40
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;107  - Ofst:&D60
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;108  - Ofst:&D80
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;109  - Ofst:&DA0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;110  - Ofst:&DC0
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0xC210C210,0x80008000,0x80008000     ;111  - Ofst:&DE0
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000     ;112  - Ofst:&E00
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;113  - Ofst:&E20
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0x80008000     ;114  - Ofst:&E40
	.dw 0x80008000,0x80008000,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;115  - Ofst:&E60
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;116  - Ofst:&E80
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x80008000     ;117  - Ofst:&EA0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;118  - Ofst:&EC0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;119  - Ofst:&EE0
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000,0x80008000     ;120  - Ofst:&F00
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;121  - Ofst:&F20
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xC2108000,0xC210FBDE,0x80008000,0x80008000     ;122  - Ofst:&F40
	.dw 0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;123  - Ofst:&F60
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDE8000,0x8000FBDE     ;124  - Ofst:&F80
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000     ;125  - Ofst:&FA0
	.dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000C210,0x80008000     ;126  - Ofst:&FC0
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;127  - Ofst:&FE0
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x8000FBDE     ;128  - Ofst:&1000
	.dw 0x8000FBDE,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x8000FBDE,0xFBDEFBDE,0xFBDE8000,0x8000FBDE     ;129  - Ofst:&1020
	.dw 0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000C210,0xC210FBDE,0xC210FBDE,0x80008000,0x80008000     ;130  - Ofst:&1040
	.dw 0xC2108000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;131  - Ofst:&1060
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;132  - Ofst:&1080
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;133  - Ofst:&10A0
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;134  - Ofst:&10C0
	.dw 0x80008000,0x8000C210,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;135  - Ofst:&10E0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;136  - Ofst:&1100
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;137  - Ofst:&1120
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;138  - Ofst:&1140
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;139  - Ofst:&1160
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;140  - Ofst:&1180
	.dw 0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000     ;141  - Ofst:&11A0
	.dw 0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x80008000     ;142  - Ofst:&11C0
	.dw 0x80008000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;143  - Ofst:&11E0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x80008000     ;144  - Ofst:&1200
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;145  - Ofst:&1220
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x80008000     ;146  - Ofst:&1240
	.dw 0x80008000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;147  - Ofst:&1260
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;148  - Ofst:&1280
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0x8000FBDE,0x80008000     ;149  - Ofst:&12A0
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;150  - Ofst:&12C0
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;151  - Ofst:&12E0
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;152  - Ofst:&1300
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0xFBDEFBDE,0x8000FBDE,0x80008000     ;153  - Ofst:&1320
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000,0x80008000     ;154  - Ofst:&1340
	.dw 0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;155  - Ofst:&1360
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;156  - Ofst:&1380
	.dw 0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000     ;157  - Ofst:&13A0
	.dw 0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;158  - Ofst:&13C0
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;159  - Ofst:&13E0
	.dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;160  - Ofst:&1400
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;161  - Ofst:&1420
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;162  - Ofst:&1440
	.dw 0x80008000,0x8000C210,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;163  - Ofst:&1460
	.dw 0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;164  - Ofst:&1480
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;165  - Ofst:&14A0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;166  - Ofst:&14C0
	.dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;167  - Ofst:&14E0
	.dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;168  - Ofst:&1500
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;169  - Ofst:&1520
	.dw 0xFBDE8000,0x80008000,0xFBDEFBDE,0x80008000,0xC210FBDE,0xC210FBDE,0xC210FBDE,0x80008000     ;170  - Ofst:&1540
	.dw 0xC2108000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;171  - Ofst:&1560
	.dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;172  - Ofst:&1580
	.dw 0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0x8000FBDE,0x80008000     ;173  - Ofst:&15A0
	.dw 0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;174  - Ofst:&15C0
	.dw 0x80008000,0x8000C210,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;175  - Ofst:&15E0
	.dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;176  - Ofst:&1600
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;177  - Ofst:&1620
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;178  - Ofst:&1640
	.dw 0x80008000,0xC210C210,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;179  - Ofst:&1660
	.dw 0xFBDE8000,0x80008000,0xFBDE8000,0x80008000,0xFBDEFBDE,0x8000FBDE,0xFBDEFBDE,0x8000FBDE     ;180  - Ofst:&1680
	.dw 0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE     ;181  - Ofst:&16A0
	.dw 0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xC210FBDE,0xFBDE8000,0xC2108000,0x8000FBDE     ;182  - Ofst:&16C0
	.dw 0xC2108000,0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;183  - Ofst:&16E0
	.dw 0xFBDE8000,0x80008000,0xFBDE8000,0x80008000,0xFBDEFBDE,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;184  - Ofst:&1700
	.dw 0xFBDEFBDE,0xFBDEFBDE,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0xFBDE8000,0xFBDEFBDE,0x8000FBDE     ;185  - Ofst:&1720
	.dw 0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x8000FBDE,0xC210FBDE,0x80008000,0xC2108000,0x8000FBDE     ;186  - Ofst:&1740
	.dw 0xC2108000,0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;187  - Ofst:&1760
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;188  - Ofst:&1780
	.dw 0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE     ;189  - Ofst:&17A0
	.dw 0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC210FBDE,0x80008000     ;190  - Ofst:&17C0
	.dw 0x80008000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;191  - Ofst:&17E0
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;192  - Ofst:&1800
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;193  - Ofst:&1820
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000,0x80008000     ;194  - Ofst:&1840
	.dw 0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;195  - Ofst:&1860
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;196  - Ofst:&1880
	.dw 0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE     ;197  - Ofst:&18A0
	.dw 0xFBDEFBDE,0x80008000,0x8000FBDE,0x8000FBDE,0xC2108000,0xC210C210,0xC2108000,0x80008000     ;198  - Ofst:&18C0
	.dw 0x80008000,0xC210C210,0x8000C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;199  - Ofst:&18E0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;200  - Ofst:&1900
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;201  - Ofst:&1920
	.dw 0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;202  - Ofst:&1940
	.dw 0x80008000,0x8000C210,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;203  - Ofst:&1960
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;204  - Ofst:&1980
	.dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;205  - Ofst:&19A0
	.dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;206  - Ofst:&19C0
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;207  - Ofst:&19E0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;208  - Ofst:&1A00
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;209  - Ofst:&1A20
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;210  - Ofst:&1A40
	.dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;211  - Ofst:&1A60
	.dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;212  - Ofst:&1A80
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;213  - Ofst:&1AA0
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;214  - Ofst:&1AC0
	.dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;215  - Ofst:&1AE0
	.dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;216  - Ofst:&1B00
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;217  - Ofst:&1B20
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xC210FBDE,0xC210FBDE,0x80008000     ;218  - Ofst:&1B40
	.dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;219  - Ofst:&1B60
	.dw 0xFBDE8000,0x80008000,0xFBDE8000,0x80008000,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE     ;220  - Ofst:&1B80
	.dw 0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE     ;221  - Ofst:&1BA0
	.dw 0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0xFBDEC210,0x8000C210,0xFBDEC210,0x8000C210     ;222  - Ofst:&1BC0
	.dw 0xC2108000,0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;223  - Ofst:&1BE0
	.dw 0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;224  - Ofst:&1C00
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000     ;225  - Ofst:&1C20
	.dw 0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xC210FBDE,0x80008000,0xC2108000,0x8000FBDE     ;226  - Ofst:&1C40
	.dw 0xC2108000,0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;227  - Ofst:&1C60
	.dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;228  - Ofst:&1C80
	.dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;229  - Ofst:&1CA0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;230  - Ofst:&1CC0
	.dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;231  - Ofst:&1CE0
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;232  - Ofst:&1D00
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;233  - Ofst:&1D20
	.dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;234  - Ofst:&1D40
	.dw 0xC2108000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;235  - Ofst:&1D60
	.dw 0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000     ;236  - Ofst:&1D80
	.dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000     ;237  - Ofst:&1DA0
	.dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC210FBDE,0x80008000,0x80008000     ;238  - Ofst:&1DC0
	.dw 0x80008000,0xC2108000,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;239  - Ofst:&1DE0
	.dw 0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000     ;240  - Ofst:&1E00
	.dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x80008000,0x80008000     ;241  - Ofst:&1E20
	.dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xC2108000,0x80008000     ;242  - Ofst:&1E40
	.dw 0x80008000,0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;243  - Ofst:&1E60
	.dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;244  - Ofst:&1E80
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;245  - Ofst:&1EA0
	.dw 0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC210FBDE,0x80008000     ;246  - Ofst:&1EC0
	.dw 0x80008000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;247  - Ofst:&1EE0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;248  - Ofst:&1F00
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;249  - Ofst:&1F20
	.dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;250  - Ofst:&1F40
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000C210,0x80008000     ;251  - Ofst:&1F60
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;252  - Ofst:&1F80
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;253  - Ofst:&1FA0
	.dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;254  - Ofst:&1FC0
	.dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000C210,0x80008000     ;255  - Ofst:&1FE0
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;256  - Ofst:&2000
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;257  - Ofst:&2020
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;258  - Ofst:&2040
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000C210,0x80008000     ;259  - Ofst:&2060
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;260  - Ofst:&2080
	; .dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;261  - Ofst:&20A0
	; .dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xC210FBDE,0x80008000,0xC210FBDE,0x80008000     ;262  - Ofst:&20C0
	; .dw 0xC2108000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;263  - Ofst:&20E0
	; .dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;264  - Ofst:&2100
	; .dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;265  - Ofst:&2120
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;266  - Ofst:&2140
	; .dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;267  - Ofst:&2160
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;268  - Ofst:&2180
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;269  - Ofst:&21A0
	; .dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;270  - Ofst:&21C0
	; .dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;271  - Ofst:&21E0
	; .dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;272  - Ofst:&2200
	; .dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000     ;273  - Ofst:&2220
	; .dw 0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000,0xC210FBDE,0x80008000,0xC210FBDE,0x80008000     ;274  - Ofst:&2240
	; .dw 0xC2108000,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;275  - Ofst:&2260
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;276  - Ofst:&2280
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;277  - Ofst:&22A0
	; .dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0xC2108000,0x8000FBDE,0x80008000,0x80008000     ;278  - Ofst:&22C0
	; .dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;279  - Ofst:&22E0
	; .dw 0x80008000,0xFBDE8000,0xFBDEFBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDE8000,0x8000FBDE     ;280  - Ofst:&2300
	; .dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000     ;281  - Ofst:&2320
	; .dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC210FBDE,0x80008000,0x80008000     ;282  - Ofst:&2340
	; .dw 0x80008000,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;283  - Ofst:&2360
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;284  - Ofst:&2380
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;285  - Ofst:&23A0
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;286  - Ofst:&23C0
	; .dw 0x80008000,0x80008000,0xC2108000,0x8000C210,0x80008000,0xC210C210,0xC210C210,0x80008000     ;287  - Ofst:&23E0
	; .dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;288  - Ofst:&2400
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDE8000,0x8000FBDE     ;289  - Ofst:&2420
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;290  - Ofst:&2440
	; .dw 0x80008000,0x8000C210,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;291  - Ofst:&2460
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;292  - Ofst:&2480
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;293  - Ofst:&24A0
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;294  - Ofst:&24C0
	; .dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;295  - Ofst:&24E0
	; .dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x80008000     ;296  - Ofst:&2500
	; .dw 0x80008000,0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE     ;297  - Ofst:&2520
	; .dw 0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x8000FBDE,0xC2108000,0x8000FBDE     ;298  - Ofst:&2540
	; .dw 0xC2108000,0x8000C210,0xC2108000,0x8000C210,0x80008000,0xC210C210,0xC210C210,0x80008000     ;299  - Ofst:&2560
	; .dw 0x80008000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;300  - Ofst:&2580
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;301  - Ofst:&25A0
	; .dw 0xFBDE8000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xC2108000,0x8000FBDE,0xC210FBDE,0x80008000     ;302  - Ofst:&25C0
	; .dw 0x80008000,0x8000C210,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;303  - Ofst:&25E0
	; .dw 0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;304  - Ofst:&2600
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;305  - Ofst:&2620
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000     ;306  - Ofst:&2640
	; .dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;307  - Ofst:&2660
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;308  - Ofst:&2680
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;309  - Ofst:&26A0
	; .dw 0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xC210FBDE,0xC2108000,0xC2108000,0x8000FBDE     ;310  - Ofst:&26C0
	; .dw 0xC210C210,0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;311  - Ofst:&26E0
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;312  - Ofst:&2700
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;313  - Ofst:&2720
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;314  - Ofst:&2740
	; .dw 0x80008000,0x8000C210,0xC2108000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;315  - Ofst:&2760
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;316  - Ofst:&2780
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;317  - Ofst:&27A0
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;318  - Ofst:&27C0
	; .dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;319  - Ofst:&27E0
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;320  - Ofst:&2800
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;321  - Ofst:&2820
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0xC210FBDE,0xC210FBDE,0x80008000     ;322  - Ofst:&2840
	; .dw 0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000     ;323  - Ofst:&2860
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;324  - Ofst:&2880
	; .dw 0xFBDE8000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000     ;325  - Ofst:&28A0
	; .dw 0xFBDEFBDE,0x80008000,0xFBDEFBDE,0x80008000,0xC2108000,0xC210FBDE,0xC210FBDE,0x80008000     ;326  - Ofst:&28C0
	; .dw 0x80008000,0x80008000,0xC210C210,0x80008000,0x80008000,0x80008000,0x8000C210,0x80008000     ;327  - Ofst:&28E0
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;328  - Ofst:&2900
	; .dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;329  - Ofst:&2920
	; .dw 0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000FBDE,0x80008000,0x80008000     ;330  - Ofst:&2940
	; .dw 0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;331  - Ofst:&2960
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;332  - Ofst:&2980
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000     ;333  - Ofst:&29A0
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC2108000,0x8000FBDE     ;334  - Ofst:&29C0
	; .dw 0xC2108000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;335  - Ofst:&29E0
	; .dw 0x80008000,0xFBDE8000,0x80008000,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000     ;336  - Ofst:&2A00
	; .dw 0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000,0x80008000,0xFBDEFBDE,0x80008000,0x80008000     ;337  - Ofst:&2A20
	; .dw 0x80008000,0xFBDEFBDE,0x80008000,0x80008000,0x80008000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;338  - Ofst:&2A40
	; .dw 0x80008000,0xC2108000,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;339  - Ofst:&2A60
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;340  - Ofst:&2A80
	; .dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;341  - Ofst:&2AA0
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xC2108000,0x8000FBDE,0xC2108000,0x8000FBDE     ;342  - Ofst:&2AC0
	; .dw 0x80008000,0xC210C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;343  - Ofst:&2AE0
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;344  - Ofst:&2B00
	; .dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;345  - Ofst:&2B20
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xC210FBDE,0xC210FBDE,0x80008000     ;346  - Ofst:&2B40
	; .dw 0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;347  - Ofst:&2B60
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;348  - Ofst:&2B80
	; .dw 0xFBDE8000,0x80008000,0xFBDE8000,0x80008000,0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE     ;349  - Ofst:&2BA0
	; .dw 0xFBDEFBDE,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xC210FBDE,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;350  - Ofst:&2BC0
	; .dw 0xC2108000,0x8000C210,0xC210C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;351  - Ofst:&2BE0
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;352  - Ofst:&2C00
	; .dw 0xFBDEFBDE,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0xFBDEFBDE,0x80008000     ;353  - Ofst:&2C20
	; .dw 0x80008000,0xFBDEFBDE,0x8000FBDE,0x80008000,0xC2108000,0x8000FBDE,0xC210FBDE,0x80008000     ;354  - Ofst:&2C40
	; .dw 0xC210C210,0x80008000,0xC2108000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;355  - Ofst:&2C60
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;356  - Ofst:&2C80
	; .dw 0x80008000,0x8000FBDE,0xFBDE8000,0x80008000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE     ;357  - Ofst:&2CA0
	; .dw 0xFBDE8000,0x8000FBDE,0xFBDE8000,0x8000FBDE,0x80008000,0xC210FBDE,0xC210FBDE,0x8000FBDE     ;358  - Ofst:&2CC0
	; .dw 0x80008000,0x80008000,0xC2108000,0x8000C210,0xC2108000,0xC210C210,0xC210C210,0x80008000     ;359  - Ofst:&2CE0
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;360  - Ofst:&2D00
	; .dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0x80008000     ;361  - Ofst:&2D20
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC210FBDE,0x80008000,0x80008000     ;362  - Ofst:&2D40
	; .dw 0xC2108000,0xC210C210,0xC210C210,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000     ;363  - Ofst:&2D60
	; .dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x8000FBDE,0x80008000     ;364  - Ofst:&2D80
	; .dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0x8000C210,0x80008000     ;365  - Ofst:&2DA0
	; .dw 0xFBDE8000,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0xFBDE8000,0xFBDE8000,0xFBDE8000     ;366  - Ofst:&2DC0
	; .dw 0xFBDE8000,0xFBDE8000,0xFBDE8000,0xC210FBDE,0xC2108000,0xC210C210,0xC2108000,0x80008000     ;367  - Ofst:&2DE0
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0x80008000,0xFBDE8000,0x80008000     ;368  - Ofst:&2E00
	; .dw 0x80008000,0x80008000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0xC210C210,0x80008000     ;369  - Ofst:&2E20
	; .dw 0xFBDE8000,0xFBDE8000,0xFBDE8000,0x8000FBDE,0xFBDE8000,0xFBDE8000,0xFBDE8000,0xFBDE8000     ;370  - Ofst:&2E40
	; .dw 0xFBDE8000,0xFBDE8000,0xFBDE8000,0xC210FBDE,0xC2108000,0xC210C210,0xC2108000,0x80008000     ;371  - Ofst:&2E60
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;372  - Ofst:&2E80
	; .dw 0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;373  - Ofst:&2EA0
	; .dw 0xC2108000,0xFBDEFBDE,0xFBDEFBDE,0x8000C210,0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE     ;374  - Ofst:&2EC0
	; .dw 0xC210FBDE,0xC210C210,0xC210C210,0xFBDEC210,0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE     ;375  - Ofst:&2EE0
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDEFBDE,0xFBDEFBDE,0x80008000     ;376  - Ofst:&2F00
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xC2108000,0x8000C210,0x80008000     ;377  - Ofst:&2F20
	; .dw 0x80008000,0xFBDE8000,0x8000FBDE,0x80008000,0x80008000,0xFBDE8000,0x8000FBDE,0x80008000     ;378  - Ofst:&2F40
	; .dw 0xC2108000,0xFBDEFBDE,0xFBDEFBDE,0x8000FBDE,0xFBDEC210,0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE     ;379  - Ofst:&2F60
	; .dw 0x80008000,0x8000FBDE,0x80008000,0x8000FBDE,0xFBDE8000,0xFBDEFBDE,0xFBDE8000,0xFBDEFBDE     ;380  - Ofst:&2F80
	; .dw 0xFBDE8000,0xFBDEFBDE,0xFBDEFBDE,0xFBDEFBDE,0xC2108000,0xFBDEFBDE,0xFBDEFBDE,0xC210FBDE     ;381  - Ofst:&2FA0
	; .dw 0x80008000,0xFBDEC210,0xFBDEFBDE,0x8000C210,0x80008000,0xC2108000,0xC210FBDE,0x80008000     ;382  - Ofst:&2FC0
	; .dw 0x80008000,0x80008000,0x8000C210,0x80008000,0x80008000,0x80008000,0x80008000,0x80008000     ;383  - Ofst:&2FE0
	
.close