;s0	r0  A				
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag
	


SlowDown:		;For systesm that are too fast

Pause50:
	li s0,50	;Wait for 50
	
PauseA:			;Pause for S0
	andi s0,s0,0xFF
	.ifdef BuildN64
		sll s0,s0,13
	.endif
	.ifdef BuildPSX
		sll s0,s0,14
	.endif
	
PauseAAgain:
	;nop
	
	addi s0,s0,-1
	bne s0,zero,PauseAAgain
	nop
	
	jr ra		;Return
	nop



DoLdir:	;Copy S1 bytes from S3 to S2 (Ascending)
	lbu s0,(s3)			;Get a byte
	addi s3,s3,1		;inc
	
	sb s0,(s2)			;Save a byte
	addi s2,s2,1		;inc
	
	addi s1,s1,-1		
	bne s1,zero,DoLdir
	nop
	
	jr ra				;Return
	nop

	
DoLddr: ;Copy S1 bytes from S3 to S2 (Descemding)
	lbu s0,(s3)			;Get a byte
	addi s3,s3,-1		;dec 
	
	sb s0,(s2)			;Save a byte
	addi s2,s2,-1		;dec
	
	addi s1,s1,-1
	bne s1,zero,DoLddr
	nop
	jr ra				;Return
	nop
	


joyaxis:		;S0/a=val s4/c=joypresses
	move s1,s0
	
	andi t0,s4,0b00000001	;up or left
	bne t0,zero,notupleft
	nop
	
	addi s0,s0,-1			;Pos--

notupleft:
	andi t0,s4,0b00000010	;down or right
	bne t0,zero,notdownright
	nop
	
	addi s0,s0,1			;Pos++
	
notdownright:
	srl s4,s4,2

	jr ra				;Return
	nop
	
	
	
WaitForFire:		;Pause for a fire press
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
		jal WaitForRelease		;Wait for fire to be released
		nop
WaitForFire2:
		jal DoRandom			;Re-seed the random generator
		nop
		jal ReadJoystick		;Read from the joystick
		nop
				;    SSBARLDU
		andi t0,s0,0b00010000	;Test Fire
		bne t0,zero,WaitForFire2 ;Not Preseed? Then repeat
		nop	
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	

WaitForRelease:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack	
WaitForReleaseB:	
		jal ReadJoystick	;SSBARLDU
		nop
				
		li t0,255			;255=No button pressed
		bne s0,t0,WaitForReleaseB ;Repeat until fire released
		nop
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
	
	

ShowDecimal:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s6,0(sp)			;Put the register onto the stack
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s4,0(sp)			;Put the register onto the stack
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s1,0(sp)			;Put the register onto the stack
	
		li s6,100
		jal DivideAbyH	;Digit 1	2--
		nop
		
		li s6,10
		move s0,s1
		jal DivideAbyH	;Digit 2	-5-
		nop
		
		move s0,s1
		jal PrintNumber	;Digit 3	--5
		nop
		
	lw s1,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	lw s4,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	lw s6,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
		
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
DivideAbyH:		;Divide S0 by S6, remainder in S1
	li s4,0				;S4/C=Count
	
	andi s0,s0,255
	andi s6,s6,255
	
DivideBbyHagain:
	bgt s6,s0,DivideBbyH_LessThan	;Still S0/A>=S6/H
	nop
	
	addi s4,s4,1		;Yes! Count+1
	sub s0,s0,s6		;-S6/H
	j DivideBbyHagain
	nop
	
DivideBbyH_LessThan:
	move s1,s0			;Remainder
	move s0,s4			;Count
	j PrintNumber		;Print S0/A as a digit
	nop
	

		
	

RangeTest: ;ensure S0/A is between S2/D and S5/E (>=S2 <S5)
	andi s0,s0,255
	andi s2,s2,255
	andi s5,s5,255
			
	blt s0,s2,RangeTest_OutOfRange		;Below S2
	nop
	bge s0,s5,RangeTest_OutOfRange		;Above S5
	nop
	
	li v1,0				;Carry Clear (In Range)
	jr ra				;Return
	nop
		
RangeTest_OutOfRange:
	li v1,1				;Carry Set (Our of range)
	jr ra				;Return
	nop
	
	
rangelimit:				;reset a=b if over range de
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
			
		jal rangetest
		nop
		
		beq v1,zero,lbl60376 ;Carry Clear = Val OK
		nop
		
		andi s1,s1,255
		move s0,s1
lbl60376:
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
RandomSeed equ ramarea	;2 Bytes

DoRandom:		;Return a random byte in S0
	li t0,RandomSeed		
	
	lhu t3,0(t0)		;16 bit seed
	
	lbu t1,0(t0)		;8 bit parts
	lbu t2,1(t0)	
	
	addi t3,t3,1		;INC Seed (16 bit)
	sh t3,0(t0)
	
	xor s0,t1,t2		;EOR two seeds together
	
	sll t1,t1,3
	srl t2,t2,4
	
	xor s0,s0,t1		;EOR two seeds together
	xor s0,s0,t2		;EOR two seeds together
		
	xor s0,s0,t4
	xor s0,s0,t5
	xor s0,s0,t6
	xor s0,s0,t7
	xor s0,s0,t8
	xor s0,s0,t9
	
	xor s0,s0,a0
	xor s0,s0,a1
	xor s0,s0,a2
	xor s0,s0,a3

	andi s0,s0,255		;Limit to one byte
		
	jr ra		;Return
	nop
	
	
	

RangedRandom: 	;Return a value between S2/D and S5/E (>=D <E)

	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
RangedRandom_again: 
		jal DoRandom
		nop
		jal RangeTest
		nop
		bne v1,zero,RangedRandom_again	;Our of range (CS) V1=C V0=Z
		nop
		
RangedRandomDone: 
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	
	
ChibiSoundBeep:	
	j Pause50
	nop
	
ChibiSound:
	jr ra				;Return
	nop
	
	
printseqNC:
	move s5,s4
	addi s2,s2,1
	j printseq
	nop

printseqnl:
	move s2,s1
	addi s5,s5,1		;inc ypos

printseq:				;print seq S3 (hl) at location S2,S5 (de)
	andi s2,s2,255
	andi s5,s5,255
	move s1,s2
	move s4,s5

;&00     = empty (nothing drawn)
printseqb:
	li s0,0
	lbu s0,(s3)			;get a char
	addi s3,s3,1
	
	beq s0,zero,doprintchar ;0=empty char	
	nop
	
	li t0,32
	blt s0,t0,xposchange ;&01-&1f = new absolute xpos (use nl for xpos=0)
	nop
	
	li t0,0xE0
	bgt s0,t0,yposchange ;&e0-&f8 = new absolute ypos
	nop
	
	li t0,0xA0
	bgt s0,t0,sequenceh	;&a0-&bf = horizontal sequence of one char
	nop
	
doprintchar:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
		jal printchar	;&20-&9f = character
		nop

	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	
	j printseqb
	nop
	
	
sequenceh:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s1,0(sp)			;Put the register onto the stack
	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s4,0(sp)			;Put the register onto the stack
	
		li t0,0xC0
		bgt s0,t0,sequencev	;&c0-&df = vertical sequence of one char
		nop
		
		andi s0,s0,0x1F
		addi s1,s0,1		
		lbu s0,(s3)
		addi s3,s3,1

sequenceh2:
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw ra,0(sp)			;Put the register onto the stack
			jal printchar
			nop
			
		lw ra,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		addi s1,s1,-1
		bne s1,zero,sequenceh2
		nop

printseq_poprep:
	lw s4,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	
	lw s1,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	b printseqb
	

sequencev:
	andi s0,s0,0x1F
	addi s1,s0,1
	lbu s0,(s3)
	addi s3,s3,1

sequencev2:
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw ra,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s2,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s5,0(sp)			;Put the register onto the stack
		
			jal printchar
			nop
			
		lw s5,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		lw s2,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer	
		lw ra,0(sp)		;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer	
	addi s5,s5,1
	addi s1,s1,-1
	bne s1,zero,sequencev2
	nop
	j printseq_poprep
	nop

	
xposchange:
	move s2,s0 				;Set new Xpos
	j printseq
	nop

yposchange:
	li t0,251
	beq s0,t0,printseqfill	;&fb	 = fill area (w,h,char,inc)
	nop
	
	li t0,252
	beq s0,t0,printseqnc	;&fc 	 = new column (vertical)
	nop

	li t0,253
	beq s0,t0,printseqcrnl	;&fd     = new line (true)
	nop
	
	li t0,254
	beq s0,t0,printseqnl	;&fe     = new line (horizontal)
	nop
	
	li t0,255				;&ff     = end of list
	bne s0,t0,lbl22306		;yes? then return
	nop
	
	jr ra
	nop
	
lbl22306:
	move s2,s1
	andi s5,s0,0x1F			;Set new Ypos
	j printseqb
	nop

	
	
printseqfill:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s1,0(sp)			;Put the register onto the stack
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw s4,0(sp)			;Put the register onto the stack
	
		lbu s1,(s3)			;W
		addi s3,s3,1
		
		lbu s4,(s3)			;H
		addi s3,s3,1
		
		lbu s0,(s3)			;Char
		addi s3,s3,1

		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s3,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s6,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw ra,0(sp)			;Put the register onto the stack

			lbu s6,(s3)			;Inc
			addi s3,s3,1	

			move s3,s0
			jal fillarea
			nop
			
		lw ra,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		lw s6,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		lw s3,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		
		addi s3,s3,1
	j printseq_poprep
	nop

printseqcrnl:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack
	
		jal newline 		;zero x, move down a line
		nop
		
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	j printseq
	nop
	
	

FillArea:			;S3/H=Char 			S6/L=Char increment 
					;S2,S5/DE=X,Ypos 	S1,S4/BC=Wid,Hei
	addi sp,sp,-12		;Subtract 15 from Stack pointer
	sw ra,8(sp)			;Put the register onto the stack
	sw s2,4(sp)			;Put the register onto the stack
	sw s5,0(sp)			;Put the register onto the stack
	
FillAreaY:
		addi sp,sp,-16		;Subtract 16 from Stack pointer
		sw s1,12(sp)		;Put the register onto the stack
		sw s2,8(sp)			;Put the register onto the stack
		sw s4,4(sp)			;Put the register onto the stack
		sw s5,0(sp)			;Put the register onto the stack
		
FillAreaX:
			move s0,s3		;Get Char to print
			jal PrintChar
			nop
			add s0,s0,s6	;Inc Char
			move s3,s0
			addi s1,s1,-1
			
			bne s1,zero,FillAreaX
			nop
		lw s5,0(sp)			;Pop the register off the stack
		lw s4,4(sp)			;Pop the register off the stack
		lw s2,8(sp)			;Pop the register off the stack
		lw s1,12(sp)		;Pop the register off the stack
		addi sp,sp,16		;Add 16 to the Stack pointer
	
		addi s5,s5,1		;Down one line
		addi s4,s4,-1
		bne s4,zero,FillAreaY
		nop
		
	lw s5,0(sp)		;Pop the register off the stack
	lw s2,4(sp)		;Pop the register off the stack
	lw ra,8(sp)		;Pop the register off the stack
	addi sp,sp,12	;Add 12 to the Stack pointer
	jr ra			;Return
	nop
	
	