.psx
.create "\BldPSX\Prog.bin", 0x80010000

.definelabel UserRam,0x00020000

.org 0x80010000 ; Entry Point Of Code


	lui     a0,0x1F80 ;IO_BASE 

; Setup Screen Mode
		;   CCPPPPPP - CC = Command PPPPPP=Parameter
    li t0,0x00000000		;$00=Reset
    sw t0,0x1814(a0)	       ;GP0 Command Control 0x1F801814
	
    li t0,0x03000000		;$03=Display Enable
    sw t0,0x1814(a0)	       ;GP0 Command Control 0x1F801814
	
    li t0,0x08000001		;$80=Display Mode %RwI2VHWW (320x240 16bpp)
    sw t0,0x1814(a0)	       ;GP0 Command Control 0x1F801814
	
    li t0,0x06C60260		;$06= H Display Range 0xXXXxxx	 (3168-608)
    sw t0,0x1814(a0)	       ;GP0 Command Control 0x1F801814
	
    li t0,0x07042018        ;$07= V Display Range %yyyyyyyyyyYYYYYYYYYY	 (264-24)
	sw t0,0x1814(a0)	       ;GP0 Command Control 0x1F801814

	
	li t0,0xE1000400
    sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810
	
	li t0,0xE3000000		;$E3 - Drawing Area TopLeft - %YYYYYYYYYYXXXXXXXXXX
    sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810
	
	li t0,0xE403BD3F		;$E4 - Drawing area Bottom Right - %YYYYYYYYYYXXXXXXXXXX
    sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810
	
	li t0,0xE5000000		;$E5 - Drawing Offset - %YYYYYYYYYYYXXXXXXXXXXXX
    sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810

    li t0,0x02000000		;$02 - Fill Area 1- 0xBBBBBB - Background 
    sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810
    li t0,0x00000000		;$02 - Fill Area 2-0xYYYYXXXX - Topleft
    sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810
    li t0,0x0EF0013F		;$02 - Fill Area 3-0xHHHHWWWW - HeightWidth
	sw t0,0x1810(a0)			;GP0 Command Port 0x1F801810

	li sp,UserRam			;Init Stack Pointer
	
	
.include "\SrcAll\BasicMacros.asm"
  
CursorX equ 0x100 		;Defined symbols CursorX EQUals 0x100
CursorY equ 0x101

JoyData equ UserRam+0x200

	jal Cls				;Zero Graphics cursor pos
	nop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	j HardwareDirect
	nop
	
	;j UseBios
;	nop

;1F801040h 1/4	JOY_DATA Joypad/Memory Card Data (R/W)
;1F801044h 4	JOY_STAT Joypad/Memory Card Status (R)
;1F801048h 2	JOY_MODE Joypad/Memory Card Mode (R/W)
;1F80104Ah 2	JOY_CTRL Joypad/Memory Card Control (R/W)
;1F80104Eh 2	JOY_BAUD Joypad/Memory Card Baudrate (R/W) 
  
 
;Normal Pad timing flow ->
;		10000000 	1000010 	1011010 	1234567 	1234567
;CMD 	01h 		42h 		00h 		00h 		00h
;		xxxxxxxx 	10000010 	10100101 	1234567 	1234567
;DAT 	---- 		41h 		5ah 		SW.1 		SW.2

;byte 	b7 		b6 		b5 		b4 		b3 		b2 		b1 		b0
;0 --- N.A.
;1 0x41 'A'
;2 0x5a 'Z'
;3 		LEFT 	DOWN 	RGHT 	UP 		START 	1 		1 		SELECT
;4 		SQUARE 	X 		O 		TRIANGL R1 		L1 		R2 		L2

HardwareDirect:
HardwareDirectInfLoop:
	li t1,1F801040h		;1F801040h 1/4	JOY_DATA (R/W)
	
		;   FEDCBA9876543210
	li t2,0b0000000000000000
	sh t2,0xA(t1)		;1F80104Ah 2	JOY_CTRL (R/W)
	
	li t2,0xFFFF
	bal DoPause			;Wait a bit
	nop
	
	
	li t2,0x0088
	sh t2,0xE(t1)		;1F80104Eh 2	JOY_BAUD (R/W) 
	
	li t2,0x000D
	sh t2,0x8(t1)		;1F801048h 2	JOY_MODE (R/W)
		
		;   FEDCBA9876543210	D=Joy Port 
	li t2,0b0000000000000011	;Pad 1
	;li t2,0b0010000000000011	;Pad 2 (Can't get pad 2 working!)
	sh t2,0xA(t1)		;1F80104Ah 2	JOY_CTRL (R/W)
		
	li t2,0xFFFF
	bal DoPause
	nop
	
	
	li t2,0x01			;Cmd 1
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	li t2,0x42			;Cmd 2
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	
	li t2,0x0			;Cmd 3
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	li t2,0x0			;Cmd 4
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	li t2,0x0			;Cmd 5
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
		
	li t2,0x0			;Cmd 6
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	li t2,0x0			;Cmd 7
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	li t2,0x0			;Cmd 8
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
		
	li t2,0x0			;Cmd 9
	sw t2,0(t1)			;1F801040h 1/4	JOY_DATA (R/W)
	bal JoyWait			;Wait for reply
	nop
	jal MonitorJoy		;Show Reply Data / Status
	nop
	
	jal cls
	nop
	j HardwareDirectInfLoop		;Wait forever
	nop 				;Delay Slot
	
	
DoPause:	
	addi t2,t2,-1
	bne t2,zero,DoPause
	nop
	jr ra
	nop
	
	
JoyWait:	
	lw t2,4(t1)				;0x1F801044 JOY_STAT
	nop
	andi t2,t2,0b00000010	;RX FIFO Not Empty (0=Empty, 1=Not Empty)
	beq t2,zero,JoyWait		;Wait for reply
	nop
	jr ra
	
MonitorJoy:
	lbu a0,0(t1)			;0x1F801040 JOY_DATA
	lw a1,4(t1)  			;0x1F801044 JOY_STAT
	
MonitorA0A1:
	push ra
	pushAs
	pushTs
	    li t5,'a'
		li t6,'0'
		move t7,a0
		jal ShowRegTextB  	;A5 A6 : A7
		nop
		li t5,'a'
		li t6,'1'
		move t7,a1
		jal ShowRegTextB    ;A5 A6 : A7
		nop
		jal NewLine         
		nop
	popTs
	popAs
	pop ra
	jr ra
	nop	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
		
;Hardware
;1F801040h 1/4	JOY_DATA Joypad/Memory Card Data (R/W)
;1F801044h 4	JOY_STAT Joypad/Memory Card Status (R)
;1F801048h 2	JOY_MODE Joypad/Memory Card Mode (R/W)
;1F80104Ah 2	JOY_CTRL Joypad/Memory Card Control (R/W)
;1F80104Eh 2	JOY_BAUD Joypad/Memory Card Baudrate (R/W)



;Normal Pad timing flow ->
;		10000000 	1000010 	1011010 	1234567 	1234567
;CMD 	01h 		42h 		00h 		00h 		00h
;		xxxxxxxx 	10000010 	10100101 	1234567 	1234567
;DAT 	---- 		41h 		5ah 		SW.1 		SW.2

;byte 	b7 		b6 		b5 		b4 		b3 		b2 		b1 		b0
;0 --- N.A.
;1 0x41 'A'
;2 0x5a 'Z'
;3 		LEFT 	DOWN 	RGHT 	UP 		START 	1 		1 		SELECT
;4 		SQUARE 	X 		O 		TRIANGL R1 		L1 		R2 		L2


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; 1F801040h JOY_TX_DATA (W)
  ; 0-7   Data to be sent
  ; 8-31  Not used

 
; Writing to this register starts the transfer (if, or as soon as TXEN=1 and JOY_STAT.2=Ready), the written value is sent to the controller or memory card, and, simultaneously, a byte is received (and stored in RX FIFO if JOY_CTRL.1 or JOY_CTRL.2 is set).
; The "TXEN=1" condition is a bit more complex: Writing to SIO_TX_DATA latches the current TXEN value, and the transfer DOES start if the current TXEN value OR the latched TXEN value is set (ie. if TXEN gets cleared after writing to SIO_TX_DATA, then the transfer may STILL start if the old latched TXEN value was set).

; 1F801040h JOY_RX_DATA (R)
  ; 0-7   Received Data      (1st RX FIFO entry) (oldest entry)
  ; 8-15  Preview            (2nd RX FIFO entry)
  ; 16-23 Preview            (3rd RX FIFO entry)
  ; 24-31 Preview            (4th RX FIFO entry) (5th..8th cannot be previewed)

 
; A data byte can be read when JOY_STAT.1=1. Data should be read only via 8bit memory access (the 16bit/32bit "preview" feature is rather unusable, and usually there shouldn't be more than 1 byte in the FIFO anyways).

; 1F801044h JOY_STAT (R)
  ; 0     TX Ready Flag 1   (1=Ready/Started)
  ; 1     RX FIFO Not Empty (0=Empty, 1=Not Empty)
  ; 2     TX Ready Flag 2   (1=Ready/Finished)
  ; 3     RX Parity Error   (0=No, 1=Error; Wrong Parity, when enabled)  (sticky)
  ; 4     Unknown (zero)    (unlike SIO, this isn't RX FIFO Overrun flag)
  ; 5     Unknown (zero)    (for SIO this would be RX Bad Stop Bit)
  ; 6     Unknown (zero)    (for SIO this would be RX Input Level AFTER Stop bit)
  ; 7     /ACK Input Level  (0=High, 1=Low)
  ; 8     Unknown (zero)    (for SIO this would be CTS Input Level)
  ; 9     Interrupt Request (0=None, 1=IRQ7) (See JOY_CTRL.Bit4,10-12)   (sticky)
  ; 10    Unknown (always zero)
  ; 11-31 Baudrate Timer    (21bit timer, decrementing at 33MHz)

 

; 1F801048h JOY_MODE (R/W) (usually 000Dh, ie. 8bit, no parity, MUL1)
  ; 0-1   Baudrate Reload Factor (1=MUL1, 2=MUL16, 3=MUL64) (or 0=MUL1, too)
  ; 2-3   Character Length       (0=5bits, 1=6bits, 2=7bits, 3=8bits)
  ; 4     Parity Enable          (0=No, 1=Enable)
  ; 5     Parity Type            (0=Even, 1=Odd) (seems to be vice-versa...?)
  ; 6-7   Unknown (always zero)
  ; 8     Destroy Received Data  (0=Normal, 1=Force Data=FFh) (purpose unknown?)
  ; 9-15  Unknown (always zero)

 

; 1F80104Ah JOY_CTRL (R/W) (usually 1003h,3003h,0000h)
  ; 0     TX Enable (TXEN)  (0=Disable, 1=Enable)
  ; 1     /JOYn Output      (0=High, 1=Low/Select) (/JOYn as defined in Bit13)
  ; 2     RX Enable (RXEN)  (0=Normal, when /JOYn=Low, 1=Force Enable Once)
  ; 3     Unknown? (read/write-able) (for SIO, this would be TX Output Level)
  ; 4     Acknowledge       (0=No change, 1=Reset JOY_STAT.Bits 3,9)          (W)
  ; 5     Unknown? (read/write-able) (for SIO, this would be RTS Output Level)
  ; 6     Reset             (0=No change, 1=Reset most JOY_registers to zero) (W)
  ; 7     Not used             (always zero) (unlike SIO, no matter of FACTOR)
  ; 8-9   RX Interrupt Mode    (0..3 = IRQ when RX FIFO contains 1,2,4,8 bytes)
  ; 10    TX Interrupt Enable  (0=Disable, 1=Enable) ;when JOY_STAT.0-or-2 ;Ready
  ; 11    RX Interrupt Enable  (0=Disable, 1=Enable) ;when N bytes in RX FIFO
  ; 12    ACK Interrupt Enable (0=Disable, 1=Enable) ;when JOY_STAT.7  ;/ACK=LOW
  ; 13    Desired Slot Number  (0=/JOY1, 1=/JOY2) (set to LOW when Bit1=1)
  ; 14-15 Not used             (always zero)

 
; Caution: After slot selection (via Bits 1,13), one should issue a short delay (XXX: unknown length) before sending the the first data byte; this is required for controllers like Mouse and Analog Joypads (whilst Digital Joypads may work without that delay).

; 1F80104Eh JOY_BAUD (R/W) (usually 0088h, ie. circa 250kHz, when Factor=MUL1)
  ; 0-15  Baudrate Reload value for decrementing Baudrate Timer

 
; Timer reload occurs when writing to this register, and, automatically when the Baudrate Timer reaches zero. Upon reload, the 16bit Reload value is multiplied by the Baudrate Factor (see 1F801048h.Bit0-1), divided by 2, and then copied to the 21bit Baudrate Timer (1F801044h.Bit11-31). The 21bit timer decreases at 33MHz, and, it ellapses twice per bit (once for CLK=LOW and once for CLK=HIGH).
  ; BitsPerSecond = (44100Hz*300h) / MIN(((Reload*Factor) AND NOT 1),1)

 
; The default BAUD value is 0088h (equivalent to 44h cpu cycles), and default factor is MUL1, so CLK pulses are 44h cpu cycles LOW, and 44h cpu cycles HIGH, giving it a transfer rate of circa 250kHz per bit (33MHz divided by 88h cycles).
; Note: The Baudrate Timer is always running; even if there's no transfer in progress.

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	




UseBios:

;B(12h) InitPad(buf1,siz1,buf2,siz2)

	li t0,0xB0			;Bios Functions
	li t1,0x12			;12: InitPad
	
	la a0,JoyData		;Pad Dest
	li a1,0x22			;BufferSize
	li a2,JoyData+0x30	;Pad Dest 2
	li a3,0x22			;BufferSize 2
	jalr t0
	nop 
	
;B(13h) StartPad()
	
	li t0,0xB0			;Bios Functions
	li t1,0x13			;13: StartPad
	jalr t0
	nop 

InfLoopBios: 
	jal cls
	nop
	
	li a3,JoyData		;Load Test Values
	lw a0,0(a3)
	lw a1,4(a3)
	lw a2,8(a3)
	jal MonitorA0A1A2
	nop
	
	li t7,JoyData		;Address
	li t6,12			;Line Count
	
	jal MemDump			;Dump Ram to screen
	nop
	
	j InfLoopBios		;Wait forever
	nop 				;Delay Slot
	
	
	
 MonitorA0A1A2:
	push ra
	pushAs
	pushTs
	    li t5,'a'
		li t6,'0'
		move t7,a0
		jal ShowRegTextB                ;A5 A6 : A7
		nop
		li t5,'a'
		li t6,'1'
		move t7,a1
		jal ShowRegTextB                ;A5 A6 : A7
		nop
		li t5,'a'
		li t6,'2'
		move t7,a2
		jal ShowRegTextB                ;A5 A6 : A7
		nop
		jal NewLine         
		nop
	popTs
	popAs
	pop ra
	jr ra
	nop	 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
MyFont:
	.incbin "\ResPSX\ChibiAkumas.fnt"

Cls:
	li t7,UserRam
  
	li t8,0
	sb t8,CursorX(t7)
	sb t8,CursorY(t7)
	
	jr ra
	nop


PrintChar:	;PrintChar A1
    pushAll
		subiu a1,32			;No Characters below 32
	
		li t0,UserRam		
		lbu t1,CursorX(t0)	;Xpos in chars
		nop					;Load delay Slot
		sll t1,3 		;*8
		
		lbu t2,CursorY(t0)	;Ypos in chars
		nop					;Load delay Slot
		sll t2,3 		;*8

		lui t4,0x1F80 	;IO_BASE
		
		;Byte 0: GPU Command
		li t3,0xA0000000	;A0=Send image to Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 1: XY Pos - 0xYYYYXXXX 
		sll t3,t2,16 		;0xYYYY----
		addu t3,t1 			;0x----XXXX
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00080008 	;8x8 Char
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
	
		la t2,MyFont  		;Font Source
		sll a1,7 			;8*8*2=128 bytes per char
		addu a1,t2 ; A3 = Texture RAM Font Offset
			
		li t1,(8*8/2)-1 	;Bytes to send (8x8 - 2 pixels per byte, but 2 pixels per send)
		
		;Byte 3+: Pixel Data 0x22221111
SendFontData:
		lw t2,0(a1) 			;Get 2 pixels
		addiu a1,4  			;Move to next word
		sw t2,0x1810(t4) 		;send pixel Data - 0x22221111	Pixel 1 and 2 data
		bnez t1,SendFontData 
		subiu t1,1 				;Decrease loop counter (Delay Slot)
	  
		lbu t1,CursorX(t0)		;Get Xpos
		nop						;Load delay Slot
		addiu t1,1
		sb t1,CursorX(t0)		;Move across 1 char
 	popAll
	jr ra
	nop
 
 
 
 
PrintString:				;Print String A0
	pushAll		
DrawChars:		
		lbu a1,0(a0) 	;Load a character
		addiu a0,1 		;Move to next Char
		
		li t0,255		;Compare to 255
		beq t0,a1,PrintString_Done	;Done?
		nop
		
		jal PrintChar	;Show Character A0 to the screen
		nop
		
		j DrawChars		;Repeat
		nop
PrintString_Done:	
	popAll				
	jr ra				;Return
	nop
	
NewLine:
	Push t8
	Push t7
		li t7,UserRam
	
		lbu t8,CursorY(t7)
		nop						;Load delay Slot
		addiu t8,1
		sb t8,CursorY(t7)		;Move Down
	
		li t8,0
		sb t8,CursorX(t7)		;Zero Xpos
	pop t7
	pop t8
	jr ra
	nop

	
.include "\SrcAll\monitor.asm"  	

.close

;Bios:
;0x00b0 - 0x0012 - InitPad
;0x00b0 - 0x0013 - StartPad
;0x00b0 - 0x0014 - StopPAD
;0x00b0 - 0x0015 - PAD_init
;0x00b0 - 0x0016 - u_long PAD_dr()

