
		
	.macro LoadLE,src,dest
		li t8,0x0000
		lui t8,0xFFFF
		and dest,dest,t8
		
		lbu t9,1(src)
		lbu t8,(src)
		sll	t9,t9,8
		add dest,dest,t8
		add dest,dest,t9
	.endmacro

	.macro StoreLE,src,dest
		move t9,src
		sb t9,(dest)
		srl t9,t9,8
		sb t9,1(dest)
	.endmacro 
		
		
		
	
	.macro loadLEA0,off,dest		
		li t8,0x0000
		lui t8,0xFFFF
		and dest,dest,t8	
		lbu t9,off+1(a0)
		lbu t8,off(a0)
		sll	t9,t9,8
		add dest,dest,t8
		add dest,dest,t9
	.endmacro
	
	
	.macro StoreLEA0,src,off
		move t9,src
		sb t9,off(a0)
		srl t9,t9,8
		sb t9,off+1(a0)
	.endmacro 
	
		
	.macro db,p1		
		.db p1
	.endmacro

	.macro dwb,p1,p2,p3,p4
		;assert \p2<256,Byte Parameter is a word
		;assert \p3<1,Too many parameters
		;assert \p4<1,Too many parameters
		.dh p1
		.db p2
	.endmacro
	.macro dbw,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p3<1,Too many parameters
		;assert \p4<1,Too many parameters
		.db p1
		.dh p2
	.endmacro
	.macro dbb,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		;assert \p3<1,Too many parameters
		;assert \p4<1,Too many parameters
		.db p1,p2
	.endmacro
	
	.macro dbbw,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		;assert \p4<1,Too many parameters
		.db p1,p2
		.dh p3
	.endmacro
	
	.macro dbbb,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		;assert \p3<256,Byte Parameter is a word
		;assert \p4<1,Too many parameters
		.db p1,p2,p3
	.endmacro
	
	.macro dbwb,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p3<256,Byte Parameter is a word
		;assert \p4<1,Too many parameters
		.db p1
		.dh p2
		.db p3
	.endmacro
	.macro dbww,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p4<1,Too many parameters
		.db p1
		.dh p2,p3
	.endmacro
	.macro dbbww,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		.db p1,p2
		.dh p3,p4
	.endmacro
	.macro dbbbw,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		;assert \p3<256,Byte Parameter is a word
		.db p1,p2,p3
		.dh p4
	.endmacro
	.macro dbbwb,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		;assert \p4<256,Byte Parameter is a word
		.db p1,p2
		.dh p3
		.db p4
	.endmacro
	.macro dbbbb,p1,p2,p3,p4
		;assert \p1<256,Byte Parameter is a word
		;assert \p2<256,Byte Parameter is a word
		;assert \p3<256,Byte Parameter is a word
		;assert \p4<256,Byte Parameter is a word
		.db p1,p2,p3,p4
	.endmacro

	
VM_fHalt  equ  0b10000000	;HALT ocurred (Set Automatically)
VM_fSleep equ  0b01000000	;Sleep (Set Manually)
VM_fTrap  equ  0b00100000	;Trap Running (Set Manually)
VM_fError equ  0b00010000	;Unknown Opcode (Set Automatically) \ Syscall function \ Trap function
VM_fIntDis equ  0b00001000	;Interrupts disabled (Set Manually)
VM_fTrace equ  0b00000100	;Trace enabled (monitor after each command)
VM_fZero equ  0b00000010		;Last command resulted in Zero
VM_fCarry equ  0b00000001		;Last command resulted in Carry

VM_rR0 equ 0	;Accumulator A - 16 bit AK pair  (Default Destination for ops)
VM_rR1 equ 1	;K (Counter?)
VM_rR2 equ 2	;Accumulator B  - 16 bit UB Pair  (Default parameter for ops)
VM_rR3 equ 3	;U
VM_rR4 equ 4	;E - 16 bit DE pair 
VM_rR5 equ 5	;D
VM_rR6 equ 6	;L - 16 bit HL Pair
VM_rR7 equ 7	;H

vR0 equ 0
vR1 equ 1
vR2 equ 2
vR3 equ 3
vR4 equ 4
vR5 equ 5
vR6 equ 6
vR7 equ 7

VM_rF equ  8	;Flags 0bHSTEItZC (Halted) (Halted -Sleeping) (Trap running) (Error - unknown opcode) (Interrupt disabled) (Zero) (Carry) (t=trace)
VM_rFU equ 9	;Flags User (unused by cpu - backed up with PHF / PLF) 
VM_rPC equ 10	;Program Counter
VM_rSP equ 12	;Stack pointer
VM_rVB equ 14	;Vblanks (0-65535)

vm_rBank0 equ 32	;&0000-&3FFF 
vm_rBank1 equ 36	;&4000-&7FFF
vm_rBank2 equ 40	;&8000-&BFFF
vm_rBank3 equ 44	;&C000-&FFFF

	;ifd VASM
; vm_ParameterAddressingModesH equ vm_ParameterAddressingModes>>8
; vm_ParameterAddressingModesL equ vm_ParameterAddressingModes&255
	; else
; vm_ParameterAddressingModesH equ vm_ParameterAddressingModes/256
; vm_ParameterAddressingModesL equ vm_ParameterAddressingModes
	; endif	
	
;0b-PPPFFF-
;Prep: (tasks run before command)
prp_Nothing equ 0*16
prp_VM_GetAddress_Branch  equ 1*16
prp_VM_GetAddress equ 2*16
prp_VM_GetAddress_VM_GetFlagC  equ 3*16
prp_VM_GetAddress16 equ 4*16	
prp_VM_GetAddressPrep_ZPDest equ 5*16	;Patched for INC ZP (Dest=Param)
prp_VM_GetAddressPrep_ZPDest_GetFlagC equ 6*16
;Finishers: (tasks run after command)
fin_Nothing equ 0*2
fin_VM_PC_Store equ 1*2
fin_VM_PCINC equ 2*2
fin_VM_PCINC_FZ equ 3*2
fin_VM_PCINC_FZ_LD_IX_E equ 4*2
fin_VM_PCINC_FZ_LD_IX_DE equ 5*2
fin_VM_PCINC_LD_IX_E equ 6*2
fin_VM_PCINC_LD_IX_DE equ 7*2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Instruction Set

vm_NOP equ 0b00000000	;No-Operation
vm_RET equ 0b00000001	;Return from sub
vm_HLT equ 0b00000010	;Stop Processor
vm_SEC equ 0b00000011	;Set Carry

vm_PH0 equ 0b00000100
vm_PH2 equ 0b00000101
vm_PH4 equ 0b00000110
vm_PH6 equ 0b00000111

vm_PL0 equ 0b00001000
vm_PL2 equ 0b00001001
vm_PL4 equ 0b00001010
vm_PL6 equ 0b00001011

vm_PHF equ 0b00001100
vm_PLF equ 0b00001101

vm_BRA equ 0b00010000
vm_BSR equ 0b00010100
vm_BEQ equ 0b00011000
vm_BNE equ 0b00011100
vm_BCS equ 0b00100000
vm_BCC equ 0b00100100
vm_ADD equ 0b00101000
vm_SUB equ 0b00101100
vm_CMP equ 0b00110000
vm_MOV equ 0b00110100			;Move Param to Dest
vm_STO equ 0b00111000			;Store Dest To Param
vm_LEA equ 0b00111100			;Load Effective address
vm_NEG equ 0b01000000
vm_ROL equ 0b01000100			;Rotate with carry
vm_ROR equ 0b01001000
vm_ASL equ 0b01001100
vm_ASR equ 0b01010000
vm_LSR equ 0b01010100
vm_INC equ 0b01011000
vm_DEC equ 0b01011100
vm_AND equ 0b01100000
vm_ORR equ 0b01100100
vm_XOR equ 0b01101000
vm_TRP equ 0b01101100			;Trap #PARAM
vm_SYS equ 0b01110000			;Syscall #PARAM
vm_MOV16 equ 0b01110100
vm_INC16 equ 0b01111000
vm_DEC16 equ 0b01111100
vm_ADD16 equ 0b10000000
vm_SUB16 equ 0b10000100
vm_SWP16 equ 0b10001000			;Swap 2 16 bit values
vm_STO16 equ 0b10001100

vm_BRA16 equ 0b10010000			;Branch To 16 bit Relative offset PARAM
vm_BSR16 equ 0b10010100			;Branch To Sub 16 bit Relative offset PARAM
vm_TST   equ 0b10011000
vm_CMP16 equ 0b10011100

vm_CLR equ   0b10100000
vm_CLR16 equ 0b10100100
vm_TOR equ   0b10101000			;Test OR
vm_ADC equ   0b10101100	
vm_SBC equ    0b10110000	
;Reserved for future use!
;vm_CMD equ   0b10110100			;Command switch
;vm_ADR equ   0b10111000			;Address switch
;vm_CPU equ   0b10111100			;Cpu switch
vm_LastComamnd equ 0b10110100

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Addressing Modes Branch:
 
vm_b2B equ 0 	;Branch PC+2 
vm_bI8 equ 1	;Branch PC+Imm8 (Signed relative)
vm_bI6 equ 2	;Branch PC+Imm16 (Absolute addr)
vm_bR6 equ 3	;Branch R6/R7 (Absolute addr in R6/7)

;Addressing Modes Command:

vm_aAB equ 0	;AB Accumulator
vm_aIM equ 1	;Immediate
vm_aZP equ 2	;ZeroPage
vm_aBP equ 3	;ByteParam  %PARAM/DEST

;Addressing Modes Parameter:

;Syntax is z80 style eg:
;XOR A,B		A is destination B is parameter

vm_pR0 equ 0	;Param R0
vm_pR1 equ 1	;Param R1
vm_pR2 equ 2	;Param R2
vm_pR3 equ 3	;Param R3
vm_pR4 equ 4	;Param R4
;vm_pR5 equ 5	;Param R5 - Not available use zeropage
vm_pR6 equ 5	;Param R6
;vm_pR7 equ 7	;Param R7 - Not available - use zeropage
vm_PB2 equ 6 	;Indirect 16 bit pointer R2 (16 bit to anywhere) - Base+imm8 offset
vm_PB4 equ 7 	;Indirect 16 bit pointer R4 (16 bit to anywhere) - Base+imm8 offset
vm_PU2 equ 8 	;Indirect 16 bit pointer R2 (16 bit to anywhere) - PostInc
vm_PU6 equ 9 	;Indirect 16 bit pointer R6 (16 bit to anywhere) - PostInc
vm_PQ4 equ 10 	;Indirect 16 bit pointer R4 (16 bit to anywhere)
vm_PQ6 equ 11 	;Indirect 16 bit pointer R6 (16 bit to anywhere)
vm_pA6 equ 12	;Address 16
vm_pA8 equ 13	;Address 8 (ZeroPage)
vm_pI6 equ 14	;Immediate 16 - Source only
vm_pI8 equ 15	;Immediate 8 - Source only

vm_pRF equ 15	;Flags Reg - Dest only
vm_pQS equ 14	;Indirect 16 bit pointer SP - Dest Only

;vm_PP2 equ 8 	;Indirect 8 bit pointer R0 (8 bit to zeropage)
;vm_PP3 equ 9 	;Indirect 8 bit pointer R2 (8 bit to zeropage)

vm_Ppr equ 16	;Parameter 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Friendly names

Param_R0 equ vm_pR0*vm_Ppr
Param_R1 equ vm_pR1*vm_Ppr
Param_R2 equ vm_pR2*vm_Ppr
Param_R3 equ vm_pR3*vm_Ppr
Param_R4 equ vm_pR4*vm_Ppr
Param_R6 equ vm_pR6*vm_Ppr
Param_Imm8 equ vm_pI8*vm_Ppr
Param_Imm16 equ vm_pI6*vm_Ppr
Param_Addr8 equ vm_pA8*vm_Ppr
Param_ZeroPg equ vm_pA8*vm_Ppr
Param_Addr16 equ vm_pA6*vm_Ppr
Param_AtR4 equ vm_PQ4*vm_Ppr
Param_AtR6 equ vm_PQ6*vm_Ppr
Param_AtR2Inc equ vm_PU2*vm_Ppr
Param_AtR6Inc equ vm_PU6*vm_Ppr
Param_AtR2PlusImm8 equ vm_PB2*vm_Ppr
Param_AtR4PlusImm8 equ vm_PB4*vm_Ppr


Dest_R0 equ vm_pR0
Dest_R1 equ vm_pR1
Dest_R2 equ vm_pR2
Dest_R3 equ vm_pR3
Dest_R4 equ vm_pR4
Dest_R6 equ vm_pR6
Dest_Addr8 equ vm_pA8
Dest_ZeroPg equ vm_pA8
Dest_Addr16 equ vm_pA6
Dest_AtR4 equ vm_PQ4
Dest_AtR6 equ vm_PQ6
Dest_AtR2Inc equ vm_PU2
Dest_AtR6Inc equ vm_PU6
Dest_AtR2PlusImm8 equ vm_PB2
Dest_AtR4PlusImm8 equ vm_PB4
Dest_RF equ vm_pRF			;rF
Dest_AtSP equ vm_pQS			;rStackTop



BranchPlus2 equ vm_b2B				;Skip 2 bytes (equivalent of BRAi 2)
BranchImm8 equ vm_bI8
BranchImm16 equ vm_bI6
BranchR6 equ vm_bR6

;Addressing Modes Command:

ParamAB equ vm_aAB					;AK=Dest BC=Param
ParamImm8 equ vm_aIM				;Param= Immediate 8 bit (16 bit for 16 bit commands)
;ParamAddr8 equ vm_aZP ;ZeroPage
ParamZeroPg equ vm_aZP ;ZeroPage	;Param in zero page (Dest for INC/DEC)
ParamExtByt equ vm_aBP ;ByteParam  %PARAM/DEST - Advanced Addressing 16 options for SRC DEST

		


NOPb equ vm_NOP 	;No operation
RETb equ vm_RET 	;Return
RTSb equ vm_RET 	;Return
HLTb equ vm_HLT 	;Halt processor
SECb equ vm_SEC		;Set Carry
PH0b equ vm_PH0 	;Push R0+R1
PH2b equ vm_PH2 	;Push R2+R4
PH4b equ vm_PH4 	;Push R4+R5
PH6b equ vm_PH6 	;Push R6+R7
PL0b equ vm_PL0 	;Pull R0+R1
PL2b equ vm_PL2 	;Pull R2+R3
PL4b equ vm_PL4 	;Pull R4+R5
PL6b equ vm_PL6 	;Pull R6+R7
PHFb equ vm_PHF 	;Push F+FU
PLFb equ vm_PLF 	;Pull F+FU

;2 byte jump
BRA2 equ vm_BRA 	;EG db BRA2
BSR2 equ vm_BSR 
BEQ2 equ vm_BEQ 
BNE2 equ vm_BNE 
BCS2 equ vm_BCS 
BCC2 equ vm_BCC 

;immediate 8
BRAi equ vm_BRA+1	;EG DB BRAi,-32
BSRi equ vm_BSR+1
BEQi equ vm_BEQ+1
BNEi equ vm_BNE+1
BCSi equ vm_BCS+1
BCCi equ vm_BCC+1

;Immediate 16
BRAj equ vm_BRA+2	;EG DB Braj,$5000
BSRj equ vm_BSR+2
BEQj equ vm_BEQ+2
BNEj equ vm_BNE+2
BCSj equ vm_BCS+2
BCCj equ vm_BCC+2

;Immediate 16
JMPj equ vm_BRA+2	;EG DB JMPj,$5000
JSRj equ vm_BSR+2
JEQj equ vm_BEQ+2
JNEj equ vm_BNE+2
JCSj equ vm_BCS+2
JCCj equ vm_BCC+2


;R6
BRAh equ vm_BRA+3	;EG DB BRAh
BSRh equ vm_BSR+3
BEQh equ vm_BEQ+3
BNEh equ vm_BNE+3
BCSh equ vm_BCS+3
BCCh equ vm_BCC+3

;BC reg
ADDb equ vm_ADD 
SUBb equ vm_SUB 
CMPb equ vm_CMP 		;Sets flags like SUB
MOVb equ vm_MOV 		;Move Param to Dest
STOb equ vm_STO 		;Store Dest to address Param (opposite of MOV)
LEAb equ vm_LEA 		;Load Effective address to Dest
NEGb equ vm_NEG 
ROLb equ vm_ROL 		;Rotate with carry
RORb equ vm_ROR 
ASLb equ vm_ASL 
LSLb equ vm_ASL 
ASRb equ vm_ASR 
LSRb equ vm_LSR 
INCb equ vm_INC 
DECb equ vm_DEC 
ANDb equ vm_AND 
TSTb equ vm_TST 
ORRb equ vm_ORR 
XORb equ vm_XOR 
EORb equ vm_XOR 
TRPb equ vm_TRP 		;Execute Trap #param
SYSb equ vm_SYS 		;Execute Systemcall #param
CLRb equ vm_CLR
TORb equ vm_TOR
ADCb equ vm_ADC
SBCb equ vm_SBC

MOV16b equ vm_MOV16 	;Move Param to Dest
INC16b equ vm_INC16 
DEC16b equ vm_DEC16 
ADD16b equ vm_ADD16 
SUB16b equ vm_SUB16 	
SWP16b equ vm_SWP16 	;Swap 16 bit Dest and Param
STO16b equ vm_STO16 	;Store Dest to address Param (opposite of MOV16)
CMP16b equ vm_CMP16		;Sets flags like SUB
CLR16b equ vm_CLR16	
;Immediate 8/16
vADDi equ vm_ADD+1
SUBi equ vm_SUB+1 
CMPi equ vm_CMP+1
MOVi equ vm_MOV+1
;STOi equ vm_STO+1		;Commands don't make sense!
LEAi equ vm_LEA+1
;NEGi equ vm_NEG+1
;ROLi equ vm_ROL+1
;RORi equ vm_ROR+1
;ASLi equ vm_ASL+1
;ASRi equ vm_ASR+1
;LSRi equ vm_LSR+1
;INCi equ vm_INC+1		;Command doesn't make sense!
;DECi equ vm_DEC+1
vANDi equ vm_AND+1
TSTi equ vm_TST+1
ORRi equ vm_ORR+1
vXORi equ vm_XOR+1
EORi equ vm_XOR+1
TRPi equ vm_TRP+1
SYSi equ vm_SYS+1
ADCi equ vm_ADC+1
SBCi equ vm_SBC+1

MOV16i equ vm_MOV16+1
INC16i equ vm_INC16+1
DEC16i equ vm_DEC16+1
ADD16i equ vm_ADD16+1
SUB16i equ vm_SUB16+1
SWP16i equ vm_SWP16+1
STO16i equ vm_STO16+1
CMP16i equ vm_CMP16+1		;Sets flags like SUB

BRA16i equ vm_BRA16+1	;Branch to relative imm16
BSR16i equ vm_BSR16+1	;Branch to sub at relative imm16

;Zeropage
ADDz equ vm_ADD+2
SUBz equ vm_SUB+2 
CMPz equ vm_CMP+2
MOVz equ vm_MOV+2
STOz equ vm_STO+2
LEAz equ vm_LEA+2
NEGz equ vm_NEG+2
ROLz equ vm_ROL+2
RORz equ vm_ROR+2
ASLz equ vm_ASL+2
LSLz equ vm_ASL+2
ASRz equ vm_ASR+2
LSRz equ vm_LSR+2
INCz equ vm_INC+2
DECz equ vm_DEC+2
ANDz equ vm_AND+2
TSTz equ vm_TST+2
ORRz equ vm_ORR+2
XORz equ vm_XOR+2
EORz equ vm_XOR+2
TRPz equ vm_TRP+2
SYSz equ vm_SYS+2
CLRz equ vm_CLR+2
TORz equ vm_TOR+2
ADCz equ vm_ADC+2
SBCz equ vm_SBC+2


MOV16z equ vm_MOV16+2
INC16z equ vm_INC16+2
DEC16z equ vm_DEC16+2
ADD16z equ vm_ADD16+2
SUB16z equ vm_SUB16+2
SWP16z equ vm_SWP16+2
STO16z equ vm_STO16+2
CMP16z equ vm_CMP16+2		;Sets flags like SUB
CLR16z equ vm_CLR16+2
;BRA16z equ vm_BRA16+2		;Possible but not recommended!
;BSR16z equ vm_BSR16+2

;Extended parameter byte (one from Multiplexed Parameters)
ADDx equ vm_ADD+3
SUBx equ vm_SUB+3 
CMPx equ vm_CMP+3
MOVx equ vm_MOV+3
STOx equ vm_STO+3
LEAx equ vm_LEA+3
NEGx equ vm_NEG+3
ROLx equ vm_ROL+3
RORx equ vm_ROR+3
LSLx equ vm_ASL+3
ASLx equ vm_ASL+3
ASRx equ vm_ASR+3
LSRx equ vm_LSR+3
INCx equ vm_INC+3
DECx equ vm_DEC+3
ANDx equ vm_AND+3
TSTx equ vm_TST+3
ORRx equ vm_ORR+3
XORx equ vm_XOR+3
EORx equ vm_XOR+3
TRPx equ vm_TRP+3
SYSx equ vm_SYS+3
CLRx equ vm_CLR+3
TORx equ vm_TOR+3
ADCx equ vm_ADC+3
SBCx equ vm_SBC+3

MOV16x equ vm_MOV16+3
INC16x equ vm_INC16+3
DEC16x equ vm_DEC16+3
ADD16x equ vm_ADD16+3
SUB16x equ vm_SUB16+3
SWP16x equ vm_SWP16+3
STO16x equ vm_STO16+3
CMP16x equ vm_CMP16+3		;Sets flags like SUB
CLR16x equ vm_CLR16+3
;BRA16x equ vm_BRA16+3	;Possible but not recommended
;BSR16x equ vm_BSR16+3

;Multiplexed Parameters (Dest,Param)
;Eg dbbww MOV16x,Addr16_imm16,&4200,&6660
;Moves imm16 &6660 to Addr16 &4200

R0_R0 equ Dest_R0+Param_R0		;Dest Reg 0
R1_R0 equ Dest_R1+Param_R0		;Dest Reg 1
R2_R0 equ Dest_R2+Param_R0		;Dest Reg 2
R3_R0 equ Dest_R3+Param_R0		;Dest Reg 3
R4_R0 equ Dest_R4+Param_R0		;Dest Reg 4 (4+5 for 16 bit)
R6_R0 equ Dest_R6+Param_R0		;Dest Reg 6 (6+7 for 16 bit)
;Addr8_R0 equ Dest_Addr8+Param_R0		;Superflouous, same as below
ZeroPg_R0 equ Dest_ZeroPg+Param_R0		;Dest ZeroPage address 	
Addr16_R0 equ Dest_Addr16+Param_R0		;Dest absolute 16 bit address
AtR4_R0 equ Dest_AtR4+Param_R0			;Dest address in R4
AtR6_R0 equ Dest_AtR6+Param_R0			;Dest address in R6
AtR2Inc_R0 equ Dest_AtR2Inc+Param_R0	;Dest address in R2 - Inc R2+1
AtR6Inc_R0 equ Dest_AtR6Inc+Param_R0	;Dest address in R6 - Inc R2+1
AtR2PlIm_R0 equ Dest_AtR2PlusImm8+Param_R0 ;Dest address in R2+imm8
AtR4PlIm_R0 equ Dest_AtR4PlusImm8+Param_R0	;Dest address in R4+imm8
RF_R0 equ Dest_RF+Param_R0					;Dest Flags reg
AtSP_R0 equ Dest_AtSP+Param_R0				;Dest Top item on stack

R0_R1 equ Dest_R0+Param_R1
R1_R1 equ Dest_R1+Param_R1
R2_R1 equ Dest_R2+Param_R1
R3_R1 equ Dest_R3+Param_R1
R4_R1 equ Dest_R4+Param_R1
R6_R1 equ Dest_R6+Param_R1
;Addr8_R1 equ Dest_Addr8+Param_R1
ZeroPg_R1 equ Dest_ZeroPg+Param_R1
Addr16_R1 equ Dest_Addr16+Param_R1
AtR4_R1 equ Dest_AtR4+Param_R1
AtR6_R1 equ Dest_AtR6+Param_R1
AtR2Inc_R1 equ Dest_AtR2Inc+Param_R1
AtR6Inc_R1 equ Dest_AtR6Inc+Param_R1
AtR2PlIm_R1 equ Dest_AtR2PlusImm8+Param_R1
AtR4PlIm_R1 equ Dest_AtR4PlusImm8+Param_R1
RF_R1 equ Dest_RF+Param_R1
AtSP_R1 equ Dest_AtSP+Param_R1

R0_R2 equ Dest_R0+Param_R2
R1_R2 equ Dest_R1+Param_R2
R2_R2 equ Dest_R2+Param_R2
R3_R2 equ Dest_R3+Param_R2
R4_R2 equ Dest_R4+Param_R2
R6_R2 equ Dest_R6+Param_R2
;Addr8_R2 equ Dest_Addr8+Param_R2
ZeroPg_R2 equ Dest_ZeroPg+Param_R2
Addr16_R2 equ Dest_Addr16+Param_R2
AtR4_R2 equ Dest_AtR4+Param_R2
AtR6_R2 equ Dest_AtR6+Param_R2
AtR2Inc_R2 equ Dest_AtR2Inc+Param_R2
AtR6Inc_R2 equ Dest_AtR6Inc+Param_R2
AtR2PlIm_R2 equ Dest_AtR2PlusImm8+Param_R2
AtR4PlIm_R2 equ Dest_AtR4PlusImm8+Param_R2
RF_R2 equ Dest_RF+Param_R2
AtSP_R2 equ Dest_AtSP+Param_R2

R0_R3 equ Dest_R0+Param_R3
R1_R3 equ Dest_R1+Param_R3
R2_R3 equ Dest_R2+Param_R3
R3_R3 equ Dest_R3+Param_R3
R4_R3 equ Dest_R4+Param_R3
R6_R3 equ Dest_R6+Param_R3
;Addr8_R3 equ Dest_Addr8+Param_R3
ZeroPg_R3 equ Dest_ZeroPg+Param_R3
Addr16_R3 equ Dest_Addr16+Param_R3
AtR4_R3 equ Dest_AtR4+Param_R3
AtR6_R3 equ Dest_AtR6+Param_R3
AtR2Inc_R3 equ Dest_AtR2Inc+Param_R3
AtR6Inc_R3 equ Dest_AtR6Inc+Param_R3
AtR2PlIm_R3 equ Dest_AtR2PlusImm8+Param_R3
AtR4PlIm_R3 equ Dest_AtR4PlusImm8+Param_R3
RF_R3 equ Dest_RF+Param_R3
AtSP_R3 equ Dest_AtSP+Param_R3

R0_R4 equ Dest_R0+Param_R4
R1_R4 equ Dest_R1+Param_R4
R2_R4 equ Dest_R2+Param_R4
R3_R4 equ Dest_R3+Param_R4
R4_R4 equ Dest_R4+Param_R4
R6_R4 equ Dest_R6+Param_R4
;Addr8_R4 equ Dest_Addr8+Param_R4
ZeroPg_R4 equ Dest_ZeroPg+Param_R4
Addr16_R4 equ Dest_Addr16+Param_R4
AtR4_R4 equ Dest_AtR4+Param_R4
AtR6_R4 equ Dest_AtR6+Param_R4
AtR2Inc_R4 equ Dest_AtR2Inc+Param_R4
AtR6Inc_R4 equ Dest_AtR6Inc+Param_R4
AtR2PlIm_R4 equ Dest_AtR2PlusImm8+Param_R4
AtR4PlIm_R4 equ Dest_AtR4PlusImm8+Param_R4
RF_R4 equ Dest_RF+Param_R4
AtSP_R4 equ Dest_AtSP+Param_R4

R0_R6 equ Dest_R0+Param_R6
R1_R6 equ Dest_R1+Param_R6
R2_R6 equ Dest_R2+Param_R6
R3_R6 equ Dest_R3+Param_R6
R4_R6 equ Dest_R4+Param_R6
R6_R6 equ Dest_R6+Param_R6
;Addr8_R6 equ Dest_Addr8+Param_R6
ZeroPg_R6 equ Dest_ZeroPg+Param_R6
Addr16_R6 equ Dest_Addr16+Param_R6
AtR4_R6 equ Dest_AtR4+Param_R6
AtR6_R6 equ Dest_AtR6+Param_R6
AtR2Inc_R6 equ Dest_AtR2Inc+Param_R6
AtR6Inc_R6 equ Dest_AtR6Inc+Param_R6
AtR2PlIm_R6 equ Dest_AtR2PlusImm8+Param_R6
AtR4PlIm_R6 equ Dest_AtR4PlusImm8+Param_R6
RF_R6 equ Dest_RF+Param_R6
AtSP_R6 equ Dest_AtSP+Param_R6

R0_imm8 equ Dest_R0+Param_Imm8
R1_imm8 equ Dest_R1+Param_Imm8
R2_imm8 equ Dest_R2+Param_Imm8
R3_imm8 equ Dest_R3+Param_Imm8
R4_imm8 equ Dest_R4+Param_Imm8
R6_imm8 equ Dest_R6+Param_Imm8
;Addr8_imm8 equ Dest_Addr8+Param_Imm8
ZeroPg_imm8 equ Dest_ZeroPg+Param_Imm8
Addr16_imm8 equ Dest_Addr16+Param_Imm8
AtR4_imm8 equ Dest_AtR4+Param_Imm8
AtR6_imm8 equ Dest_AtR6+Param_Imm8
AtR2Inc_imm8 equ Dest_AtR2Inc+Param_Imm8
AtR6Inc_imm8 equ Dest_AtR6Inc+Param_Imm8
AtR2PlIm_imm8 equ Dest_AtR2PlusImm8+Param_Imm8
AtR4PlIm_imm8 equ Dest_AtR4PlusImm8+Param_Imm8
RF_imm8 equ Dest_RF+Param_Imm8
AtSP_imm8 equ Dest_AtSP+Param_Imm8

R0_imm16 equ Dest_R0+Param_Imm16
R1_imm16 equ Dest_R1+Param_Imm16
R2_imm16 equ Dest_R2+Param_Imm16
R3_imm16 equ Dest_R3+Param_Imm16
R4_imm16 equ Dest_R4+Param_Imm16
R6_imm16 equ Dest_R6+Param_Imm16
;Addr8_imm16 equ Dest_Addr8+Param_Imm16
ZeroPg_imm16 equ Dest_ZeroPg+Param_Imm16
Addr16_imm16 equ Dest_Addr16+Param_Imm16
AtR4_imm16 equ Dest_AtR4+Param_Imm16
AtR6_imm16 equ Dest_AtR6+Param_Imm16
AtR2Inc_imm16 equ Dest_AtR2Inc+Param_Imm16
AtR6Inc_imm16 equ Dest_AtR6Inc+Param_Imm16
AtR2PlIm_imm16 equ Dest_AtR2PlusImm8+Param_Imm16
AtR4PlIm_imm16 equ Dest_AtR4PlusImm8+Param_Imm16
RF_imm16 equ Dest_RF+Param_Imm16
AtSP_imm16 equ Dest_AtSP+Param_Imm16

; R0_Addr8 equ Dest_R0+Param_Addr8
; R1_Addr8 equ Dest_R1+Param_Addr8
; R2_Addr8 equ Dest_R2+Param_Addr8
; R3_Addr8 equ Dest_R3+Param_Addr8
; R4_Addr8 equ Dest_R4+Param_Addr8
; R6_Addr8 equ Dest_R6+Param_Addr8
; Addr8_Addr8 equ Dest_Addr8+Param_Addr8
; ZeroPg_Addr8 equ Dest_ZeroPg+Param_Addr8
; Addr16_Addr8 equ Dest_Addr16+Param_Addr8
; AtR4_Addr8 equ Dest_AtR4+Param_Addr8
; AtR6_Addr8 equ Dest_AtR6+Param_Addr8
; AtR2Inc_Addr8 equ Dest_AtR2Inc+Param_Addr8
; AtR6Inc_Addr8 equ Dest_AtR6Inc+Param_Addr8
; AtR2PlIm_Addr8 equ Dest_AtR2PlusImm8+Param_Addr8
; AtR4PlIm_Addr8 equ Dest_AtR4PlusImm8+Param_Addr8
; RF_Addr8 equ Dest_RF+Param_Addr8
; AtSP_Addr8 equ Dest_AtSP+Param_Addr8

R0_ZeroPg equ Dest_R0+Param_ZeroPg
R1_ZeroPg equ Dest_R1+Param_ZeroPg
R2_ZeroPg equ Dest_R2+Param_ZeroPg
R3_ZeroPg equ Dest_R3+Param_ZeroPg
R4_ZeroPg equ Dest_R4+Param_ZeroPg
R6_ZeroPg equ Dest_R6+Param_ZeroPg
;Addr8_ZeroPg equ Dest_Addr8+Param_ZeroPg
ZeroPg_ZeroPg equ Dest_ZeroPg+Param_ZeroPg
Addr16_ZeroPg equ Dest_Addr16+Param_ZeroPg
AtR4_ZeroPg equ Dest_AtR4+Param_ZeroPg
AtR6_ZeroPg equ Dest_AtR6+Param_ZeroPg
AtR2Inc_ZeroPg equ Dest_AtR2Inc+Param_ZeroPg
AtR6Inc_ZeroPg equ Dest_AtR6Inc+Param_ZeroPg
AtR2PlIm_ZeroPg equ Dest_AtR2PlusImm8+Param_ZeroPg
AtR4PlIm_ZeroPg equ Dest_AtR4PlusImm8+Param_ZeroPg
RF_ZeroPg equ Dest_RF+Param_ZeroPg
AtSP_ZeroPg equ Dest_AtSP+Param_ZeroPg

R0_Addr16 equ Dest_R0+Param_Addr16
R1_Addr16 equ Dest_R1+Param_Addr16
R2_Addr16 equ Dest_R2+Param_Addr16
R3_Addr16 equ Dest_R3+Param_Addr16
R4_Addr16 equ Dest_R4+Param_Addr16
R6_Addr16 equ Dest_R6+Param_Addr16
;Addr8_Addr16 equ Dest_Addr8+Param_Addr16
ZeroPg_Addr16 equ Dest_ZeroPg+Param_Addr16
Addr16_Addr16 equ Dest_Addr16+Param_Addr16
AtR4_Addr16 equ Dest_AtR4+Param_Addr16
AtR6_Addr16 equ Dest_AtR6+Param_Addr16
AtR2Inc_Addr16 equ Dest_AtR2Inc+Param_Addr16
AtR6Inc_Addr16 equ Dest_AtR6Inc+Param_Addr16
AtR2PlIm_Addr16 equ Dest_AtR2PlusImm8+Param_Addr16
AtR4PlIm_Addr16 equ Dest_AtR4PlusImm8+Param_Addr16
RF_Addr16 equ Dest_RF+Param_Addr16
AtSP_Addr16 equ Dest_AtSP+Param_Addr16

R0_AtR4 equ Dest_R0+Param_AtR4
R1_AtR4 equ Dest_R1+Param_AtR4
R2_AtR4 equ Dest_R2+Param_AtR4
R3_AtR4 equ Dest_R3+Param_AtR4
R4_AtR4 equ Dest_R4+Param_AtR4
R6_AtR4 equ Dest_R6+Param_AtR4
;Addr8_AtR4 equ Dest_Addr8+Param_AtR4
ZeroPg_AtR4 equ Dest_ZeroPg+Param_AtR4
Addr16_AtR4 equ Dest_Addr16+Param_AtR4
AtR4_AtR4 equ Dest_AtR4+Param_AtR4
AtR6_AtR4 equ Dest_AtR6+Param_AtR4
AtR2Inc_AtR4 equ Dest_AtR2Inc+Param_AtR4
AtR6Inc_AtR4 equ Dest_AtR6Inc+Param_AtR4
AtR2PlIm_AtR4 equ Dest_AtR2PlusImm8+Param_AtR4
AtR4PlIm_AtR4 equ Dest_AtR4PlusImm8+Param_AtR4
RF_AtR4 equ Dest_RF+Param_AtR4
AtSP_AtR4 equ Dest_AtSP+Param_AtR4

R0_AtR6 equ Dest_R0+Param_AtR6
R1_AtR6 equ Dest_R1+Param_AtR6
R2_AtR6 equ Dest_R2+Param_AtR6
R3_AtR6 equ Dest_R3+Param_AtR6
R4_AtR6 equ Dest_R4+Param_AtR6
R6_AtR6 equ Dest_R6+Param_AtR6
;Addr8_AtR6 equ Dest_Addr8+Param_AtR6
ZeroPg_AtR6 equ Dest_ZeroPg+Param_AtR6
Addr16_AtR6 equ Dest_Addr16+Param_AtR6
AtR4_AtR6 equ Dest_AtR4+Param_AtR6
AtR6_AtR6 equ Dest_AtR6+Param_AtR6
AtR2Inc_AtR6 equ Dest_AtR2Inc+Param_AtR6
AtR6Inc_AtR6 equ Dest_AtR6Inc+Param_AtR6
AtR2PlIm_AtR6 equ Dest_AtR2PlusImm8+Param_AtR6
AtR4PlIm_AtR6 equ Dest_AtR4PlusImm8+Param_AtR6
RF_AtR6 equ Dest_RF+Param_AtR6
AtSP_AtR6 equ Dest_AtSP+Param_AtR6

R0_AtR2Inc equ Dest_R0+Param_AtR2Inc
R1_AtR2Inc equ Dest_R1+Param_AtR2Inc
R2_AtR2Inc equ Dest_R2+Param_AtR2Inc
R3_AtR2Inc equ Dest_R3+Param_AtR2Inc
R4_AtR2Inc equ Dest_R4+Param_AtR2Inc
R6_AtR2Inc equ Dest_R6+Param_AtR2Inc
;Addr8_AtR2Inc equ Dest_Addr8+Param_AtR2Inc
ZeroPg_AtR2Inc equ Dest_ZeroPg+Param_AtR2Inc
Addr16_AtR2Inc equ Dest_Addr16+Param_AtR2Inc
AtR4_AtR2Inc equ Dest_AtR4+Param_AtR2Inc
AtR6_AtR2Inc equ Dest_AtR6+Param_AtR2Inc
AtR2Inc_AtR2Inc equ Dest_AtR2Inc+Param_AtR2Inc
AtR6Inc_AtR2Inc equ Dest_AtR6Inc+Param_AtR2Inc
AtR2PlIm_AtR2Inc equ Dest_AtR2PlusImm8+Param_AtR2Inc
AtR4PlIm_AtR2Inc equ Dest_AtR4PlusImm8+Param_AtR2Inc
RF_AtR2Inc equ Dest_RF+Param_AtR2Inc
AtSP_AtR2Inc equ Dest_AtSP+Param_AtR2Inc

R0_AtR6Inc equ Dest_R0+Param_AtR6Inc
R1_AtR6Inc equ Dest_R1+Param_AtR6Inc
R2_AtR6Inc equ Dest_R2+Param_AtR6Inc
R3_AtR6Inc equ Dest_R3+Param_AtR6Inc
R4_AtR6Inc equ Dest_R4+Param_AtR6Inc
R6_AtR6Inc equ Dest_R6+Param_AtR6Inc
;Addr8_AtR6Inc equ Dest_Addr8+Param_AtR6Inc
ZeroPg_AtR6Inc equ Dest_ZeroPg+Param_AtR6Inc
Addr16_AtR6Inc equ Dest_Addr16+Param_AtR6Inc
AtR4_AtR6Inc equ Dest_AtR4+Param_AtR6Inc
AtR6_AtR6Inc equ Dest_AtR6+Param_AtR6Inc
AtR2Inc_AtR6Inc equ Dest_AtR2Inc+Param_AtR6Inc
AtR6Inc_AtR6Inc equ Dest_AtR6Inc+Param_AtR6Inc
AtR2PlIm_AtR6Inc equ Dest_AtR2PlusImm8+Param_AtR6Inc
AtR4PlIm_AtR6Inc equ Dest_AtR4PlusImm8+Param_AtR6Inc
RF_AtR6Inc equ Dest_RF+Param_AtR6Inc
AtSP_AtR6Inc equ Dest_AtSP+Param_AtR6Inc

R0_AtR2PlIm equ Dest_R0+Param_AtR2PlusImm8
R1_AtR2PlIm equ Dest_R1+Param_AtR2PlusImm8
R2_AtR2PlIm equ Dest_R2+Param_AtR2PlusImm8
R3_AtR2PlIm equ Dest_R3+Param_AtR2PlusImm8
R4_AtR2PlIm equ Dest_R4+Param_AtR2PlusImm8
R6_AtR2PlIm equ Dest_R6+Param_AtR2PlusImm8
;Addr8_AtR2PlIm equ Dest_Addr8+Param_AtR2PlusImm8
ZeroPg_AtR2PlIm equ Dest_ZeroPg+Param_AtR2PlusImm8
Addr16_AtR2PlIm equ Dest_Addr16+Param_AtR2PlusImm8
AtR4_AtR2PlIm equ Dest_AtR4+Param_AtR2PlusImm8
AtR6_AtR2PlIm equ Dest_AtR6+Param_AtR2PlusImm8
AtR2Inc_AtR2PlIm equ Dest_AtR2Inc+Param_AtR2PlusImm8
AtR6Inc_AtR2PlIm equ Dest_AtR6Inc+Param_AtR2PlusImm8
AtR2PlIm_AtR2PlIm equ Dest_AtR2PlusImm8+Param_AtR2PlusImm8
AtR4PlIm_AtR2PlIm equ Dest_AtR4PlusImm8+Param_AtR2PlusImm8
RF_AtR2PlIm equ Dest_RF+Param_AtR2PlusImm8
AtSP_AtR2PlIm equ Dest_AtSP+Param_AtR2PlusImm8

R0_AtR4PlIm equ Dest_R0+Param_AtR4PlusImm8
R1_AtR4PlIm equ Dest_R1+Param_AtR4PlusImm8
R2_AtR4PlIm equ Dest_R2+Param_AtR4PlusImm8
R3_AtR4PlIm equ Dest_R3+Param_AtR4PlusImm8
R4_AtR4PlIm equ Dest_R4+Param_AtR4PlusImm8
R6_AtR4PlIm equ Dest_R6+Param_AtR4PlusImm8
;Addr8_AtR4PlIm equ Dest_Addr8+Param_AtR4PlusImm8
ZeroPg_AtR4PlIm equ Dest_ZeroPg+Param_AtR4PlusImm8
Addr16_AtR4PlIm equ Dest_Addr16+Param_AtR4PlusImm8
AtR4_AtR4PlIm equ Dest_AtR4+Param_AtR4PlusImm8
AtR6_AtR4PlIm equ Dest_AtR6+Param_AtR4PlusImm8
AtR2Inc_AtR4PlIm equ Dest_AtR2Inc+Param_AtR4PlusImm8
AtR6Inc_AtR4PlIm equ Dest_AtR6Inc+Param_AtR4PlusImm8
AtR2PlIm_AtR4PlIm equ Dest_AtR2PlusImm8+Param_AtR4PlusImm8
AtR4PlIm_AtR4PlIm equ Dest_AtR4PlusImm8+Param_AtR4PlusImm8
RF_AtR4PlIm equ Dest_RF+Param_AtR4PlusImm8
AtSP_AtR4PlIm equ Dest_AtSP+Param_AtR4PlusImm8






