;s0 r0  A				
;s1 r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4 r4  C
;s5 r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)

;t9/a0 r10	 (Was A0 / r10)
;t9/a1 r11	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag



;As these commands are likely to be time sensitive, we've overriden the register loads
;with our own minimal ones.	

MpBitmap_TileTints:
	.db 255,0,0,0
	
	.align 4
	
	
	
mpbitmap_GetScreenPosTile:	;S2=Xpos in tiles  S5=Ypos in tiles
	andi s5,s5,0xFF
	andi s2,s2,0xFF
	sll s5,s5,3			;Ypos - 8x8 Tiles to pixels
	sll s2,s2,3			;Xpos - 8x8 Tiles to pixels
	
	j mpbitmap_GetScreenPosTileb
	nop

	
mpbitmap_GetScreenPos:	;CS= offscreen / Result in R11
	andi s5,s5,0xFF		;Ypos
	andi s2,s2,0xFF		;Xpos
	
	andi s6,s6,0xFF		;R6(L) is top byte of Xpos
	sll s6,s6,8
	add s2,s2,s6
	
mpbitmap_GetScreenPosTileb:	
	la a1,0xA0100000+320*2*8*2	;Screen Base+2 lines
	move t0,s2			;Xpos
	sll t0,t0,1			;2 bytes per pixel
	add a1,a1,t0
	
	move t0,s5			;Ypos
	li t1,320*2			;Bytes per line+Char
	multu t1,t0
	mflo t1
	add a1,a1,t1
			
	la a0,N64_Palette	;Palette lookup
				
	jr ra				;Return
	nop


	
mpbitmap_setpixel:		;s6 s2 LD= Xpos    s5 = Ypos  s0=Color
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		jal mpbitmap_GetScreenPos ;Get VRAM address A1
		nop
		
		andi s0,s0,255
		sll s0,s0,1
		add a0,a0,s0	;A0=N64_Palette
		
		lh t0,0(a0)		;Get from Palette (%RRRRRGGGGGBBBBBB-)
		nop
		sh t0,0(a1)		;Write to screen
		nop
			
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop	
	
	
mpbitmap_getpixel:
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		jal mpbitmap_GetScreenPos	;Get VRAM address A1
		nop
		
		lhu t0,0(a1)	;Color from screen (%RRRRRGGGGGBBBBBB-)
		
		jal mpbitmap_getpixel_FindColor ;S0=Found Color /T0=Search Half
		nop
		
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop	
	
	
	
	


;Search for an entry in the palette
;		  T0=Search Half
;Returns: S0=Found Color
mpbitmap_getpixel_FindColor: 
	la a0,N64_Palette	;Source Palette
	li s0,0				;Tested color
	li t2,16			;Max color
	
mpbitmap_getpixel_FindColorAgain:		
	lhu t1,0(a0)		;Palette color (%RRRRRGGGGGBBBBBB-)
	nop
	beq t0,t1,mpbitmap_getpixel_Done	;Found color?
	nop
	
	addi s0,s0,1		;Color +1
	addi a0,a0,2		;Next Pallette address
	beq s0,t2,mpbitmap_getpixel_Done	;No Color match (>=16)
	nop
	j mpbitmap_getpixel_FindColorAgain
	nop

mpbitmap_getpixel_Done:		
	jr ra				;Return
	nop

	
	
;HL/S6 = Source Pat D/S2=Xpos (tiles) E/S5=Ypos (Tiles) S0=Bitplanes	
mpbitmap_settile:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		jal mpbitmap_GetScreenPosTile	;Calculate VRAM destination
		nop

		li t5,8				;Lines
mpbitmap_settileY:				
		move a2,a1			;Backup Vram Destination
	
		li t8,8				;Pixels
				
		la t1,MpBitmap_TileTints
		
		lbu s2,0(t1)		;Load default tints
		lbu s3,1(t1)		; (Used when source doesn't have enough
		lbu s4,2(t1)		;  bitplanes)
		li s1,0
		
		lbu s1,(s6)			;Get Bitplane 0
		addi s6,s6,1
		li t0,1				;More bitplanes?
		beq s0,t0,mpbitmap_settileX
		nop
		
		lbu s2,(s6)			;Get Bitplane 1
		addi s6,s6,1
		li t0,2				;More bitplanes?
		beq s0,t0,mpbitmap_settileX
		nop
		
		lbu s3,(s6)			;Get Bitplane 2
		addi s6,s6,1
		li t0,3				;More bitplanes?
		beq s0,t0,mpbitmap_settileX
		nop
		
		lbu s4,(s6)			;Get Bitplane 3
		addi s6,s6,1
	
mpbitmap_settileX:		
		li t0,0
		andi s7,s1,0x0080	;Get leftmost bit (bitplane 0)
		srl s7,s7,7
		or t0,t0,s7

		andi s7,s2,0x0080	;Get leftmost bit (bitplane 1)
		srl s7,s7,6
		or t0,t0,s7
		
		andi s7,s3,0x0080	;Get leftmost bit (bitplane 2)
		srl s7,s7,5
		or t0,t0,s7
		
		andi s7,s3,0x0080	;Get leftmost bit (bitplane 3)
		srl s7,s7,4
		or t0,t0,s7
		
		sll s1,s1,1			;Shift all bitplanes left 1 pixel
		sll s2,s2,1
		sll s3,s3,1
		sll s4,s4,1
		
		
		sll t0,t0,1			;2 bytes per palette
		add t0,t0,a0		;A0=N64_Palette
		
		lh t0,(t0)			;Get 2 bytes from palette
		nop
		
		sh t0,(a1)			;Write to screen
		addi a1,a1,2		;Across 1 pixel
		
		addi t8,t8,-1
		bne t8,zero,mpbitmap_settileX
		nop
		
		addi a1,a2,320*2	;Down a line
				
		addi t5,t5,-1
		bne t5,zero,mpbitmap_settileY
		nop
			

;You don't need these lines if you're not using ChibiVM	
		jal VM_SaveA6R10
		nop
		la t8,ReturnKey2
		lw t8,(t8)		;#$66660000
		
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	




;HL/S6 = Dest Pat D/S2=Xpos (tiles) E/S5=Ypos (Tiles) S0=Bitplanes

mpbitmap_gettile:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		move a3,s0		;Backup Vram Destination
	
		jal mpbitmap_GetScreenPosTile
		nop
		
		li t5,8			;Line count
mpbitmap_gettileY:				
		move a2,a1		;Backup VRAM destination
		
		li t9,8			;Pixel count
		
		li s1,0
		li s2,0
		li s3,0
		li s4,0
		
mpbitmap_gettileX:		
		lhu t0,(a1)		;Get a pixel (%RRRRRGGGGGBBBBBB-)
		addi a1,a1,2	;Across 1 pixel
		
		
		jal mpbitmap_getpixel_FindColor ;S0=Found Color /T0=Search Half
		nop
		
		sll s1,s1,1			;Shift all bitplanes left 1 bit
		sll s2,s2,1
		sll s3,s3,1
		sll s4,s4,1
				
		andi s7,s0,0x0001	;Bitplane 0
		or s1,s1,s7
		
		andi s7,s0,0x0002	;Bitplane 1
		srl s7,1
		or s2,s2,s7
		
		andi s7,s0,0x0004	;Bitplane 2
		srl s7,2
		or s3,s3,s7
					
		andi s7,s0,0x0008	;Bitplane 3
		srl s7,3
		or s4,s4,s7
					
		addi t9,t9,-1		;Xloop
		bne t9,zero,mpbitmap_gettileX
		nop
		
		
		sb s1,(s6)			;Store bitplane 0
		addi s6,s6,1
		li t0,1				;More bitplanes?
		beq a3,t0,mpbitmap_SetTileLineDone
		nop
		
		sb s2,(s6)			;Store bitplane 1
		addi s6,s6,1
		li t0,2				;More bitplanes?
		beq a3,t0,mpbitmap_SetTileLineDone
		nop
		
		sb s3,(s6)			;Store bitplane 2
		addi s6,s6,1
		li t0,3				;More bitplanes?
		beq a3,t0,mpbitmap_SetTileLineDone
		nop
		
		sb s4,(s6)			;Store bitplane 3
		addi s6,s6,1
		
mpbitmap_SetTileLineDone:	
		addi a1,a2,320*2	;Down a line
	
		addi t5,t5,-1
		bne t5,zero,mpbitmap_gettileY
		nop
				
		
;You don't need these lines if you're not using ChibiVM	
		jal VM_SaveA6R10
		nop
		la t8,ReturnKey2
		lw t8,(t8)		;#$66660000
		

	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	