;s0	r0  A				
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag
	

	.align 4
nativespriteactivebuffer:
	.fill 64				;Buffer of sprites drawn last time for XOR
	
	
nativespriteaddr:	.dw 0	;Base of pattern data


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_drawextra:
NativeSpr_Draw:		;S1,S4=XY in pairs of pixels	 S5=SpriteDef

	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		lw s7,(s5)		;Wid
		addi s5,s5,4
		lw t7,(s5)		;Hei
		addi s5,s5,4
		
		or s0,t7,s7
		beq zero,s0,nativespr_RTS
		nop
		
drawnativespry:
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s1,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s4,0(sp)			;Put the register onto the stack

			move a3,s7	

drawnativesprx:
			lw s0,(s5)
			li t0,0xFFFFFFFF
			beq s0,t0,drawnativeskipx
			nop
			
			addi s0,s1,-vscreenminx
			li t0,vscreenwid
			bgt s0,t0,drawnativeskipx
			nop
			
			move s1,s0			;Start Xpos in pairs of pixels
			
drawnativeokx:
			addi s0,s4,-vscreenminy

			li t0,vscreenhei-2
			bgt s0,t0,drawnativeskipx
			nop
			move s4,s0			;Start Ypos in Pairs of lines

drawnativeoky:
drawnativesprxfast:
			lw s0,(s5)			;Pattern Number
			li t0,0xFFFFFFFF
			beq s0,t0,drawnativeskipf
			nop
		
;Calculate VRAM Dest:

			la a1,0xA0100000+320*2*8*2	;Screen Base+2 lines
			move t0,s1		;Xpos
			sll t0,t0,2		;2 bytes per pixel, 2 pix per LU
			add a1,a1,t0
			
			move t0,s4		;Ypos
			sll t0,t0,1		;2 lines per LU
			li t1,320*2		;Bytes per line+Char
			multu t1,t0
			mflo t1
			add a1,a1,t1
			
;Calculate source tile:
		
			la a0,nativespriteaddr
			lw a0,(a0)		;Pattern Base
			sll s0,s0,7		;128 bytes per pattern
				
			add a0,a0,s0	;Source pattern addr
						
			move t4,a1		;Backup VRAM
						
						
;Transfer tile to screen:

			li t2,8			;Linecount
DrawSprite_NextLine:
			lw t0,(a0)		;Read 2 pixels from pattern
			lw t1,(a1)		;Read 2 pixels from screen
			addi a0,a0,4	;Source +4
			xor t0,t0,t1	;Xor them
			sw t0,(a1)		;Store Back to screen
			addi a1,a1,4	;Vram +4
			
			lw t0,(a0)		;Read 2 pixels from pattern
			lw t1,(a1)		;Read 2 pixels from screen
			addi a0,a0,4	;Source +4
			xor t0,t0,t1	;Xor them
			sw t0,(a1)		;Store Back to screen
			addi a1,a1,4	;Vram +4
			
			lw t0,(a0)		;Read 2 pixels from pattern
			lw t1,(a1)		;Read 2 pixels from screen
			addi a0,a0,4	;Source +4
			xor t0,t0,t1	;Xor them
			sw t0,(a1)		;Store Back to screen
			addi a1,a1,4	;Vram +4
			
			lw t0,(a0)		;Read 2 pixels from pattern
			lw t1,(a1)		;Read 2 pixels from screen
			addi a0,a0,4	;Source +4
			xor t0,t0,t1	;Xor them
			sw t0,(a1)		;Store Back to screen
			addi a1,a1,4	;Vram +4
			
			li t0,(320*2)-16	;Down a lines
			add a1,a1,t0
			
			addi t2,t2,-1
			bne t2,zero,DrawSprite_NextLine
			nop
			
			addi a1,t4,16		;Across screen (Vram)
			
			
			addi s1,s1,4		;Xpos++
			
drawnativeskipf:
			li t0,128			;At far right?
			bgt s1,t0,DrawNative_overRow
			nop
			
			addi s5,s5,4		;Move to the next sprite pattern
				
			addi a3,a3,-1
			bne a3,zero,drawnativesprxfast
			nop
			
			
drawnative_overrowb:
		lw s4,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
		lw s1,0(sp)			;Pop the register off the stack
		addi sp,sp,4		;Add 4 to the Stack pointer
	
		addi s4,s4,4		;Down one block
		addi t7,t7,-1
		bne t7,zero,drawnativespry
		nop	
			
nativespr_RTS:		
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	

drawnative_overrow:		;Handles tiles that are 'offscreen right'
drawnativeskipfb:
    addi s5,s5,4		;Skip a tile
	addi a3,a3,-1
	bne a3,zero,drawnativeskipfb
	nop
	
	b drawnative_overrowb
	nop
	
	
drawnativeskipx:			;Handles tiles that are 'offscreen left'
							; or emty
	addi s1,s1,4			;Across one block
	addi s5,s5,4			;Skip a tile
	addi a3,a3,-1
	bne a3,zero,drawnativesprx
	nop

	j drawnative_overrowb
	nop
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	