
MaxTileClearBorder:

	lui a0,0x1F80 			;IO_BASE 0x1F80xxxx

	;Fill color
	li a1,0x02FFCC00		;02BBGGRR
	
;Top
    sw a1,0x1810(a0)		;$02 - Fill Area 1- 0xBBGGRR - Background 
		
    li t0,0x00000000		;$02 - Fill Area 2-0xYYYYXXXX - Topleft
    sw t0,0x1810(a0)			;YYYYXXXX
		
    li t0,0x00060100		;$02 - Fill Area 3-0xHHHHWWWW - HeightWidth
	sw t0,0x1810(a0)			;HHHHWWWW  $EF x $137 = 239 x 319
			

;Bottom
    sw a1,0x1810(a0)		;$02 - Fill Area 1- 0xBBGGRR - Background 
		
    li t0,0x00BA0000		;$02 - Fill Area 2-0xYYYYXXXX - Topleft
    sw t0,0x1810(a0)			;YYYYXXXX
		
    li t0,0x00060100		;$02 - Fill Area 3-0xHHHHWWWW - HeightWidth
	sw t0,0x1810(a0)			;HHHHWWWW  $EF x $137 = 239 x 319

	la t6,MaxTileClearBorder_Vert
	
;Fill only works in 8 pixel blocks, so we have to use a CPU->GPU
;transfer for the left/right	
	
;Left
  
	li a1,0xA0000000	;A0=Send image to Framebuffer
	sw a1,0x1810(a0) 	;GP0 Cpmmand Port 0x1F801810

		
    li t0,0x00000000		;$02 - Fill Area 2-0xYYYYXXXX - Topleft
    sw t0,0x1810(a0)			;YYYYXXXX
		
    li t0,0x00C00006		;$02 - Fill Area 3-0xHHHHWWWW - HeightWidth
	sw t0,0x1810(a0)			;HHHHWWWW  $EF x $137 = 239 x 319
	
	jalr t6,t3
	nop
;Right
	sw a1,0x1810(a0) 	;GP0 Cpmmand Port 0x1F801810
		
    li t0,0x000000FA		;$02 - Fill Area 2-0xYYYYXXXX - Topleft
    sw t0,0x1810(a0)			;YYYYXXXX
		
    li t0,0x00C00006		;$02 - Fill Area 3-0xHHHHWWWW - HeightWidth
	sw t0,0x1810(a0)			;HHHHWWWW  $EF x $137 = 239 x 319

	jalr t6,t3
	nop
	
	jr ra				;Return
	nop
	

MaxTileClearBorder_Vert:	
	li t0,3*192
		;  %-BBBBBGGGGGRRRRR-BBBBBGGGGGRRRRR
	li t1,0b11111111010000001111111101000000
MaxTileClearBorder_VertAgain:		
	sw t1,0x1810(a0)
	
	addi t0,t0,-1
	bne t0,zero,MaxTileClearBorder_VertAgain
	nop
	
InitMaxTile:
	jr t3				;Return
	nop
	

MaxTileSelectVRAM:

		lui t4,0x1F80 	;IO_BASE
		
		;Byte 0: GPU Command
		li t3,0xA0000000	;A0=Send image to Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 1: XY Pos - 0xYYYYXXXX 
		sw s6,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00080008 	;8x8 Char
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
		
	jr t0
	nop
	

MaxTileGetScreenPos: ; d1=x d4=y (in pairs of pixels)
	andi s1,s1,0xFF
	andi s4,s4,0xFF
	
	

	;Byte 1: XY Pos - 0xYYYYXXXX 
	sll t1,s4,1			;LU to pixels
	sll s6,t1,16 		;0xYYYY----
	sll t1,s1,1			;LU to pixels
	addu s6,t1 			;0x----XXXX

		
	jr ra				;Return
	nop
	
	
;r5=Tilemap r4=TileOffset r6=Vram dest
			
drawtile:
	la t6,MaxTileSelectVRAM

	;btst #0,d0
	andi t0,s0,0b00000001
		bne t0,zero,drawtileadvanced
		nop

	sll s0,s0,1
	;asl.b #1,d0				;%NNNNXYP0 ... Update flag cleared (bit 0)
	sb s0,(s5)
	addi s5,s5,1
	;move.b d0,(a2)+
	
	
drawtilebasiconly:
	andi s0,s0,0b11110000
	;and.b #%11110000,d0		;%nnnn----
	
	lbu a0,(s5)
	addi s5,s5,1
	sll a0,a0,8
	or s0,s0,a0
	
	sll s0,s0, 3			;128 bytes per tile
	add s1,s0,s4				;NNNNNNNN nnnn----
	
	
	jalr t6,t0	;MaxTileSelectVRAM
	nop
	
	
	li s2,8

	move s3,s6
drawtilebasiconly_NextLine:	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,0x1810(t4)
	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,0x1810(t4)
	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,0x1810(t4)
	
	lw s0,(s1)		;2 pixel
	addi s1,s1,4
	sw s0,0x1810(t4)
	
	li t0,640-16
	
	add s6,s6,t0
	
	addi s2,s2,-1
	bne s2,zero,drawtilebasiconly_NextLine
	nop
	
	move s6,s3
	
	j tiledone
	nop
	
	
	
	

drawtileadvanced:

	andi s0,s0,0b00000110		;%-NNNNXYP
	beq s0,zero,drawtilecustom		;X,Y flip 0 = special prog
	nop
	
	lbu s0,(s5)
	nop
	andi s0,s0,0b11111110
	sb s0,(s5)
	
	
	;.ifdef tiletest_noflip	;for minimal testing
	;	j drawtilebasiconly
	;	nop
	;.endif
	
	andi s0,s0,0b11110000
	
	lbu a0,1(s5)
	nop
	sll a0,a0,8
	
	or s0,s0,a0
	
	sll s0,s0,3				;128 bytes per tile
	add s1,s0,s4				;NNNNNNNN nnnn----
	
	
	lb s0,(s5)
	addi s5,s5,2
	
	
	li s2,8				;Linecount
	move s3,s6
	
	andi t0,s0,0b00000100
	bne t0,zero,drawtileyflip
	nop
	
	jalr t6,t0	;MaxTileSelectVRAM
	nop
	
	addi s1,s1,14
	
drawtileXflip_NextLine:	


	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	
	sw t0,0x1810(t4)
	
	
	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	
	sw t0,0x1810(t4)
	
	
	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	
	sw t0,0x1810(t4)
	

	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	
	sw t0,0x1810(t4)
	
	addi s1,s1,16+16
	
	addi s2,s2,-1
	bne s2,zero,drawtileXflip_NextLine
	nop
	
	move s6,s3
	j tiledone
	nop

drawtileyflip:
	
	
	li s2,8
	
	andi t0,s0,0b00001000
	bne t0,zero,drawtilexyflip
	nop
	
	
	jalr t6,t0	;MaxTileSelectVRAM
	nop
	
	
	addi s1,s1,16*7
	
	move s3,s6
drawtileYflip_NextLine:	
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	addi s1,-32
		
	addi s2,s2,-1
	bne s2,zero,drawtileYflip_NextLine
	nop
	
	move s6,s3
	j tiledone
	nop
	
drawtileXYflip:	

	addi s1,s1,126

	jalr t6,t0	;MaxTileSelectVRAM
	nop
	
drawtileXYflip_NextLine:

	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	sw t0,0x1810(t4)
	

	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	sw t0,0x1810(t4)
	
	
	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	sw t0,0x1810(t4)
	
	
	lhu t0,(s1)		;1 pixel
	addi s1,s1,-2
	lhu t1,(s1)		;1 pixel
	addi s1,s1,-2
	
	sll t1,t1,16
	add t0,t1,t0
	sw t0,0x1810(t4)
	
	addi s2,s2,-1
	bne s2,zero,drawtileXYflip_NextLine
	nop
	
	j tiledone
	nop
	

	
drawtileempty:
	lbu s0,-1(s5)	;255=empty <255=tilenum
	
	li t0,255
	bne t0,s0,drawtiletransp
	nop
	j tiledone
	nop
	
drawtiletransp:		;;;;;;;;;;;;;;;;;;transparent

	sll s1,s1,7
	add s1,s1,s4
	
	li s2,8		;H
		
	;li t0,0xFFFEFFFE	;Ensure bottom (unused) bit is ignored	
		
	;move s3,s6
	
	
		lui t4,0x1F80 	;IO_BASE
;Get Buffer of current screen data
		;Byte 0: GPU Command
		li t3,0xC0000000	;C0=Get image from Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 1: XY Pos - 0xYYYYXXXX 
		sw s6,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

		;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00080008 	;8x8 pattern
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
	
	
		la a1,MaxTile_PSXbuffer
	
		li t2,(8*8/2)	 	;Bytes to get (8x8 - 2 pixels per byte, but 2 pixels per send)
		
		;Byte 3+: Pixel Data 0x22221111
drawtileTransp_GetDataFromScreen:
		lw t1,0x1810(t4) 	;Get 2 pixels from screen
		nop
		sw t1,(a1)			;Store in buffer
		
		
		addiu a1,4  			;Move to next word
		addiu a0,4  			;Move to next word
		
		subiu t2,1 				;Decrease loop counter (Delay Slot)
		bnez t2,drawtileTransp_GetDataFromScreen
		nop	

	
	
		la a0,MaxTile_PSXbuffer
		
		
		jalr t6,t0	;MaxTileSelectVRAM
		nop
		li t3,0x7FFF7FFF	;Ensure bottom (unused) bit is ignored	
		
drawtileTransp_NextLine:	
		lw t1,(a0)		;Buffer
		lw t2,(s1)		;Pattern2 pixels
		addi s1,s1,4
		addi a0,a0,4
		and t2,t2,t3
		beq t2,zero,drawtileTransp_skip1
		nop
		move t1,t2		;Use Pattern pixel
drawtileTransp_skip1:
		sw t1,0x1810(t4)
		
		lw t1,(a0)		;Buffer
		lw t2,(s1)		;Pattern2 pixels
		addi s1,s1,4
		addi a0,a0,4
		and t2,t2,t3
		beq t2,zero,drawtileTransp_skip2
		nop
		move t1,t2		;Use Pattern pixel
drawtileTransp_skip2:
		sw t1,0x1810(t4)	
		
		
			lw t1,(a0)		;Buffer
		lw t2,(s1)		;Pattern2 pixels
		addi s1,s1,4
		addi a0,a0,4
		and t2,t2,t3
		beq t2,zero,drawtileTransp_skip3
		nop
		move t1,t2		;Use Pattern pixel
drawtileTransp_skip3:
		sw t1,0x1810(t4)
		
			lw t1,(a0)		;Buffer
		lw t2,(s1)		;Pattern2 pixels
		addi s1,s1,4
		addi a0,a0,4
		and t2,t2,t3
		beq t2,zero,drawtileTransp_skip4
		nop
		move t1,t2		;Use Pattern pixel
drawtileTransp_skip4:
		sw t1,0x1810(t4)
		
	 addi s2,s2,-1
	 bne s2,zero,drawtileTransp_NextLine
	 nop
	; move s6,s3
	
	j tiledone
	nop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

drawtilecustom:
	
	
	lbu s0,(s5)
	nop
	andi s0,s0,0b11111110	;NN------
	sb s0,(s5)

	;move.b (a2),d0			
	;and.b #%11111110,d0
	;move.b d0,(a2)
	
	sll s0,s0,2
	li t0,0b0000001100000000
	and s1,s0,t0
	lbu s0,1(s5)
	nop
	or s1,s1,s0
	
	;lsl.l #2,d0
	;and.l #%0000001100000000,d0
	;move.l d0,D2

	lbu s0,(s5)
	
	addi s5,s5,2
	
	andi s0,s0,0b00110000	;cmd bits
	beq s0,zero,drawtilefill
	nop
	
	li t0,0b00110000
	beq s0,t0,drawtileempty
	nop
	
drawtiledouble:		
	sll s1,s1,6		;pattern *64
	add s1,s1,s4

	li s2,4
	
	jalr t6,t0	;MaxTileSelectVRAM
	nop
	
drawtiledoubleAgain:		
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	addi s1,s1,-16
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	lw t0,(s1)		;2 pixels
	addi s1,s1,4
	sw t0,0x1810(t4)
	
	addi s2,s2,-1
	bne s2,zero,drawtiledoubleAgain
	nop
	
	
	j tiledone
	nop

drawtilefill:
	la s0,N64_MaxTile_SolidFills
	sll s1,2
	add s1,s1,s0
	lhu t0,(s1)
	sll s0,t0,16
	or s0,s0,t0		;2 pixels

	li s1,8
	
	
	jalr t6,t0	;MaxTileSelectVRAM
	nop
	
	
drawtileFill_NextLine:	
	sw s0,0x1810(t4)
	sw s0,0x1810(t4)
	sw s0,0x1810(t4)
	sw s0,0x1810(t4)
	
	
	li t0,640
	add s6,s6,t0
	
	
	addi s1,s1,-1
	bne s1,zero,drawtileFill_NextLine
	nop
	
	j tiledone	
	nop

MaxTile_PSXbuffer:
	.fill 128
	
	.align 4