;s0 r0  A				
;s1 r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4 r4  C
;s5 r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)

;t9/a0 r10	 (Was A0 / r10)
;t9/a1 r11	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag



;As these commands are likely to be time sensitive, we've overriden the register loads
;with our own minimal ones.	

MpBitmap_TileTints:
	.db 255,0,0,0
	
	.align 4


	
	
;Set a screen pixel

;s6 s2 LD= Xpos    s5 = Ypos  s0=Color	
mpbitmap_setpixel:		
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		andi s5,s5,0xFF		;Ypos
		andi s2,s2,0xFF		;Xpos
		andi s6,s6,0xFF		;R6(L) is top byte of Xpos
		sll s6,s6,8
		add s2,s2,s6		
			
		lui t4,0x1F80 		;IO_BASE
;Byte 0: GPU Command
		li t3,0xA0000000	;A0=Send image to Framebuffer
		sw t3,0x1810(t4) 	;GP0 Command Port 0x1F801810

;Byte 1: XY Pos - 0xYYYYXXXX 
		sll t3,s5,16 		;0xYYYY----
		addu t3,s2 			;0x----XXXX
		sw t3,0x1810(t4) 	;GP0 Command Port 0x1F801810

;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00010001 	
		sw t3,0x1810(t4) 	;GP0 Command Port 0x1F801810
	
		la a0,PSX_Palette	
		andi s0,s0,255
		
		sll s0,s0,1			;2 bytes per color (%-BBBBBGGGGGRRRRR)
		add a0,a0,s0
		lhu t0,0(a0)		;get from Palette
		nop
		
		sw t0,0x1810(t4) 	;Store the color into VRAM
		
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop	
	
	
;Get a pixel from the screen
;s6 s2 LD= Xpos    s5 = Ypos 
mpbitmap_getpixel:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		andi s5,s5,0xFF		;Ypos
		andi s2,s2,0xFF		;Xpos
		andi s6,s6,0xFF		;R6(L) is top byte of Xpos
		sll s6,s6,8
		add s2,s2,s6
				
		lui t4,0x1F80 		;IO_BASE
;Byte 0: GPU Command
		li t3,0xC0000000	;C0=Get image from Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

;Byte 1: XY Pos - 0xYYYYXXXX 
		sll t3,s5,16 		;0xYYYY----
		addu t3,s2 			;0x----XXXX
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00010001 	;
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
	
		lw t0,0x1810(t4) 	;Read the pixel from the screen
		
		li t1,0xFFFF
		and t0,t0,t1		;Ensure we didn't get any extra data
		
		jal mpbitmap_getpixel_FindColor ;S0=Found Color /T0=Search Half
		nop
			
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop	
	

;Search for an entry in the palette
;		  T0=Search Half
;Returns: S0=Found Color
mpbitmap_getpixel_FindColor: 
	la a0,PSX_Palette	;Source Palette
	li s0,0				;Tested color
	li t2,16			;Max color
	
mpbitmap_getpixel_FindColorAgain:		
	lhu t1,0(a0)		;Palette color (%-BBBBBGGGGGRRRRR)
	nop
	beq t0,t1,mpbitmap_getpixel_Done	;Found color?
	nop
	
	addi s0,s0,1		;Color +1
	addi a0,a0,2		;Next Pallette address
	beq s0,t2,mpbitmap_getpixel_Done	;No Color match (>=16)
	nop
	j mpbitmap_getpixel_FindColorAgain
	nop

mpbitmap_getpixel_Done:		
	jr ra				;Return
	nop

	

	
;Set an 8x8 block on the screen in bitplane format 
; (Up to 4 bitplanes)
	
;HL/s6 = Source Pat D/s2=Xpos (tiles) E/s5=Ypos (Tiles) s0=Bitplanes	
	
mpbitmap_settile:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		la a0,PSX_Palette	
		
		andi s5,s5,0xFF
		andi s2,s2,0xFF
		sll s5,s5,3			;Ypos - 8x8 Tiles to pixels
		sll s2,s2,3			;Xpos - 8x8 Tiles to pixels
		
		lui t4,0x1F80 	;IO_BASE
		
;Byte 0: GPU Command
		li t3,0xA0000000	;A0=Send image to Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

;Byte 1: XY Pos - 0xYYYYXXXX 
		sll t3,s5,16 		;0xYYYY----
		addu t3,s2 			;0x----XXXX
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00080008 	;8x8 Char
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
			
		li t5,8				;Lines
mpbitmap_settileY:				
		move a2,a1
		li t8,8				;Pixels
		
		
		la t1,MpBitmap_TileTints
		
		lbu s2,0(t1)		;Load default tints
		lbu s3,1(t1)		; (Used when source doesn't have enough
		lbu s4,2(t1)		;  bitplanes)
		li s1,0
		
		lbu s1,(s6)			;Get Bitplane 0
		addi s6,s6,1
		li t0,1				;More bitplanes?
		beq s0,t0,mpbitmap_settileX
		nop
		
		lbu s2,(s6)			;Get Bitplane 1
		addi s6,s6,1
		li t0,2				;More bitplanes?
		beq s0,t0,mpbitmap_settileX
		nop
		
		lbu s3,(s6)			;Get Bitplane 2
		addi s6,s6,1
		li t0,3				;More bitplanes?
		beq s0,t0,mpbitmap_settileX
		nop
		
		lbu s4,(s6)			;Get Bitplane 3
		addi s6,s6,1
	
mpbitmap_settileX:		
		li t0,0
		andi s7,s1,0x0080	;Get leftmost bit (bitplane 0)
		srl s7,s7,7
		or t0,t0,s7

		andi s7,s2,0x0080	;Get leftmost bit (bitplane 1)
		srl s7,s7,6
		or t0,t0,s7
		
		andi s7,s3,0x0080	;Get leftmost bit (bitplane 2)
		srl s7,s7,5
		or t0,t0,s7
		
		andi s7,s3,0x0080	;Get leftmost bit (bitplane 3)
		srl s7,s7,4
		or t0,t0,s7
		
		sll s1,s1,1			;Shift all bitplanes left 1 pixel
		sll s2,s2,1
		sll s3,s3,1
		sll s4,s4,1
		
		
		sll t0,t0,1			;2 bytes per palette
		add t0,t0,a0		;A0=PSX_Palette
		
		lhu t0,(t0)			;Get 2 bytes from the palette
		nop
		sll t0,t0,16	
		add a3,a3,t0		;Add this pixel to 32 bit word
		
		
		andi t0,t8,1		;Have we got 2 pixels?
		beq t0,zero,mpbitmap_settile_OddPixel
		nop
		
		sw a3,0x1810(t4)	;Write 2 pixels
		
mpbitmap_settile_OddPixel:		
		srl a3,a3,16		;Shift the 16 bit color to the right
							;(For odd pixels)
		addi t8,t8,-1
		bne t8,zero,mpbitmap_settileX
		nop
			
		addi t5,t5,-1
		bne t5,zero,mpbitmap_settileY
		nop
		
;You don't need these lines if you're not using ChibiVM	
		jal VM_SaveA6R10
		nop
		la t8,ReturnKey2
		lw t8,(t8)		;#$66660000
	
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
		



;Get an 8x8 block from the screen in bitplane format 
; (Up to 4 bitplanes)

;HL/S6 = Dest Pat D/S2=Xpos (tiles) E/S5=Ypos (Tiles) S0=Bitplanes

mpbitmap_gettile:	
	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		move a3,s0		;Bitplane count
		
		andi s5,s5,0xFF
		andi s2,s2,0xFF
		sll s5,s5,3			;Ypos - 8x8 Tiles to pixels 
		sll s2,s2,3			;Xpos - 8x8 Tiles to pixels 
		
		lui t4,0x1F80 	;IO_BASE
		
;Byte 0: GPU Command
		li t3,0xC0000000	;C0=Get image from Framebuffer
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

;Byte 1: XY Pos - 0xYYYYXXXX 
		sll t3,s5,16 		;0xYYYY----
		addu t3,s2 			;0x----XXXX
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

;Byte 2: Width/Height - 0xHHHHWWWW
		li t3,0x00080008 	;8x8 Char
		sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
	
		li t5,8				;Line count
mpbitmap_gettileY:				
		move a2,a1
		li t9,8				;Pixel count
		
		li s1,0
		li s2,0
		li s3,0
		li s4,0
		
mpbitmap_gettileX:		
		andi t0,t9,1		;Have we read 2 pixels?
		bne t0,zero,mpbitmap_gettile_OddPixel  ;Don't read if 1
		nop									   ; pixel left
		
		lw a2,0x1810(t4)	;Get 2 pixels
		nop
mpbitmap_gettile_OddPixel:		
		li t0,0xFFFF
		and t0,t0,a2		;Get this pixel
		
		srl a2,a2,16		;Color for next time
		
		jal mpbitmap_getpixel_FindColor ;S0=Found Color /T0=Search Half
		nop
		
		sll s1,s1,1			;Shift all bitplanes left 1 bit
		sll s2,s2,1
		sll s3,s3,1
		sll s4,s4,1
				
		andi s7,s0,0x0001	;Bitplane 0
		or s1,s1,s7
		
		andi s7,s0,0x0002	;Bitplane 1
		srl s7,1
		or s2,s2,s7
		
		andi s7,s0,0x0004	;Bitplane 2
		srl s7,2
		or s3,s3,s7
					
		andi s7,s0,0x0008	;Bitplane 3
		srl s7,3
		or s4,s4,s7
					
		addi t9,t9,-1		;Xloop
		bne t9,zero,mpbitmap_gettileX
		nop
		
		
		sb s1,(s6)			;Store bitplane 0
		addi s6,s6,1
		li t0,1				;More bitplanes?
		beq a3,t0,mpbitmap_SetTileLineDone
		nop
		
		sb s2,(s6)			;Store bitplane 1
		addi s6,s6,1
		li t0,2				;More bitplanes?
		beq a3,t0,mpbitmap_SetTileLineDone
		nop
		
		sb s3,(s6)			;Store bitplane 2
		addi s6,s6,1
		li t0,3				;More bitplanes?
		beq a3,t0,mpbitmap_SetTileLineDone
		nop
		
		sb s4,(s6)			;Store bitplane 3
		addi s6,s6,1
		
mpbitmap_SetTileLineDone:		
		addi t5,t5,-1
		bne t5,zero,mpbitmap_gettileY
		nop

;You don't need these lines if you're not using ChibiVM
		jal VM_SaveA6R10	;Save results to ChibiVM
		nop
		la t8,ReturnKey2
		lw t8,(t8)		;#$66660000 - For ChibiVM
		
	lw ra,0(sp)		;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	
	