;s0	r0  A				
;s1	r1  B BC 
;s2 r2  D DE
;s3 r3  H HL
;s4	r4  C
;s5	r5  E
;s6 r6  L
;s7 r7  IX  (Was A5)

;t7 r8  IY  (Was A6) 
;t8 r9	 (Was D7)
;t9 r10	 (Was A0 / r10)

;v0=zero flag
;v1=carry flag

	.align 4
nativespriteactivebuffer:
	.fill 64					;Buffer of sprites drawn last time for XOR

NativeSprite_XORbuffer:			;We have to transfer an 8x8 block FROM
	.fill 128					; vram to here for the XOR effect
		
nativespriteaddr:	.dw 0		;Base of pattern data

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nativespr_drawextra:
NativeSpr_Draw:	;S1,S4=XY in pairs of pixels S5=SpriteDef			 S0=HspriteNum

	addi sp,sp,-4		;Subtract 4 from Stack pointer
	sw ra,0(sp)			;Put the register onto the stack

		lw s7,(s5)		;Wid
		addi s5,s5,4
		lw t7,(s5)		;Hei
		addi s5,s5,4

		or s0,t7,s7
		beq zero,s0,nativespr_RTS
		nop

drawnativespry:
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s1,0(sp)			;Put the register onto the stack
		addi sp,sp,-4		;Subtract 4 from Stack pointer
		sw s4,0(sp)			;Put the register onto the stack

			move a3,s7		;Width in tiles

drawnativesprx:
			lw s0,(s5)
			li t0,0xFFFFFFFF
			beq s0,t0,drawnativeskipx
			nop
			
			addi s0,s1,-vscreenminx
			li t0,vscreenwid
			bgt s0,t0,drawnativeskipx
			nop
			
			move s1,s0		;Start Xpos in pairs of pixels
			
drawnativeokx:
			addi s0,s4,-vscreenminy

			li t0,vscreenhei-2
			bgt s0,t0,drawnativeskipx
			nop
			move s4,s0		;Start Ypos in Pairs of lines
drawnativeoky:

drawnativesprxfast:
			
			lw s0,(s5)			;Pattern Number
			li t0,0xFFFFFFFF
			beq s0,t0,drawnativeskipf
			nop
		
;Calculate source pattern
			la a0,nativespriteaddr
			lw a0,(a0)		;Pattern Base
			sll s0,s0,7		;128 bytes per pattern
				
			add a0,a0,s0	;Source pattern addr
			
			lui t4,0x1F80 	;IO_BASE
			
			
;Get Buffer of current screen data
			;Byte 0: GPU Command
			li t3,0xC0000000	;C0=Get image from Framebuffer
			sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

			;Byte 1: XY Pos - 0xYYYYXXXX 
			sll t0,s4,1
			sll t3,t0,16 		;0xYYYY----
			sll t0,s1,1
			addu t3,t0 			;0x----XXXX
			sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

			;Byte 2: Width/Height - 0xHHHHWWWW
			li t3,0x00080008 	;8x8 pattern
			sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
		
;Draw the tile into the buffer
			la a1,NativeSprite_XORbuffer
		
			li t2,(8*8/2)	 	;Bytes to read (8x8 - 2 pixels per byte,
								;	 but 2 pixels per read)
								
			;Byte 3+: Pixel Data 0x22221111
GetSpriteDatab:
			lw t0,(a0) 			;Get 2 pixels from pattern
			lw t1,0x1810(t4) 	;Get 2 pixels from screen
			nop
			xor t0,t0,t1		;XOR them
			sw t0,(a1)			;Store in buffer
			
			addiu a1,4  			;Move to next word
			addiu a0,4  			;Move to next word
			
			subiu t2,1 				;Decrease loop counter (Delay Slot)
			bnez t2,GetSpriteDatab
			nop	
		
;Send Buffer back to screen

			;Byte 0: GPU Command
			li t3,0xA0000000	;A0=Send image to Framebuffer
			sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

			;Byte 1: XY Pos - 0xYYYYXXXX 
			sll t0,s4,1
			sll t3,t0,16 		;0xYYYY----
			sll t0,s1,1
			addu t3,t0 			;0x----XXXX
			sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810

			;Byte 2: Width/Height - 0xHHHHWWWW
			li t3,0x00080008 	;8x8 pattern
			sw t3,0x1810(t4) 	;GP0 Cpmmand Port 0x1F801810
			
		
			la a1,NativeSprite_XORbuffer
		
			li t1,(8*8/2)	 	;Bytes to send (8x8 - 2 pixels per
								;  byte, but 2 pixels per send)
		;Byte 3+: Pixel Data 0x22221111
SendSpriteData:
			lw t2,0(a1) 			;Get 2 pixels from buffer
			addiu a1,4  			;Move to next word
			sw t2,0x1810(t4) 		;send pixel Data - 0x22221111
									; Pixel 1 and 2 data
			
			subiu t1,1 				;Decrease loop counter (Delay Slot)
			bnez t1,SendSpriteData 
			nop	

			
			addi s1,s1,4	;Xpos++
			
drawnativeskipf:

			li t0,128		;At far right?
			bgt s1,t0,DrawNative_overRow
			nop
			
			addi s5,s5,4	;Move to the next sprite pattern
				
			addi a3,a3,-1
			bne a3,zero,drawnativesprxfast
			nop
						
drawnative_overrowb:
		lw s4,0(sp)		;Pop the register off the stack
		addi sp,sp,4	;Add 4 to the Stack pointer
		lw s1,0(sp)		;Pop the register off the stack
		addi sp,sp,4	;Add 4 to the Stack pointer
	
		addi s4,s4,4	;Down one block
		addi t7,t7,-1
		bne t7,zero,drawnativespry
		nop	
			
nativespr_RTS:		
	lw ra,0(sp)			;Pop the register off the stack
	addi sp,sp,4		;Add 4 to the Stack pointer
	jr ra				;Return
	nop
	

drawnative_overrow:		;Handles tiles that are 'offscreen right'
drawnativeskipfb:
    addi s5,s5,4		;Skip a tile
	addi a3,a3,-1
	bne a3,zero,drawnativeskipfb
	nop
	
	b drawnative_overrowb
	nop
	
	
drawnativeskipx:			;Handles tiles that are 'offscreen left'
							; or emty
	addi s1,s1,4			;Across one block
	addi s5,s5,4			;Skip a tile
	addi a3,a3,-1
	bne a3,zero,drawnativesprx
	nop

	j drawnative_overrowb
	nop
	

	